/**
 * 界面程序主入口，保存了其它js需要的公共全局变量和函数。
 * 
 * @author mdhuang 2013-3-22
 */

// 是否开启动画
var enableAnimation = false;

// 是否正在换肤
var isChangingSkin = false;

// 无网络时的view，在不点击气泡操作时，用户设置网络然后返回操作成功时使用
var errorView = null;

// var editQuestionView = null;//碧昂量定义一直questionView.js中

var answerViewWithShare = null;
// /首页面列表
var focusListView = null;
var needFold = false;

var smsSendView = null;
// 复制弹出框
var float_layer = null;
// 当前添加的View，特指那些可以被清除的View。由java函数调用。
var currentCanDeleteView = null;

//
var driverQueryView = null;

// 滚动过剧检测器
var moveOverCheck = new checkMoveOver();

/** ******************初始化工作************************** */
// head节点
var head = document.getElementsByTagName('head').item(0);

// 最大的一张图片是否加载完毕
var biggest_img_load_finish = false;

// 获取屏幕分辨率
try {
	var resultDevice = ifly_getDeviceInfo();
	var deviceWidth = resultDevice.screenWidth;
} catch (e) {
	deviceWidth = 480;
}

// 获取皮肤包路径
var skinPath = ifly_getCurrentSkinPath();
if (!skinPath) {
	skinPath = "../skin/theme_new/";
}

console.log("deviceWidth is :" + deviceWidth + " ,skinPath is " + skinPath);

// 适配比例，least文件解析时需要
var scale = deviceWidth / 320;

// 版本标识，用来区分灵犀还是语点。默认值为true，标识灵犀
var cmcc_flag = true;
cmcc_flag = ifly_getVersionFlag();

// 加载资源
function loadResource() {
	var dimenJs = createScriptElement('dimenJs');
	var preLeast = createLeastElement('preLeast');
	var leastJs = createScriptElement('leastJs');
	var imageJs = createScriptElement('imageJs');

	dimenJs.src = skinPath + "dialogModeRes/dimen.js";
	preLeast.href = skinPath + "dialogModeRes/pre.least";
	leastJs.src = skinPath + "dialogModeRes/least.min.js";
	imageJs.src = skinPath + "dialogModeRes/image.js";

	head.appendChild(dimenJs);
	head.appendChild(preLeast);
	head.appendChild(leastJs);
	head.appendChild(imageJs);
}

loadResource();

function createCssElement(id) {
	var css = document.createElement('link');
	css.id = id;
	css.rel = 'stylesheet';
	css.type = 'text/css';
	return css;
}

function createLeastElement(id) {
	var css = document.createElement('link');
	css.id = id;
	css.rel = 'stylesheet/least';
	css.type = 'text/css';
	return css;
}

function createScriptElement(id) {
	var script = document.createElement('script');
	script.id = id;
	script.type = "text/javascript";
	return script;
}

// 皮肤切换的刷新函数，由java层调用
function refreshRes() {
	isChangingSkin = true;
	skinPath = ifly_getCurrentSkinPath();
	if (!skinPath) {
		skinPath = "../skin/theme_new/";
	}

	head.removeChild(document.getElementById('dimenJs'));
	head.removeChild(document.getElementById('imageJs'));

	// 删除least解析生成的css style
	var styles = document.getElementsByTagName('style');
	while (styles.length > 0) {
		head.removeChild(styles[styles.length - 1]);
	}

	loadResource();
}

// 加载businessLeast
function loadBusinessLeast() {
	var businessLeast = createLeastElement('businessLeast');
	businessLeast.href = skinPath + "dialogModeRes/business.least";
	head.appendChild(businessLeast);

	var leastJs = createScriptElement('leastJs');
	leastJs.src = skinPath + "dialogModeRes/least.min.js";
	head.appendChild(leastJs);
}

// 捕获least解析完成的事件
document.documentElement.addEventListener("parseFinish", function() {
	if (document.getElementById('businessLeast')) {
		// 通知java层，businessLeast解析完毕
		exec('WidgetMMPContainerComponents', 'businessLeastParseFinish', []);

		// 删除已经不需要的节点
		head.removeChild(document.getElementById('businessLeast'));
		head.removeChild(document.getElementById('leastJs'));

		// 若是换肤，则需要刷新已有节点
		if (isChangingSkin) {
			var bodyChildrens = document.body.children;
			if (bodyChildrens != null && bodyChildrens.length > 0) {
				for ( var i = 0; i < bodyChildrens.length; i++) {
					var child = bodyChildrens[i];
					if (child && child.refresh
							&& typeof child.refresh == 'function') {
						child.refresh();
					}
				}
				forceRefreshScreen();
			}
			isChangingSkin = false;
		}
	} else {
		exec('WidgetMMPContainerComponents', 'preLeastParseFinish', []);

		// 删除已经不需要的节点
		head.removeChild(document.getElementById('preLeast'));
		head.removeChild(document.getElementById('leastJs'));

		// 延迟一段时间再解析，避免阻塞页面加载
		setTimeout(function() {
			loadBusinessLeast();
		}, 500);
	}
}, false);

// 图片加载完成
function imgLoadFinish() {
	if (biggest_img_load_finish) {
		console.log('all img load finish now');
		// 通知java层，加载完毕
		exec('WidgetMMPContainerComponents', 'loadFinish', []);
	} else {
		console.log('not all img load finish, so retry a moment later');
		setTimeout(function() {
			imgLoadFinish();
		}, 50);
	}
}
imgLoadFinish();

// 根据android sdk版本，选择旋转动画的函数版本
try {
	if (resultDevice.model == "MI-ONE C1" || resultDevice.model == "MI 1"
			|| resultDevice.model == "MI 1S") {
		var androidVersion = 2.1;
	} else {
		var androidVersionName = resultDevice.release;
		console.log(androidVersionName);
		androidVersion = parseFloat(resultDevice.release);
	}
} catch (e) {
	androidVersion = 2.2;
}

if (androidVersion < 2.2) {
	startRotate = startRotateLowVersion;
}
/** ******************初始化工作结束************************** */

/**
 * Java函数对语音识别结果进行处理后，调用此函数进行页面展示
 * 
 * @param viewName
 *            需要处理的view的类型，如对话、提醒、股票等
 * @param result
 *            java进行处理后的数据结果，json格式字符串
 */
function addE(viewName, result) {
	console.log('addE begin, viewName is ' + viewName + ' ,result is ' + result);
	var view = null;
	if (viewName in functionMap) {
		var resultJson = eval('(' + result + ')');

		require(functionMap[viewName].url, function(func) {
			if (func && typeof func == 'function') {
				view = func(resultJson);
			} else {
				view = eval(functionMap[viewName].func)(resultJson);
			}

			// 强制屏幕刷新，解决界面闪烁的问题
			forceRefreshScreen();

			// 滚动到节点（WidgetViaFlyAnswerView在自己创建函数中处理）
			if (viewName != 'WidgetViaFlyAnswerView') {
				scrollToView(view);
			}
		});
	}
}

// 显示淡入淡出动画
function showOpacityAnimation(domElement, timeDelay) {
	if (enableAnimation) {
		setTimeout(function() {
			domElement.style.opacity = "1.0";
		}, timeDelay);
	}
}

function removeCurrentCanDeleteView(viweId) {
	console.log("removeCurrentCanDeleteView :" + currentCanDeleteView);
	if (currentCanDeleteView != null && currentCanDeleteView.parentNode != null) {
		if (currentCanDeleteView.deleteView !== undefined) {
			currentCanDeleteView.deleteView();
		}
		removeChild(currentCanDeleteView.parentNode, currentCanDeleteView);
		currentCanDeleteView = null;
	}
	forceRefreshScreen();
}

function removeErrorView() {
	if (errorView != null) {
		removeChild(document.body, errorView);
		errorView = null;
	}
	// 屏蔽页面刷新不及时的问题
	forceRefreshScreen();
}

/* 创建position为relative的外层div */
function createOutDiv(id) {
	var relativeDiv = document.createElement("div");
	relativeDiv.className = "css_dilaog_out_div";
	if (id != undefined && id != null) {
		relativeDiv.id = id;
	}
	return relativeDiv;
}

/**
 * 创建背景画布
 * 
 * @param width
 *            canvas的宽度
 */
function createBgCanvas(width) {
	var bg_canvas = document.createElement('canvas');
	bg_canvas.setAttribute("width", width + "px");
	return bg_canvas;
}

/********************功能列表相关函数*********************/
function createFocusItem(focusId, focusIconSrc, focusItemInfo, index,
		languageModeShow,offFlag) {
	var item = document.createElement("div");
	item.id = focusId;
	item.className = "css_dialog_focus_item";
	if (languageModeShow == false) {
		item.style.display = "none";
	}
	/** **************************************** */

	var preview = document.createElement("img");
	preview.id = focusId + "_preview";
	preview.className = "css_dialog_focus_preview";
	preview.src = focusIconSrc;

	/** **************************************** */

	var item_overview = document.createElement("div");
	item_overview.id = focusId + "_overview";
	item_overview.className = "css_dialog_focus_overview";
	if (index % 2 == 1) {
		item_overview.style.backgroundColor = "#f3f3f5";
	}

	var focus_Icon_container = document.createElement("div");
	focus_Icon_container.id = focusId + "_overview_icon_container";
	focus_Icon_container.className = "css_dialog_focus_icon_container";

	var focus_Icon = document.createElement("img");
	focus_Icon.id = focusId + "_normal";
	focus_Icon.src = focusIconSrc;
	focus_Icon.className = "css_dialog_focus_icon";

	var focus_Icon_pressed = document.createElement("img");
	focus_Icon_pressed.id = focusId + "_pressed";
	focus_Icon_pressed.className = "css_dialog_focus_icon_pressed";
	focus_Icon_pressed.src = focusIconSrc;

	focus_Icon_container.appendChild(focus_Icon);
	focus_Icon_container.appendChild(focus_Icon_pressed);

	var focus_describe = document.createElement("span");
	// focus_describe.className = "css_dialog_focus_describe";

	if (offFlag && (focusId == "focus_telephone" || focusId == "focus_message" || focusId == "focus_app")) {
		var offline = document.createElement("lable");
		offline.className = "css_dialog_focus_offline";
		offline.innerText = "不连网也能使用";
		focus_describe.className = "css_dialog_focus_describe_offline";
	} else {
		focus_describe.className = "css_dialog_focus_describe";
	}

	var focus_describe_title = document.createElement("div");
	focus_describe_title.id = focusId + "_overview_title";
	focus_describe_title.className = "css_dialog_focus_describe_title";
	focus_describe_title.innerText = focusItemInfo.describeTitle;

	var focus_describe_func = document.createElement("div");
	focus_describe_func.id = focusId + "_overview_func";
	focus_describe_func.className = "css_dialog_focus_describe_func";
	focus_describe_func.innerText = focusItemInfo.describeFunc;

	focus_describe.appendChild(focus_describe_title);
	focus_describe.appendChild(focus_describe_func);

	var fold_Icon = document.createElement("img");
	fold_Icon.id = focusId + "_overview_fold";
	fold_Icon.src = dialog_arrow_down_normal;
	fold_Icon.className = "css_dialog_focus_fold";

	item_overview.appendChild(focus_Icon_container);
	item_overview.appendChild(focus_describe);
	if (offFlag && (focusId == "focus_telephone" || focusId == "focus_message" || focusId == "focus_app")) {
		item_overview.appendChild(offline);
	}
	item_overview.appendChild(fold_Icon);

	var item_detail = document.createElement("div");
	item_detail.id = focusId + "_detail";
	item_detail.className = "css_dialog_focus_detail";

	var item_detail_canvas = document.createElement("canvas");
	item_detail_canvas.className = "css_dialog_absolute_bg";
	item_detail_canvas.id = focusId + "_detail_bg";

	var item_detail_text = document.createElement("div");
	item_detail_text.id = focusId + "_detail_text";
	item_detail_text.className = "css_dialog_focus_detail_text";
	item_detail_text.innerHTML = focusItemInfo.details;

	item_detail.appendChild(item_detail_canvas);
	item_detail.appendChild(item_detail_text);

	item.appendChild(preview);
	item.appendChild(item_overview);
	item.appendChild(item_detail);

	return item;
}

function createListDivider(dividerId, languageModeShow) {
	var divier = document.createElement("div");
	divier.id = dividerId;
	divier.style.height = "2px";
	divier.style.backgroundImage = "url('" + dialog_list_divider + "')";
	if (languageModeShow == false) {
		divier.style.display = "none";
	}
	return divier;
}
function invalidFocusListView(modeJson) {
	if (focusListView !== null) {
		var modeInfo = eval('(' + modeJson + ')');
		focusListView.invalidFocusList(modeInfo.itemShow);
		console.log("focus invalid is called,invalid info is "
				+ modeInfo.itemShow.toString());
	}
}

function createFocusList(listInfo) {
	var lMode = listInfo.welcomeListInfo;
	var isSupportOff = listInfo.supportOffline;
	var singleEnter = false;
	var hasShowId = null;
	var touchTarget = null;
	var oldElement = null;
	var outDiv = document.createElement("div");
	outDiv.className = "css_dialog_focus_out_div";

	var bgCanvas = document.createElement("canvas");
	bgCanvas.className = "css_dialog_absolute_bg";

	var focusContainer = document.createElement("div");
	focusContainer.className = "css_dialog_focus_list";
	var hasBg = 0;

	var focusInfo = lMode.showInfo;
	var focusControl = lMode.showControl;
	var focusIconMap = {
		"focus_telephone" : dialog_focus_call_icon,
		"focus_message" : dialog_focus_sms_icon,
		"focus_contacts" : dialog_focus_contacts_icon,
		"focus_schedule" : dialog_focus_schedule_icon,
		"focus_music" : dialog_focus_music_icon,
		"focus_app" : dialog_focus_app_icon,
		"focus_appsearch" : dialog_focus_search_icon,
		"focus_restaurant" : dialog_focus_restaurant_icon,
		"focus_flight" : dialog_focus_flight_icon,
		"focus_hotel" : dialog_focus_hotel_icon,
		"focus_weather" : dialog_focus_weather_icon,
		"focus_stock" : dialog_focus_stock_icon,
		"focus_cmbusiness" : dialog_focus_cm_icon,
		"focus_map" : dialog_focus_map_icon,
		"focus_websearch" : dialog_focus_web_icon,
		"focus_news" : dialog_focus_news_icon,
		"focus_translation" : dialog_focus_translation_icon,
		"focus_dialog" : dialog_focus_dialog_icon
	};
	for ( var i = 0; i < focusInfo.length; i++) {
		focusContainer.appendChild(createFocusItem(focusInfo[i].foucsID,
				focusIconMap[focusInfo[i].foucsID], focusInfo[i], hasBg,
				focusControl[i],isSupportOff));
		if (i + 1 < focusInfo.length) {
			focusContainer.appendChild(createListDivider(focusInfo[i].foucsID
					+ "divider", focusControl[i]));
		}
		if (focusControl[i]) {
			hasBg++;
		}
	}

	/** ************************************************************** */
	focusContainer
			.addEventListener(
					"touchstart",
					function(event) {
						touchTarget = getParentOfClass(
								"css_dialog_focus_icon_container", event.target);
						if (touchTarget != null) {
							singleEnter = true;
							console.log(touchTarget.parentNode.id);
							console.log((touchTarget.parentNode).parentNode.id);
							// document.getElementById((touchTarget.parentNode).parentNode.id
							// + "_preview").style.display = "inline-block";
							document
									.getElementById((touchTarget.parentNode).parentNode.id
											+ "_normal").style.display = "none";
							document
									.getElementById((touchTarget.parentNode).parentNode.id
											+ "_pressed").style.display = "inline-block";
						} else {
							touchTarget = getParentOfClass(
									"css_dialog_focus_overview", event.target);
							singleEnter = false;
							if (touchTarget != null) {
								touchTarget.style.backgroundImage = "url('"
										+ list_item_background_pressed + "')";
								document.getElementById(touchTarget.id
										+ "_title").style.color = "white";
								document.getElementById(touchTarget.id
										+ "_func").style.color = "#e1f0ff";
								console.log("" + hasShowId);

								if (hasShowId == touchTarget.parentNode.id) {
									document.getElementById(hasShowId
											+ "_overview_fold").src = dialog_arrow_up_pressed;
								} else {
									document
											.getElementById(touchTarget.parentNode.id
													+ "_overview_fold").src = dialog_arrow_down_pressed;
								}
							}
						}
						moveOverCheck.start(event);
						event.stopPropagation();
					}, false);
	focusContainer
			.addEventListener(
					"touchmove",
					function(event) {
						if (touchTarget != null) {
							if (singleEnter == false) {
								touchTarget.style.backgroundImage = "";
								document.getElementById(touchTarget.id
										+ "_title").style.cssText = "";
								document.getElementById(touchTarget.id
										+ "_func").style.cssText = "";
								if (hasShowId == touchTarget.parentNode.id) {
									document
											.getElementById(touchTarget.parentNode.id
													+ "_overview_fold").src = dialog_arrow_up_normal;
								} else {
									document
											.getElementById(touchTarget.parentNode.id
													+ "_overview_fold").src = dialog_arrow_down_normal;
								}
							} else {
								// document.getElementById(touchTarget.parentNode.parentNode.id
								// + "_preview").style.display = "none";
								document
										.getElementById((touchTarget.parentNode).parentNode.id
												+ "_normal").style.display = "inline-block";
								document
										.getElementById((touchTarget.parentNode).parentNode.id
												+ "_pressed").style.display = "none";
							}
							forceRefreshScreen();
							if (moveOverCheck.check(event)) {
								touchTarget = null;
								singleEnter = false;
							}
						}
						event.stopPropagation();
					}, false);

	focusContainer
			.addEventListener(
					"touchend",
					function() {
						if (touchTarget != null) {
							if (singleEnter) {
								// document.getElementById(touchTarget.parentNode.parentNode.id
								// + "_preview").style.display = "none";
								document
										.getElementById((touchTarget.parentNode).parentNode.id
												+ "_normal").style.display = "inline-block";
								document
										.getElementById((touchTarget.parentNode).parentNode.id
												+ "_pressed").style.display = "none";
								exec(
										"WidgetMMPContainerComponents",
										'singEnter',
										[ touchTarget.parentNode.parentNode.id ]);
							} else {
								touchTarget.style.backgroundImage = "";
								document.getElementById(touchTarget.id
										+ "_title").style.cssText = "";
								document.getElementById(touchTarget.id
										+ "_func").style.cssText = "";
								if (hasShowId === touchTarget.parentNode.id) {
									document.getElementById(hasShowId
											+ "_overview_fold").src = dialog_arrow_down_normal;
									document.getElementById(hasShowId
											+ "_detail").style.display = "none";
									needFold = false;
									hasShowId = null;
									oldElement = null;
								} else {
									if (hasShowId != null) {
										document.getElementById(hasShowId
												+ "_detail").style.display = "none";
										document.getElementById(hasShowId
												+ "_overview_fold").src = dialog_arrow_down_normal;
										oldElement = null;
									}
									hasShowId = touchTarget.parentNode.id;
									document.getElementById(hasShowId
											+ "_detail").style.display = "block";
									needFold = true;
									oldElement = touchTarget;

									var detail_canvas = document
											.getElementById(hasShowId
													+ "_detail_bg");
									var detail_bg_height = document
											.getElementById(hasShowId
													+ "_detail_text").clientHeight;
									document.getElementById(hasShowId
											+ "_detail").style.height = detail_bg_height
											+ "px";
									detail_canvas.setAttribute("height",
											detail_bg_height + "px");
									detail_canvas.setAttribute("width",
											dialog_box_canvas_width + "px");
									reDraw(detail_canvas,
											dialogmode_focus_detail_bg,
											dialog_focus_detail_bg_coordinates);

									document.getElementById(hasShowId
											+ "_overview_fold").src = dialog_arrow_up_normal;
								}

								bgCanvas.setAttribute("height",
										focusContainer.clientHeight + "px");
								reDraw(bgCanvas, img_dialog_view_bg,
										dialog_view_bg_coordinates);
								forceRefreshScreen();
								// 列表展开或收起后需要刷新内嵌webview的坐标
								refreshWeb();
							}
						}
						event.stopPropagation();
					}, false);

	/** ************************************************************** */
	outDiv.appendChild(bgCanvas);
	outDiv.appendChild(focusContainer);
	document.body.appendChild(outDiv);

	var height = focusContainer.clientHeight;
	bgCanvas.setAttribute("width", dialog_box_canvas_width + "px");
	bgCanvas.setAttribute("height", height + "px");
	draw(bgCanvas, img_dialog_view_bg, dialog_view_bg_coordinates);
	forceRefreshScreen();

	outDiv.foldDetail = function() {
		if (oldElement != null) {
			document.getElementById(oldElement.parentNode.id + "_detail").style.display = "none";

			bgCanvas.setAttribute("height", focusContainer.clientHeight + "px");
			reDraw(bgCanvas, img_dialog_view_bg, dialog_view_bg_coordinates);

			document.getElementById(oldElement.id + "_fold").src = dialog_arrow_down_normal;
			forceRefreshScreen();
			needFold = false;
			oldElement = null;
			hasShowId = null;
			// 列表展开或收起后需要刷新内嵌webview的坐标
			refreshWeb();
		}
	};
	outDiv.invalidFocusList = function(invalidInfo) {
		console.log("invalid info is" + invalidInfo.toString());
		var newId = 0;
		for ( var i = 0; i < invalidInfo.length; i++) {
			if (invalidInfo[i] == false) {
				document.getElementById(focusInfo[i].foucsID).style.display = "none";
				document.getElementById(focusInfo[i].foucsID + "divider").style.display = "none";
			} else {
				document.getElementById(focusInfo[i].foucsID).style.display = "block";
				if (newId % 2 == 1) {
					console.log("ivalid item id is " + newId + "  "
							+ focusInfo[i].foucsID);
					document.getElementById(focusInfo[i].foucsID + "_overview").style.backgroundColor = "#f3f3f5";
				} else {
					console.log("focus item id is " + newId);
					document.getElementById(focusInfo[i].foucsID + "_overview").style.backgroundColor = "";
				}
				if (i + 1 < invalidInfo.length) {
					document.getElementById(focusInfo[i].foucsID + "divider").style.display = "block";
				}
				newId++;
			}
		}
		newId = 0;
		bgCanvas.setAttribute("height", focusContainer.clientHeight + "px");
		reDraw(bgCanvas, img_dialog_view_bg, dialog_view_bg_coordinates);
		refreshWeb();
		forceRefreshScreen();
	};

	outDiv.updateFocusListName = function(updateNameInfor) {
		for ( var i = 0; i < updateNameInfor.length; i++) {
			var doc = document.getElementById(updateNameInfor[i].foucsID);
			doc.refreshDate(updateNameInfor[i]);
		}
	};
	focusListView = outDiv;
}

function getUpdateName(updateJsonInfo) {
	if (focusListView !== null) {
		var updateArray = eval("(" + updateJsonInfo + ")");
		focusListView.updateFocusListName(updateArray);
	}
}


/** *****************复制重播浮层相关逻辑******************* */
function hideFloatLayer() {
	if (float_layer) {
		float_layer.hide();
	}
}

function createFloatLayer() {
	var float = document.createElement("div");
	float.className = "css_float";
	float.style.height = window.innerHeight + "px";

	var layer = document.createElement("div");
	layer.className = "css_float_container";

	var layer_bg = document.createElement("canvas");
	layer_bg.className = "css_float_canvas";

	var layer_text = document.createElement("div");
	layer_text.className = "css_float_text_top";
	var layer_function_div = document.createElement("div");
	var layer_copy = document.createElement("label");
	layer_copy.className = "css_float_function_text";
	layer_copy.innerHTML = "复制";
	var layer_share = document.createElement("label");
	layer_share.className = "css_float_function_text";
	layer_share.innerHTML = "分享";
	var layer_play = document.createElement("label");
	layer_play.className = "css_float_function_text";
	layer_play.innerHTML = "重播";

	layer_text.appendChild(layer_copy);
	layer_text.appendChild(layer_share);
	layer_text.appendChild(layer_play);

	layer.appendChild(layer_bg);
	layer.appendChild(layer_text);

	float.appendChild(layer);

	document.body.appendChild(float);

	var titleHeight = document.getElementById("title").clientHeight;
	var stateValue = 0;
	var positionValue = null;

	var context = layer_bg.getContext("2d");
	float.setPosition = function(position) {
		positionValue = position;
	}
	var callback_copy, callback_share, callback_play, callback_bg;
	float.setCallBack = function(copyFunc, shareFunc, playFunc, bgFunc) {
		callback_copy = copyFunc;
		callback_share = shareFunc;
		callback_play = playFunc;
		callback_bg = bgFunc;
		;
	}
	float.hide = function() {
		float.style.display = "none";
		callback_bg();
		exec("WidgetMMPContainerComponents",'popState',[0]);
	}
	float.show = function() {
		float.style.display = "block";
		var canvasHeight = layer_text.clientHeight;
		var canvasWidth = layer_text.clientWidth;
		float_width = canvasWidth;

		if (positionValue[0] > canvasHeight + titleHeight) {
			stateValue = 0;
			layer.style.marginBottom = "0px";
			layer.style.marginTop = positionValue[0] - canvasHeight + "px";
		} else if (window.innerHeight - positionValue[1] > canvasHeight) {
			stateValue = 1;
			layer.style.marginBottom = "0px";
			layer.style.marginTop = (positionValue[1] - 20) + "px";
		} else {
			stateValue = 0;
			layer.style.marginBottom = "0px";
			layer.style.marginTop = window.innerHeight / 2 + "px";
		}

		layer_bg.setAttribute("height", canvasHeight + "px");
		layer_bg.setAttribute("width", canvasWidth + "px");
		if (stateValue == 0) {
			layer_text.className = "css_float_text_top";
			draw(layer_bg, bubbleLeftImg, bubble_coordinates);
		} else {
			layer_text.className = "css_float_text_Bottom";
			draw(layer_bg, bubbleRightImg, bubble_coordinates);
		}
		exec("WidgetMMPContainerComponents",'popState',[1]);
	}
	var touchFromThis = false;

	layer_text.addEventListener("touchstart", function(event) {
		touchFromThis = true;
		event.preventDefault();
		event.stopPropagation();
		if (event.target == layer_copy || event.target == layer_share
				|| event.target == layer_play) {
			event.target.style.background = "#51abe9";
			event.target.style.color = "white";
		}
	}, false);

	layer_text.addEventListener("touchmove", function(event) {
		if (touchFromThis) {
			event.preventDefault();
			event.stopPropagation();
		}
	}, false);

	layer_text.addEventListener("touchend", function(event) {
		if (touchFromThis) {
			float.style.display = "none";
			event.preventDefault();
			event.stopPropagation();
			touchFromThis = false;

			event.target.style.background = "";
			event.target.style.color = "";
			if (event.target == layer_copy) {
				callback_copy();
			} else if (event.target == layer_share) {
				callback_share();
			} else if (event.target == layer_play) {
				callback_play();
			}
			callback_bg();
		}
	}, false);

	float.addEventListener("touchstart", function(event) {
		// float.style.display = "none";
		// callback_bg();
		float.hide();
		event.stopPropagation();
	}, false);

	float_layer = float;
}

/**
 * 函数映射表
 */
var functionMap = {
	WidgetCustomerQuestionView : {
		url : [ "./view/questionView.js" ],
		func : "showQuestion"
	},
	WidgetViaFlyAnswerView : {
		url : [ "./view/answerView.js" ],
		func : "showAnswer"
	},
	WidgetAppLocalSearchView : {
		url : [ "./view/appListView.js" ],
		func : "showList"
	},
	WidgetWeatherView : {
		url : [ "./view/weatherView.js" ],
		func : "showWeather"
	},
	WidgetRemindView : {
		url : [ "./view/remindView.js" ],
		func : "showRemind"
	},
	WidgetRemindConfirmView : {
		url : [ "./view/remindConfirm.js" ],
		func : "createRemindConfirmView"
	},
	WidgetWebviewContainer : {
		url : [ "./view/webView.js" ],
		func : "showWeb"
	},

	WidgetWebviewContainer2 : {
		url : [ "./view/webView2.js" ],
		func : "showWeb2"
	},
	
	WidgetNewsView : {
		url : [ "./view/newsView.js" ],
		func : "createNewsView"
	},
	
	WidgetRestaurantView : {
		url : [ "./view/restaurantView.js" ],
		func : "createRestaurantView"
	},
	WidgetStockView : {
		url : [ "./view/stockView.js" ],
		func : "createStockView"
	},
	WidgetContactListView : {
		url : [ "./view/contactView.js" ],
		func : "createContactView"
	},
	WidgetPhoneListView : {
		url : [ "./view/phoneNumView.js" ],
		func : "createPhoneNumView"
	},
	WidgetSmsInputView : {
		url : [ "./view/smsView.js" ],
		func : "createSms"
	},
	NetErrorView : {
		url : [ "./view/errorView.js" ],
		func : "createErrorView"
	},
	WidgetCallView : {
		url : [ "./view/callView.js" ],
		func : "createCallView"
	},
	WidgetContactCreateView : {
		url : [ "./view/contactCreateView.js" ],
		func : "createContactCreateView"
	},
	WidgetContactSearchListView : {
		url : [ "./view/contactSearchView.js" ],
		func : "createContactSearchListView"
	},
	WidgetMusicView : {
		url : [ "./view/musicView.js" ],
		func : "createMusicView"
	},
	WidgetMotorViolationView : {
		url : [ "./view/vehicleQueryView.js" ],
		func : "createVehicleQueryView"
	},
	WidgetMotorViolationResultView : {
		url : [ "./view/vehicleViolationResultView.js" ],
		func : "createVehicleInformationView"
	},
	DriverPointQueryView : {
		url : [ "./view/driverCreditQuery.js" ],
		func : "createDriveCreditQueryView"
	},
	DriverPointResultView : {
		url : [ "./view/driverCreditResView.js" ],
		func : "createDriverCreditResView"
	},
};

// -------------确定、取消按钮文本创建函数，新建联系人和发短信都用到该函数------------------------//
/**
 * 创建按钮
 * 
 * @param width
 *            按钮宽度
 * @param height
 *            按钮高度
 * @param text
 *            按钮文字
 */
function createButtonDiv(width, height, text) {
	var btn_text_div = document.createElement("div");
	btn_text_div.style.display = "inline-block";
	btn_text_div.style.textAlign = "center";
	btn_text_div.style.height = height + "px";
	btn_text_div.style.width = width + "px";
	btn_text_div.innerHTML = text;
	return btn_text_div;
}

// --------------创建练新人条目的函数 <某个联系人搜索的title和联系人列表项的创建都用到了该函数> ----------------//
function createContactItem(contactNameId, contactNameStr, contactIconSrc,
		containerStyle) {
	var contactItem = document.createElement("div");
	contactItem.id = contactNameId;
	if (containerStyle != "" && containerStyle != undefined) {
		contactItem.className = containerStyle;
	} else {
		contactItem.className = "css_dialog_contact_item";
	}

	var contactIconContainer = document.createElement("div");
	contactIconContainer.className = "css_dialog_contact_icon_container";

	var contactIcon = document.createElement("img");
	contactIcon.className = "css_dialog_contact_icon";
	contactIconContainer.appendChild(contactIcon);

	if (contactIconSrc == undefined || contactIconSrc == "") {
		contactIcon.src = dialog_contact_icon;
	} else {
		contactIcon.src = contactIconSrc;
		var contactIconFrame = document.createElement("img");
		contactIconFrame.className = "css_dialog_contact_icon_frame";
		contactIconFrame.src = dialog_contact_icon_frame;
		contactIconContainer.appendChild(contactIconFrame);
	}

	var contactNameContainer = document.createElement("div");
	contactNameContainer.className = "css_dialog_contact_name_container";
	contactNameContainer.innerText = contactNameStr;

	contactItem.appendChild(contactIconContainer);
	contactItem.appendChild(contactNameContainer);
	return contactItem;
}

// ---------------创建搜索联系人界面的联系人条目<号码列表和联系人搜索的条目创建都用到了该函数>-------------//
function createContactNumberItem(containerId, isMobileNumber, phoneTag,
		markUpPhoneNum, leftContainerId, rightContainerId, defaultItemId,
		phoneFunctionIconSrc) {
	var isContactSearch = true;

	var idPre = containerId.substring(0, containerId.length - 2);
	var index = containerId.substring(containerId.length - 2);

	if (phoneFunctionIconSrc == undefined || phoneFunctionIconSrc == null
			|| phoneFunctionIconSrc == "") {
		isContactSearch = true;
	} else {
		isContactSearch = false;
	}
	// 创建最外层的容器
	var container = document.createElement("div");
	container.id = containerId;
	container.className = "css_dialog_contact_search_item_container";

	// 创建左边的容器
	var leftContainer = document.createElement("div");
	leftContainer.id = leftContainerId;
	leftContainer.className = "css_dialog_contact_search_item_lr_container";

	var leftContentContainer = document.createElement("div");

	// 放字的容器，用<br>换行
	var textContainer = document.createElement("span");
	textContainer.className = "css_dialog_contact_search_item_left_text_container";

	var phoneShowString = "";
	var sMarkArray = markUpPhoneNum.split("^");
	var phoneNumber;
	if (sMarkArray.length > 1) {
		phoneNumber = sMarkArray[1];
	} else {
		phoneNumber = sMarkArray[0];
	}
	// 电话号码加粗 分段
	var sArray = phoneNumber.split("&");
	var firstMarkPosition = phoneNumber.indexOf("&");
	if (firstMarkPosition == -1) {
		if (isMobileNumber) {
			phoneShowString = phoneNumber.substring(0, 3) + " "
					+ phoneNumber.substring(3, 7) + " "
					+ phoneNumber.substring(7);
		} else {
			phoneShowString = phoneNumber;
		}
	} else if (firstMarkPosition == 0) {
		var lastMarkPosition = phoneNumber.lastIndexOf("&");

		if (lastMarkPosition == phoneNumber.length - 1) {
			console.log(sArray[1]);
			if (isMobileNumber) {
				var s = sArray[1].substring(0, 3) + " "
						+ sArray[1].substring(3, 7) + " "
						+ sArray[1].substring(7);
				phoneShowString = phoneNumJSpre + s + phoneJSpost;
			} else {
				phoneShowString = phoneNumJSpre + sArray[1] + phoneJSpost;
			}
		} else {
			var s1 = phoneNumJSpre + sArray[1] + phoneJSpost + " ";
			var s2 = sArray[2].substring(0, 4) + " " + sArray[2].substring(4);
			phoneShowString = s1 + s2;
		}
	} else if (firstMarkPosition > 6) {
		var s1 = sArray[0].substring(0, 3) + " " + sArray[0].substring(3) + " ";
		var s2 = phoneNumJSpre + sArray[1] + phoneJSpost;
		phoneShowString = s1 + s2;
	} else {
		phoneShowString = sArray[0] + " " + phoneNumJSpre + sArray[1]
				+ phoneJSpost + " " + sArray[2];
	}

	var leftHtmlStr = phoneShowString;
	if (sMarkArray.length > 1) {
		leftHtmlStr = sMarkArray[0] + " " + leftHtmlStr;
	}
	if (phoneTag != undefined && phoneTag != null && phoneTag != "") {
		// leftHtmlStr = phoneNumJSpre + leftHtmlStr + phoneJSpost + '<br>' +
		// "<label class='css_dialog_contact_search_item_phone_tag'>" + phoneTag
		// + "</label>";
		leftHtmlStr = "<label class='css_dialog_contact_search_item_phone_tag'>"
				+ phoneTag + "</label><br>" + leftHtmlStr;
	}
	textContainer.innerHTML = leftHtmlStr;

	if (isContactSearch == true) {
		// 打电话的图标
		var callIcon = document.createElement("img");
		callIcon.src = dialog_call_icon;
		callIcon.className = "css_dialog_contact_search_item_telephone_icon";
		callIcon.id = idPre + "callIcon" + index;

		leftContentContainer.appendChild(textContainer);
		leftContentContainer.appendChild(callIcon);

		leftContainer.appendChild(leftContentContainer);
	} else {
		textContainer.className = "css_dialog_phone_info_container";
		leftContainer.appendChild(textContainer);
	}

	// 创建右边的容器
	var rightContainer = document.createElement("div");
	rightContainer.id = rightContainerId;
	rightContainer.className = "css_dialog_contact_search_item_lr_container";

	// 发短信图标
	var messageIcon;
	if (defaultItemId !== null) {
		messageIcon = document.createElement("canvas");
		messageIcon.id = "defaultPhoneNum";
		messageIcon.setAttribute("width", dialog_phone_deafault_canvas + "px");
		messageIcon.setAttribute("height", dialog_phone_deafault_canvas + "px");
		messageIcon.className = "css_dialog_phoneNum_default";
	} else {
		messageIcon = document.createElement("img");
		messageIcon.className = "css_dialog_contact_search_item_message_icon";
		messageIcon.id = idPre + "_messageIcon_" + index;
		if (isContactSearch == true) {
			messageIcon.src = dialog_message_icon;
		} else {
			messageIcon.src = phoneFunctionIconSrc;
		}
	}
	rightContainer.appendChild(messageIcon);

	// 将左右容器加入主容器中
	container.appendChild(leftContainer);
	container.appendChild(rightContainer);

	return container;
}

// ----------------------重播分享相关代码----------------------------//
/**
 * 创建分享、重播的视图
 * 
 * @param taskHandler
 *            底层java函数的标识符
 * @param isOnlyShare
 *            是否只显示分享按钮
 * @param shareType
 *            分享、重播使用的图片类型
 */
function createSharePlayView(taskHandler, isOnlyShare, shareType) {
	var sharePlayDiv = document.createElement("div");

	if (isOnlyShare == false) {
		var loading_canvas = document.createElement("canvas");
		loading_canvas.id = "play_loading" + taskHandler;
		loading_canvas.setAttribute("width",
				dialog_content_play_waiting_canvas_width + "px");
		loading_canvas.setAttribute("height",
				dialog_content_play_waiting_canvas_height + "px");
		loading_canvas.className = "css_dialog_loading_canvas";
		loading_canvas.style.display = "none";

		var playImg = document.createElement("img");
		playImg.id = "playImg" + taskHandler;
		playImg.className = "css_dialog_content_play_btn";
		if (shareType == undefined || shareType == 1) {
			playImg.src = dialogmode_content_play_normal;
		} else if (shareType == 3) {
			playImg.src = answer_content_play_normal;
		}

		sharePlayDiv.appendChild(loading_canvas);
		sharePlayDiv.appendChild(playImg);
	}

	var shareImg = document.createElement("img");
	if (shareType == undefined || shareType == 1) {
		shareImg.src = dialogmode_share_button_normal;
		shareImg.className = "css_dialog_share_btn";
	} else if (shareType == 2) {
		shareImg.src = dialogmode_share_button_normal2;
		shareImg.className = "css_dialog_share_btn2";
	} else if (shareType == 3) {
		shareImg.src = answer_share_button_normal;
		shareImg.className = "css_dialog_share_btn";
	}

	sharePlayDiv.appendChild(shareImg);

	var scrollLength = 15;
	var target_start_pageY = 0;
	var target_end_pageY = 0;
	var target_have_move_motion = false;

	// 添加控制按钮触摸响应函数
	sharePlayDiv.addEventListener("touchstart", function() {
		target_start_pageY = 0;
		target_end_pageY = 0;
		target_have_move_motion = false;
		target_start_pageY = event.targetTouches[0].pageY;

		var targetElement = event.target;
		if (targetElement === playImg) {
			if (shareType == 1) {
				targetElement.src = dialogmode_content_play_pressed;
			} else if (shareType == 3) {
				targetElement.src = answer_content_play_pressed;
			}
		} else if (targetElement === shareImg) {
			if (shareType == 1) {
				targetElement.src = dialogmode_share_button_pressed;
			} else if (shareType == 2) {
				targetElement.src = dialogmode_share_button_pressed2;
			} else if (shareType == 3) {
				targetElement.src = answer_share_button_pressed;
			}
		}
		// 阻止冒泡，使answerView不再对此事件进行处理
		event.stopPropagation();
	}, false);

	sharePlayDiv
			.addEventListener(
					"touchmove",
					function() {
						target_end_pageY = event.targetTouches[0].pageY;
						if (!target_have_move_motion) {
							if (Math.abs(target_end_pageY - target_start_pageY) > scrollLength) {
								target_have_move_motion = true;
								console.log('target_have_move_motion is true');
							}
						}
						// 阻止冒泡，使answerView不再对此事件进行处理
						event.stopPropagation();
					}, false);

	sharePlayDiv.addEventListener("touchend", function() {
		var targetElement = event.target;
		if (targetElement === playImg || targetElement === loading_canvas) {
			if (shareType == 1) {
				targetElement.src = dialogmode_content_play_normal;
			} else if (shareType == 3) {
				targetElement.src = answer_content_play_normal;
			}

			if (!target_have_move_motion) {
				exec(taskHandler, 'replay', []);
			}
		} else if (targetElement === shareImg) {
			if (shareType == 1) {
				targetElement.src = dialogmode_share_button_normal;
			} else if (shareType == 2) {
				targetElement.src = dialogmode_share_button_normal2;
			} else if (shareType == 3) {
				targetElement.src = answer_share_button_normal;
			}
			if (!target_have_move_motion) {
				exec(taskHandler, 'share', []);
			}
		}
		// 阻止冒泡，使answerView不再对此事件进行处理
		event.stopPropagation();
	}, false);

	sharePlayDiv.refresh = function() {
		if (isOnlyShare == false) {
			shareImg.src = dialogmode_share_button_normal;
			// if(playImg.style.display === "none") {
			// dismissProgressBar(taskHandler);
			// showProgressBar(taskHandler);
			// } else {
			// playImg.src = dialogmode_content_play_normal;
			// }
			playImg.src = dialogmode_content_play_normal;
		} else {
			shareImg.src = dialogmode_share_button_normal2;
		}
	};
	return sharePlayDiv;
}

var content_play_loding_interval;

var showProgressBarCallCount = 0;
/**
 * 显示等待条，由java回调
 */
function showProgressBar(taskHandler) {
	var loadingCanvas = document.getElementById('play_loading' + taskHandler);
	console.log('showProgressBar begin, loadingCanvas is ' + loadingCanvas);

	// 解决view显示延迟带来的问题
	if (loadingCanvas == null) {
		setTimeout(function() {
			showProgressBarCallCount++;

			if (showProgressBarCallCount <= 4) {
				showProgressBar(taskHandler);
			}
		}, 500);
		return;
	}
	loadingCanvas.style.display = "inline-block";
	content_play_loding_interval = startRotate(loadingCanvas);

	var playImg = document.getElementById('playImg' + taskHandler);
	playImg.style.display = "none";

	// 屏蔽页面刷新不及时的问题
	forceRefreshScreen();
	showProgressBarCallCount = 0;
}

var dismissProgressBarCallCount = 0;
/**
 * 取消等待条，由java回调
 */
function dismissProgressBar(taskHandler) {
	// console.error("dismissProgressBar--------->>" + taskHandler);

	var loadingCanvas = document.getElementById('play_loading' + taskHandler);
	// alert('dismissProgressBar, taskHandler'+taskHandler);
	console.log('dismissProgressBar begin, loadingCanvas is ' + loadingCanvas);
	// 解决view显示延迟带来的问题
	if (loadingCanvas == null) {
		setTimeout(function() {
			dismissProgressBarCallCount++;
			if (dismissProgressBarCallCount <= 4) {
				dismissProgressBar(taskHandler);
			}
		}, 500);
		return;
	}

	loadingCanvas.style.display = "none";
	stopRotate(content_play_loding_interval);

	var playImg = document.getElementById('playImg' + taskHandler);
	playImg.style.display = "inline";

	if (taskHandler.indexOf("WidgetViaFlyAnswerView") != -1) {
		playImg.src = answer_content_play_normal;
	} else {
		playImg.src = dialogmode_content_play_normal;
	}

	// 屏蔽页面刷新不及时的问题
	forceRefreshScreen();
	dismissProgressBarCallCount = 0;
}

function showPlayImg(index, taskHandler) {
	// 保险起见，判断进度条是否已经消失。
	// var loadingCanvas = document.getElementById('play_loading' +
	// taskHandler);
	// if (loadingCanvas.style.display != 'none') {
	// dismissProgressBar(taskHandler);
	// }
	// console.error("showPlayImg--------->> " + taskHandler);

	var playImg = document.getElementById('playImg' + taskHandler);
	if (null == playImg) {
		console.log("palyImage is null,update is not success and return");
		return;
	}
	if (taskHandler.indexOf("WidgetViaFlyAnswerView") != -1) {
		if (index == 1) {
			playImg.src = answer_content_play_wave;
		} else if (index == 2) {
			playImg.src = answer_content_play_wave2;
		} else {
			playImg.src = answer_content_play_normal;
		}
	} else {
		if (index == 1) {
			playImg.src = dialogmode_content_play_wave;
		} else if (index == 2) {
			playImg.src = dialogmode_content_play_wave2;
		} else {
			playImg.src = dialogmode_content_play_normal;
		}
	}

	// 屏蔽页面刷新不及时的问题
	forceRefreshScreen();
}

// --------------刷新内嵌浏览器界 <removeChild函数、功能列表、回答气泡有用到> ----------------//
function refreshWeb() {
	console.log('refreshWeb begin');

	var webChilds = document.getElementsByClassName('css_dialog_web_div');
	if (webChilds != null && webChilds.length > 0) {
		var length = webChilds.length;
		for ( var i = 0; i < length; i++) {
			var innerdiv = webChilds[i];
			exec('WidgetMMPContainerComponents', 'refreshWeb', [
					innerdiv.offsetWidth, innerdiv.offsetHeight,
					innerdiv.offsetLeft, innerdiv.offsetTop, innerdiv.id ]);
		}
	}
}

// --------------创建列表中的分割线 ----------------//
function createRestaurantDivier(imgUrl) {
	var divier = document.createElement("div");
	divier.className = "css_dialog_restaurant_divider_line";
	if (imgUrl !== undefined) {
		divier.style.backgroundImage = "url('" + imgUrl + "')";
	} else {
		divier.style.backgroundImage = "url('" + dialog_list_divider + "')";
	}
	return divier;
}

/**
 * canvas方式实现图片旋转
 */
function startRotate(target_canvas, img) {
	stopRotate(content_play_loding_interval);
	console.error("high rotate function is called");
	var dialog_waiting = function() {
		// 获取上下文
		var ctx = target_canvas.getContext("2d");
		// 清空画布
		ctx.clearRect(0, 0, target_canvas.width, target_canvas.height);
		//
		ctx.translate(target_canvas.width / 2, target_canvas.height / 2);

		ctx.rotate(Math.PI / 4);

		ctx.translate(-target_canvas.width / 2, -target_canvas.height / 2);

		if (img != undefined && img != null) {
			ctx.drawImage(img, 0, 0, target_canvas.width, target_canvas.height);
		} else {
			ctx.drawImage(img_dialog_waiting_A[0], 0, 0, target_canvas.width,
					target_canvas.height);
		}
	};
	var funtion_id = setInterval(function() {
		dialog_waiting();
	}, 125);
	return funtion_id;
}

function startRotateLow(target_canvas, img, startFrom) {
	var dialog_waiting = function() {
		// 获取上下文
		var ctx = target_canvas.getContext("2d");
		// 清空画布
		ctx.clearRect(0, 0, target_canvas.width, target_canvas.height);

		var j = startFrom % 6;
		console.log("current image id is:" + j);
		ctx.drawImage(img_dialog_waiting_A[j], 0, 0, target_canvas.width,
				target_canvas.height);
		startFrom++;
	};
	var funtion_id = setInterval(function() {
		dialog_waiting();
	}, 250);

	console.log('startRotateLow, id ' + funtion_id);
	return funtion_id;
}

function startRotateLowVersion(target_canvas, img) {
	stopRotate(content_play_loding_interval);
	console.log("android low version function is called");
	var fun_id = startRotateLow(target_canvas, null, 0);
	return fun_id;
}

function stopRotate(funtion_id) {
	console.log('stopRotate, id ' + funtion_id);
	if (funtion_id != null && typeof funtion_id != "undefined") {
		clearInterval(funtion_id);
		funtion_id = null;
	}
}


