define(function() {

	/******************显示回答的函数模块********************/
	function showAnswer(answerInfo) {
		if (answerInfo.type == "MSG_PUSH") {
			createMessagePushView(answerInfo);
		} else {
			createAnswerDialog(answerInfo);
		}
	}

	/********************消息推送相关函数*********************/
	var messagePushRotatedId;
	/**
	 * 状态为0标志图片正常显示，为1标志正在加载，为2标志加载失败
	 */
	var messagePushStatus = 0;
	var ismessagePushClosed = false;

	function createMessagePushView(answerInfo) {
		var taskHandler = answerInfo.taskHandler;
		var show_div = document.createElement("div");
		if (enableAnimation && isChangingSkin == false) {
			show_div.className = "css_dialog_opacity_animation";
		}

		var outDiv = createOutDiv();
		var dialog_answer_canvas = createBgCanvas(dialog_box_canvas_width);
		dialog_answer_canvas.className = "css_dialog_absolute_bg";
		var dialog_answer_text = document.createElement("div");
		dialog_answer_text.className = "css_dialog_answer_text2";
		var answer_text = document.createElement("div");

		// url匹配
		var replaced_text = answerInfo.answerText;

		// 如果是消息推送，图片的位置在框框里面
		var picUrl = answerInfo.picUrl;
		if (picUrl) {
			var iconContainer = document.createElement("div");
			iconContainer.className = "css_dialog_message_push_icon_containner";

			var picture = document.createElement("img");
			picture.id = "message_push_picture";
			iconContainer.appendChild(picture);

			// 说明是下载好的
			if (answerInfo.isLocalFile) {
				picture.src = picUrl;
				picture.className = "css_dialog_message_push_icon";
			}
			// 如果是网络地址 等待下载完成的图片
			else {
				messagePushStatus = 1;
				picture.style.display = "none";

				var loading_canvas = document.createElement("canvas");
				loading_canvas.id = "message_push_loading_icon";
				loading_canvas.className = "css_dialog_message_push_loading_icon";
				loading_canvas.setAttribute("width", dialog_call_loading_icon_width + "px");
				loading_canvas.setAttribute("height", dialog_call_loading_icon_height + "px");

				var failContainner = document.createElement("div");
				failContainner.id = "message_push_fail_containner";
				failContainner.style.display = "none";

				var loadFailIcon = document.createElement("img");
				loadFailIcon.src = push_notice_pic_default;
				loadFailIcon.className = "css_dialog_message_push_loadfail_icon";

				var failMessage = document.createElement("div");
				failMessage.className = "css_dialog_message_push_fail";
				failMessage.innerText = "点击图片  重新加载";

				failContainner.appendChild(loadFailIcon);
				failContainner.appendChild(failMessage);

				iconContainer.appendChild(loading_canvas);
				iconContainer.appendChild(failContainner);

				dialog_answer_text.appendChild(iconContainer);
				messagePushRotatedId = startRotate(loading_canvas);

				iconContainer.addEventListener("touchstart", function() {
					moveOverCheck.start(event);
					if (messagePushStatus != 0) {
						event.stopPropagation();
					}
				}, false);
				iconContainer.addEventListener("touchmove", function() {
					moveOverCheck.check(event);
					if (messagePushStatus != 0) {
						event.stopPropagation();
					}
				}, false);
				iconContainer.addEventListener("touchend", function() {
					if (!moveOverCheck.isMoveOver() && (messagePushStatus == 2)) {
						messagePushStatus = 1;
						failContainner.style.display = "none";
						messagePushRotatedId = startRotate(loading_canvas);
						loading_canvas.style.display = "inline-block";
						exec(taskHandler, 'reloadPic', []);
					}
					if (messagePushStatus != 0) {
						event.stopPropagation();
					}
				}, false);
			}
			dialog_answer_text.appendChild(iconContainer);
		}

		if (replaced_text != null || answerInfo.linkText != null) {
			answer_text.className = "css_answer_text_whith_share";
			if (replaced_text) {
				answer_text.innerHTML = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" + replaced_text;
			}
			if (answerInfo.linkText) {
				answer_text.innerHTML += "<button id='message_push_link' class='css_dialog_message_push_link_normal'>" + answerInfo.linkText + "</button>";
			}
			dialog_answer_text.appendChild(answer_text);
		}

		var closeBtn = document.createElement("img");
		closeBtn.className = "css_dialog_answer_close_btn";
		closeBtn.src = img_authentication_close_btn_bg_normal;

		closeBtn.addEventListener("touchstart", function() {
			closeBtn.src = img_authentication_close_btn_bg_pressed;
			event.preventDefault();
			event.stopPropagation();
		});
		closeBtn.addEventListener("touchmove", function() {
			closeBtn.src = img_authentication_close_btn_bg_normal;
			event.preventDefault();
			event.stopPropagation();
		});
		closeBtn.addEventListener("touchend", function() {
			closeBtn.src = img_authentication_close_btn_bg_normal;
			event.preventDefault();
			event.stopPropagation();
			document.body.removeChild(show_div);

			//删除消息
			exec(taskHandler, 'removeMessage', [answerInfo.id]);
			//通知java函数释放相关资源
			exec('WidgetMMPContainerComponents', 'removeViewForJs', [taskHandler]);

			ismessagePushClosed = true;
		});
		outDiv.appendChild(dialog_answer_canvas);
		outDiv.appendChild(dialog_answer_text);
		outDiv.appendChild(closeBtn);

		show_div.appendChild(outDiv);
		document.body.appendChild(show_div);

		// clientHeight = 显示区域高度+padding
		var canvasHeight = dialog_answer_text.clientHeight;
		if (canvasHeight < dialog_box_canvs_minHeight) {
			canvasHeight = dialog_box_canvs_minHeight;
			dialog_answer_text.style.top = (dialog_box_canvs_minHeight - dialog_answer_text.clientHeight) / 2 + "px";
		}
		// console.log(dialog_answer_text.clientHeight);
		dialog_answer_canvas.setAttribute("height", canvasHeight + "px");

		// 如果是招呼语或者消息推送
		dialog_answer_text.style.color = "#676779";
		draw(dialog_answer_canvas, img_dialogmode_message_push_bg_normal, dialogmode_message_push_bg_coordinates);

		outDiv.addEventListener("touchstart", function() {
			moveOverCheck.start(event);
			reDraw(dialog_answer_canvas, img_dialogmode_message_push_bg_pressed, dialogmode_message_push_bg_coordinates);

			var link = document.getElementById("message_push_link");
			if (link != null) {
				link.className = "css_dialog_message_push_link_pressed";
			}
		}, false);
		outDiv.addEventListener("touchmove", function() {
			moveOverCheck.check(event);
			reDraw(dialog_answer_canvas, img_dialogmode_message_push_bg_pressed, dialogmode_message_push_bg_coordinates);

			var link = document.getElementById("message_push_link");
			if (link != null) {
				link.className = "css_dialog_message_push_link_pressed";
			}
		}, false);
		outDiv.addEventListener("touchend", function() {
			reDraw(dialog_answer_canvas, img_dialogmode_message_push_bg_normal, dialogmode_message_push_bg_coordinates);
			var link = document.getElementById("message_push_link");
			if (link != null) {
				link.className = "css_dialog_message_push_link_normal";
			}
			if (answerInfo.openUrl) {
				if (!moveOverCheck.isMoveOver()) {
					exec(taskHandler, 'openUrl', [answerInfo.openUrl, answerInfo.id]);
				}
			}
		}, false);

		show_div.refresh = function() {
			reDraw(dialog_answer_canvas, img_dialog_ansew_bg, dialog_answer_bg_coordinates);
		};

		if (answerInfo.showWelcomeList && focusListView == null && document.body.children.length <= 3) {
			// 添加功能列表时不用滚动
			setTimeout(function() {
				// if (answerInfo.welcomeListInfo != undefined) {
					// createFocusList(answerInfo.welcomeListInfo);
				// }
				if (answerInfo.listInfo != undefined) {
					createFocusList(answerInfo.listInfo);
				}
			}, 100);
		} else {
			scrollToView(show_div);
		}
		showOpacityAnimation(show_div, 150);
		return show_div;
	}

	function reloadMessagePushPic(status, obj) {
		if (ismessagePushClosed) {
			return;
		}
		console.log("reloadMessagePushPic()");
		messagePushStatus = status;
		stopRotate(messagePushRotatedId);
		var loadingIcon = document.getElementById("message_push_loading_icon");
		loadingIcon.style.display = "none";

		if (status == 0) {
			var failContainner = document.getElementById("message_push_fail_containner");
			failContainner.style.display = "none";

			var picture = document.getElementById("message_push_picture");
			picture.src = obj;
			picture.className = "css_dialog_message_push_icon";
			picture.style.display = "inline-block";
		} else {
			var failContainner = document.getElementById("message_push_fail_containner");
			failContainner.style.display = "block";
		}
	}

	// 取消按钮
	var dialog_answer_cancel_btn = null;

	/**
	 * 创建回答对话框 菜谱、消息推送等共用此
	 *
	 * @param answerInfo
	 *            java处理过的结果，json格式
	 */
	function removeAnswerShare() {
		if (answerViewWithShare != null) {
			answerViewWithShare.removeShare();
			answerViewWithShare = null;
		}
	}

	/**************提示语气泡View***********************/
	function createAnswerDialog(answerInfo) {
		var isDialogFocus = (answerInfo.showShare || answerInfo.focus == "message");
		var taskHandler = answerInfo.taskHandler;
		var show_div = document.createElement("div");
		if (enableAnimation && isChangingSkin == false) {
			show_div.className = "css_dialog_opacity_animation";
		}

		var outDiv = createOutDiv();
		var dialog_answer_canvas = createBgCanvas(dialog_box_canvas_width);
		dialog_answer_canvas.className = "css_dialog_absolute_bg";
		var dialog_answer_text = document.createElement("div");
		dialog_answer_text.className = "css_dialog_answer_text2";
		var answer_text = document.createElement("div");

		// url匹配
		var replaced_text = answerInfo.answerText;
		// 闲聊时播报的内容
		var replaced_play_text = answerInfo.speechText;
		// 搜索应用时播报的内容
		var replaced_app_play_text = answerInfo.answerText;

		// 匹配网页地址
		var reg_url2 = /\b([\d\w\.\/\+\-\?\:]*)((ht|f)tp(s|)\:\/\/|[\d\d\d|\d\d]\.[\d\d\d|\d\d]\.|www\.|\.tv|\.ac|\.com|\.edu|\.gov|\.int|\.mil|\.net|\.org|\.biz|\.info|\.name|\.pro|\.museum|\.co)([\d\w\.\/\%\+\-\=\&amp;\?\:\\\&quot;\'\,\|\~\;]*)|(\/)$\b/ig;
		var results;
		if (answerInfo.focus == "dialog" || answerInfo.focus == "app") {
			results = replaced_text.match(reg_url2);
			if (results != null) {
				replaced_text = replaced_text.replace(reg_url2, function(m) {
					return '<label id="' + m + '" display="inline-block">&nbsp;打开链接  ></label>';
				});
			}
			if (answerInfo.focus == "dialog") {
				replaced_play_text = replaced_play_text.replace(reg_url2, "打开链接");
				exec(taskHandler, 'replaceSpeech', [replaced_play_text]);
			} else if (answerInfo.focus == "app") {
				replaced_app_play_text = replaced_app_play_text.replace(reg_url2, "打开链接");
				exec(taskHandler, 'replaceAppSpeech', [replaced_app_play_text]);
			}
		}
		var picUrl = answerInfo.picUrl;
		if ((picUrl != "") && (picUrl != null) && ( typeof picUrl != "undefined")) {
			console.log("picUrl:" + picUrl);
			var food_img = document.createElement("img");
			food_img.src = picUrl;
			food_img.className = "css_dialog_answer_food_img";
			show_div.appendChild(food_img);
		}

		var donotNeedRepaint = false;

		answer_text.className = "css_answer_text_whith_share";
		answer_text.innerHTML = replaced_text;
		dialog_answer_text.appendChild(answer_text);
		// 除招呼语外都有分享播报按钮
		if (answerInfo.showShare) {
			if (answerInfo.type == "NORMAL") {
				var sharePlayDiv = createSharePlayView(answerInfo.taskHandler, false, 3);
				if (answerInfo.topic && answerInfo.topic.toLowerCase().indexOf("va_cqa_") >= 0) {
					sharePlayDiv.style.cssText = "display:inline-block;width:40%;text-align:right";
					var footer = document.createElement("div");
					footer.className = "css_dialog_answer_sharePlayDiv";
					footer.style.textAlign = "left";
					var sharePlayDiv = createSharePlayView(answerInfo.taskHandler, false, 3);
					sharePlayDiv.style.cssText = "display:inline-block;width:40%;text-align:right";

					var fromText = document.createElement("label");
					fromText.innerText = "来自互联网";
					fromText.style.cssText = "display:inline-block;vertical-align: middle;width:60%;";

					footer.appendChild(fromText);
					footer.appendChild(sharePlayDiv);
					dialog_answer_text.appendChild(footer);
					donotNeedRepaint = true;
		  } else if (cmcc_flag && answerInfo.topic 
						&& (answerInfo.topic === "chat_愚人节_讲笑话" || answerInfo.topic
							.toLowerCase().indexOf("chat_笑话") >= 0)){
				sharePlayDiv.style.cssText = "display:inline-block;width:40%;text-align:right";
				var footer = document.createElement("div");
				footer.className = "css_dialog_answer_sharePlayDiv";
				footer.style.textAlign = "left";
				var sharePlayDiv = createSharePlayView(answerInfo.taskHandler,
						false, 3);
				sharePlayDiv.style.cssText = "display:inline-block;width:40%;text-align:right";

				var fromText = document.createElement("label");
				fromText.innerText = "更多>>";
				fromText.style.cssText = "display:inline-block;vertical-align: middle;width:60%;";

				footer.appendChild(fromText);
				footer.appendChild(sharePlayDiv);
				dialog_answer_text.appendChild(footer);
				donotNeedRepaint = true;
				fromText.addEventListener("click", function() {
					console.log("chat_joking more click");
					exec(taskHandler, 'openJokingMore', []);
				}, false);
			} else {
					sharePlayDiv.className = "css_dialog_answer_sharePlayDiv";
					dialog_answer_text.appendChild(sharePlayDiv);
				}
			}
		}

		outDiv.appendChild(dialog_answer_canvas);
		outDiv.appendChild(dialog_answer_text);

		// 取消按钮
		if (answerInfo.cancelButtonShowTime > 0 && isChangingSkin == false) {
			touchObj = createBottomBtn(outDiv, "取消", function() {
				dismissAnswerCancelBtn();
				exec(taskHandler, 'cancelTask', []);
			});
		}
		// 搜索网页按钮
		else if (answerInfo.topic && answerInfo.topic.toLowerCase() == "unknown") {
			touchObj = createBottomBtn(outDiv, "上网搜索", function() {
				exec(answerInfo.taskHandler, 'searchWeb', []);
			});
		}

		show_div.appendChild(outDiv);
		document.body.appendChild(show_div);

		if (answerInfo.showProgressBar && isChangingSkin == false) {
			showProgressBar(answerInfo.taskHandler);
		}

		// clientHeight = 显示区域高度+padding
		var canvasHeight = dialog_answer_text.clientHeight;
		if (canvasHeight < dialog_box_canvs_minHeight) {
			canvasHeight = dialog_box_canvs_minHeight;
			dialog_answer_text.style.top = (dialog_box_canvs_minHeight - dialog_answer_text.clientHeight) / 2 + "px";
		}
		// console.log(dialog_answer_text.clientHeight);
		dialog_answer_canvas.setAttribute("height", canvasHeight + "px");

		draw(dialog_answer_canvas, img_dialog_ansew_bg, dialog_answer_bg_coordinates);
		var pop_bgBack = function() {
			reDraw(dialog_answer_canvas, img_dialog_ansew_bg, dialog_answer_bg_coordinates);
		};
		var pop_copy = function() {
			exec('WidgetMMPContainerComponents', 'copyAnswer', ["copy", answerInfo.answerText]);
		};
		var pop_share = function() {
			exec('WidgetMMPContainerComponents', 'copyAnswer', ["share", taskHandler]);
		};
		var pop_play = function() {
			exec('WidgetMMPContainerComponents', 'copyAnswer', ["play", taskHandler]);
		};

		var intevalId = null;
		var isOriginBg = true;
		var hasMoveMotion = false;
		outDiv.addEventListener("touchstart", function() {
			hasMoveMotion = false;
			moveOverCheck.start(event);
			if (isDialogFocus) {
				intevalId = setTimeout(function() {
					intevalId = null;
					// exec('WidgetMMPContainerComponents', 'copyAnswer',
					// [answerInfo.answerText,taskHandler]);
					// reDraw(dialog_answer_canvas, img_dialog_ansew_bg,
					// dialog_answer_bg_coordinates);

					if (float_layer == null) {
						createFloatLayer();
					}
					float_layer.setCallBack(pop_copy, pop_share, pop_play, pop_bgBack);
					float_layer.setPosition([outDiv.getBoundingClientRect().top, outDiv.getBoundingClientRect().bottom]);
					float_layer.show();

					isOriginBg = true;
				}, 1200);
				reDraw(dialog_answer_canvas, answer_bg_press, dialog_answer_bg_coordinates);
				isOriginBg = false;
			}
		}, false);
		outDiv.addEventListener("touchmove", function() {
			console.log("point value -- X:" + event.targetTouches[0].pageX + " Y: " + event.targetTouches[0].pageY);
			if (moveOverCheck.check(event)) {
				hasMoveMotion = true;
				if (isDialogFocus) {
					clearTimeout(intevalId);
					intevalId = null;
					reDraw(dialog_answer_canvas, img_dialog_ansew_bg, dialog_answer_bg_coordinates);
					isOriginBg = true;
				}
			}
		}, false);
		outDiv.addEventListener("touchend", function() {
			if (isDialogFocus) {
				if (intevalId != null) {
					clearTimeout(intevalId);
					reDraw(dialog_answer_canvas, img_dialog_ansew_bg, dialog_answer_bg_coordinates);
					isOriginBg = true;
					intevalId = null;
				}
			}
			if (hasMoveMotion == false) {
				exec(answerInfo.taskHandler, 'cancelTask', []);
			}
		}, false);

		show_div.refresh = function() {
			reDraw(dialog_answer_canvas, img_dialog_ansew_bg, dialog_answer_bg_coordinates);

			if (sharePlayDiv) {
				sharePlayDiv.refresh();
			}
		};

		if (answerInfo.showShare) {
			show_div.removeShare = function() {
				if (donotNeedRepaint) {
					footer.removeChild(sharePlayDiv);
				} else {
					dialog_answer_text.removeChild(sharePlayDiv);
					canvasHeight = dialog_answer_text.clientHeight;
					dialog_answer_canvas.setAttribute("height", canvasHeight + "px");
					reDraw(dialog_answer_canvas, img_dialog_ansew_bg, dialog_answer_bg_coordinates);
					refreshWeb();
					forceRefreshScreen();
				}
			};
			answerViewWithShare = show_div;
		}
		// 为网址div设置独一的id，并添加触摸事件
		if (answerInfo.focus == "dialog" || answerInfo.focus == "app") {
			if (results != null) {
				for (var i = 0; i < results.length; i++) {
					var tempid = results[i];
					var href_div = document.getElementById(tempid);
					var href_id = taskHandler + "  " + tempid;
					href_div.setAttribute("id", href_id);
					href_div.className = "css_href_div";
					href_id = href_div.id;
					href_div = richURLdiv(href_id, taskHandler);
				}
			}
		}

		if (answerInfo.showWelcomeList && focusListView == null && document.body.children.length <= 3) {
			// 添加功能列表时不用滚动
			setTimeout(function() {
				// if (answerInfo.welcomeListInfo != undefined) {
					// createFocusList(answerInfo.welcomeListInfo);
				// }

				if (answerInfo.listInfo != undefined) {
					createFocusList(answerInfo.listInfo);
				}
			}, 100);
		} else if (food_img != undefined && food_img != null) {
			scrollDown(document.body.scrollTop + window.screen.height - 10);
		} else {
			scrollToView(show_div);
		}
		showOpacityAnimation(show_div, 150);
		return show_div;
	}

	function richURLdiv(id, taskHandler) {
		var url_div = document.getElementById(id);

		// url_div.setAttribute("ontouchstart", "openstart('" + id + "')", false);
		// url_div.setAttribute("ontouchmove", "openmove('" + id + "')", false);
		// url_div.setAttribute("ontouchend", "openend('" + id + "','" + taskHandler + "')", false);

		
		url_div.addEventListener("touchstart",function(){
			openstart(id);
		},false);
		url_div.addEventListener("touchmove",function(){
			openmove(id);
		},false);
		url_div.addEventListener("touchend",function(){
			openend(id,taskHandler);
		},false);
		
		return url_div;
	}

	var bopenmove = false;
	function openstart(id) {
		var url_div = document.getElementById(id);
		url_div = event.target;
		moveOverCheck.start(event);
		url_div.className += " css_href_div_pressed";
		event.stopPropagation();
	}

	function openmove(id) {
		var url_div = document.getElementById(id);
		url_div = event.target;
		if (moveOverCheck.check(event)) {
			bopenmove = true;
			url_div.className = "css_href_div";
		}
		event.stopPropagation();
	}

	function openend(id, taskHandler) {
		var url_div = document.getElementById(id);
		url_div = event.target;
		url_div.className = "css_href_div";
		var reg_url = /\b([\d\w\.\/\+\-\?\:]*)((ht|f)tp(s|)\:\/\/|[\d\d\d|\d\d]\.[\d\d\d|\d\d]\.|www\.|\.tv|\.ac|\.com|\.edu|\.gov|\.int|\.mil|\.net|\.org|\.biz|\.info|\.name|\.pro|\.museum|\.co)([\d\w\.\/\%\+\-\=\&amp;\?\:\\\&quot;\'\,\|\~\;]*)\b/i;
		var matchresult = id.match(reg_url);
		// alert("bopenmove = " + bopenmove + " matchresult = " + matchresult);

		if (bopenmove) {
			bopenmove = false;
		} else {
			if (matchresult != null) {
				var href_url = matchresult[0];
				exec("WidgetMMPContainerComponents", 'openUrl', [href_url]);
			}
			event.stopPropagation();
		}
	}

	/**
	 * 创建底部按钮
	 */

	function createBottomBtn(parent, btnName, callback) {
		dialog_answer_cancel_btn = document.createElement("div");
		dialog_answer_cancel_btn.className = "css_dialog_answer_bottom_btn_div";
		dialog_answer_cancel_btn.style.height = dialog_title_canvas_height + "px";
		dialog_answer_cancel_btn.style.lineHeight = dialog_title_canvas_height + "px";

		var dialog_applist_btn_canvas = createBgCanvas(dialog_box_canvas_width);
		dialog_applist_btn_canvas.className = "css_dialog_absolute_bg";
		dialog_applist_btn_canvas.setAttribute("height", dialog_title_canvas_height + "px");

		var dialog_applist_btntext_div = document.createElement("div");
		dialog_applist_btntext_div.className = "css_dialog_bottom_btntext_div";
		dialog_applist_btntext_div.innerText = btnName;

		dialog_answer_cancel_btn.appendChild(dialog_applist_btn_canvas);
		dialog_answer_cancel_btn.appendChild(dialog_applist_btntext_div);

		parent.appendChild(dialog_answer_cancel_btn);

		var context_btn_canvas = dialog_applist_btn_canvas.getContext("2d");
		draw(dialog_applist_btn_canvas, img_dialog_btnnomal_bg, dialog_btn_bg_coordinates);

		var changeBg = function(press) {
			var img;
			if (press) {
				img = img_dialog_btnpressed_bg;
			} else {
				img = img_dialog_btnnomal_bg;
			}
			reDraw(dialog_applist_btn_canvas, img, dialog_btn_bg_coordinates);
		};

		dialog_answer_cancel_btn.addEventListener("touchstart", function(event) {
			changeBg(true);
			moveOverCheck.start(event);
		});
		dialog_answer_cancel_btn.addEventListener("touchmove", function(event) {
			if (moveOverCheck.check(event)) {
				changeBg(false);
			}
		});
		dialog_answer_cancel_btn.addEventListener("touchend", function(event) {
			changeBg(false);
			callback();
		});
	}

	/**
	 * 在界面上删除取消按钮，当界面跳转的时候由java回调或者定时时间过了之后由js定时器调用。
	 */
	function dismissAnswerCancelBtn() {
		console.log("dismissAnswerCancelBtn");

		if (dialog_answer_cancel_btn != null && dialog_answer_cancel_btn.parentNode != null) {
			removeChild(dialog_answer_cancel_btn.parentNode, dialog_answer_cancel_btn);
			dialog_answer_cancel_btn = null;
		}

		// 强制界面刷新，解决某些手机（如：G7，MIUI）上按钮不消失的问题
		forceRefreshScreen();
	}


	window.answerView = window.answerView || {};
	answerView.removeAnswerShare = removeAnswerShare;
	answerView.dismissAnswerCancelBtn = dismissAnswerCancelBtn;

	window.messagePushView = window.messagePushView || {};
	messagePushView.reloadMessagePushPic = reloadMessagePushPic;

	return showAnswer;
})