/**********应用列表View*********/
define(function() {
	function showList(listInfo) {
		return createAppListView(listInfo);
	}

	/**
	 * 创建列表项
	 *
	 * @param appId
	 *            列表项id
	 * @param appIcon
	 *            图标
	 * @param appName
	 *            名称
	 */
	function createListItem(appId, appIcon, appName) {
		var appImage = document.createElement("img");
		appImage.className = "css_dialog_list_appimg";
		appImage.src = appIcon;

		var applicationName = document.createElement("label");
		applicationName.className = "css_dialog_list_appname";
		applicationName.innerText = appName;

		var listItemDiv = document.createElement("div");
		listItemDiv.className = "css_dialog_list_item";
		listItemDiv.setAttribute("id", appId);
		listItemDiv.appendChild(appImage);
		listItemDiv.appendChild(applicationName);
		listItemDiv.addEventListener('touchstart', touchstartHandler, false);
		listItemDiv.addEventListener('touchmove', touchmoveHandler, false);
		listItemDiv.addEventListener('touchend', touchendHandler, false);
		return listItemDiv;
	}

	var oldelement;
	var move = false;
	var listTaskHandler;
	function createAppListView(listInfo) {
		listTaskHandler = listInfo.taskHandler;

		var outDiv = createOutDiv();
		if (enableAnimation && isChangingSkin == false) {
			outDiv.className += " css_dialog_opacity_animation";
		}

		var innerDiv = document.createElement("div");
		innerDiv.className = "css_dialog_list_inner";

		var listwraper = document.createElement("div");
		listwraper.className = "css_dialog_list_wrapbody";
		var listdiv = document.createElement("div");

		for (var i = 0, j = 1; i < listInfo.appList.length; i++, j++) {
			console.log(listInfo.appList[i].appName);
			var appListItem = createListItem("appItem" + i, listInfo.appList[i].appIcon, listInfo.appList[i].appName);
			listdiv.appendChild(appListItem);
			if (j < listInfo.appList.length) {
				var dialog_list_line = document.createElement("div");
				dialog_list_line.className = "css_dialog_divider_line";
				dialog_list_line.style.backgroundImage = "url('" + dialog_applist_divide_line + "')";
				listdiv.appendChild(dialog_list_line);
			}
		}
		listwraper.appendChild(listdiv);
		innerDiv.appendChild(listwraper);

		var dialog_applist_bottom_div = document.createElement("div");
		dialog_applist_bottom_div.className = "css_dialog_appList_bottom_btn_div";
		dialog_applist_bottom_div.style.height = dialog_title_canvas_height + "px";
		dialog_applist_bottom_div.style.lineHeight = dialog_title_canvas_height + "px";

		var dialog_applist_btn_canvas = createBgCanvas(dialog_box_canvas_width);
		dialog_applist_btn_canvas.className = "css_dialog_absolute_bg";
		dialog_applist_btn_canvas.setAttribute("height", dialog_title_canvas_height + "px");

		var dialog_applist_btntext_div = document.createElement("div");
		dialog_applist_btntext_div.className = "css_dialog_bottom_btntext_div";
		dialog_applist_btntext_div.innerText = "取 消";

		dialog_applist_bottom_div.appendChild(dialog_applist_btn_canvas);
		dialog_applist_bottom_div.appendChild(dialog_applist_btntext_div);

		outDiv.appendChild(innerDiv);
		outDiv.appendChild(dialog_applist_bottom_div);

		document.body.appendChild(outDiv);
		// 设计更改，固化显示应用列表
		/*
		 * listwraper.addEventListener('touchstart', touchstartHandler, false);
		 * listwraper.addEventListener('touchmove', touchmoveHandler, false);
		 * listwraper.addEventListener('touchend', touchendHandler, false);
		 *
		 * var listScroller = new iScroll(listwraper, { scrollbarClass :
		 * 'myScrollbar' });
		 */

		draw(dialog_applist_btn_canvas, img_dialog_btnnomal_bg, dialog_btn_bg_coordinates);

		dialog_applist_btntext_div.addEventListener("touchstart", function() {
			reDraw(dialog_applist_btn_canvas, img_dialog_btnpressed_bg, dialog_btn_bg_coordinates);
		}, false);
		dialog_applist_btntext_div.addEventListener("touchmove", function() {
			reDraw(dialog_applist_btn_canvas, img_dialog_btnnomal_bg, dialog_btn_bg_coordinates);
		}, false);
		dialog_applist_btntext_div.addEventListener("touchend", function() {
			reDraw(dialog_applist_btn_canvas, img_dialog_btnnomal_bg, dialog_btn_bg_coordinates);
			removeChild(document.body, outDiv);
			exec(listTaskHandler, 'cancel', []);
			exec('WidgetMMPContainerComponents', 'removeViewForJs', [listTaskHandler]);
		}, false);

		showOpacityAnimation(outDiv, 150);
		// 设置当前可删除view
		currentCanDeleteView = outDiv;

		outDiv.refresh = function() {
			reDraw(dialog_applist_btn_canvas, img_dialog_btnnomal_bg, dialog_btn_bg_coordinates);

			var lineElements = document.getElementsByClassName('css_dialog_divider_line');
			if (lineElements != null && lineElements.length > 0) {
				for (var i = 0; i < lineElements.length; i++) {
					lineElements[i].style.backgroundImage = "url('" + dialog_list_divider + "')";
				}
			}
		};

		return outDiv;
	}

	/**
	 * 触摸响应函数
	 *
	 * @param event
	 *            触摸事件
	 */
	function touchstartHandler(event) {
		var element = event.target;
		move = false;

		console.log('touchstart, event target element className is ' + element.className);
		if (element.className === 'css_dialog_list_appimg' || element.className === 'css_dialog_list_appname') {
			element.parentNode.style.backgroundImage = "url('" + list_item_background_pressed + "')";
			oldelement = element.parentNode;
		} else if (element.className === 'css_dialog_list_item') {
			element.style.backgroundImage = "url('" + list_item_background_pressed + "')";
			oldelement = element;
		}
		event.stopPropagation();

		moveOverCheck.start(event);
	}

	function touchmoveHandler(event) {
		console.log('touchmove');
		resetBackground();
		if (moveOverCheck.check(event)) {
			move = true;
		}
	}

	function resetBackground() {
		if (oldelement != null) {
			console.log('resetBackground, oldelement.className is ' + oldelement.className);
			oldelement.style.backgroundImage = '';
		}
	}

	function touchendHandler(event) {
		console.log('touchend, move is ' + move);
		event.stopPropagation();

		if (move) {
			return;
		}

		if (oldelement != null) {
			var id = oldelement.id;
			resetBackground();
			oldelement = null;
			setTimeout(function() {
				exec(listTaskHandler, 'intentApplication', [id]);
			}, 50);
		}
	}
	return showList;
})