/**
 * 拨打电话视图
 * 
 * @author leleliu008
 * @author modified by mdhuang 2013-3-22
 */
define(function() {
	function createCallView(callInfo) {
		// 准备数据
		var contactIconUrl = callInfo.contactIconUrl;
		var contactMarkedPhoneNum = callInfo.contactPhone;
		var contactPhoneArr = contactMarkedPhoneNum.split("^");

		var contactPhonePre = "";
		var contactPhoneNum = "";
		if (contactPhoneArr.length > 1) {
			contactPhonePre = contactPhoneArr[0];
			contactPhoneNum = contactPhoneArr[1];
		} else {
			contactPhoneNum = contactPhoneArr[0];
		}

		var contactPhoneFlag = callInfo.contactPhoneFlag;
		var contactOnlyNum = callInfo.contactOnlyNum;
		if (contactPhoneFlag) {
			var s = contactPhoneNum.substring(0, 3) + " "
					+ contactPhoneNum.substring(3, 7) + " "
					+ contactPhoneNum.substring(7);
			contactPhoneNum = s;
		}

		var outDiv = createOutDiv();

		// 大背景
		var dialog_call_bg = createBgCanvas(dialog_box_canvas_width);
		dialog_call_bg.className = "css_dialog_absolute_bg";

		// 真正放东西的容器
		var dialog_call_inner_div = document.createElement("div");
		dialog_call_inner_div.className = "css_dialog_call_inner_div";

		var dialog_call_icon_container = document.createElement("div");
		dialog_call_icon_container.className = "css_dialog_call_contact_icon_container";

		// 联系人图标
		var dialog_call_contact_icon = document.createElement("img");
		dialog_call_contact_icon.className = "css_dialog_call_contact_icon";
		dialog_call_icon_container.appendChild(dialog_call_contact_icon);

		// 如果传递过来的联系人图标的url不存在，就使用默认的
		if (contactIconUrl == null || contactIconUrl == "") {
			dialog_call_contact_icon.src = dialog_contact_icon;
		} else {
			dialog_call_contact_icon.src = contactIconUrl;

			// 联系人图标相框
			var dialog_call_contact_icon_frame = document.createElement("img");
			dialog_call_contact_icon_frame.className = "css_dialog_call_contact_icon_frame";
			dialog_call_contact_icon_frame.src = dialog_contact_icon_frame;
			dialog_call_icon_container
					.appendChild(dialog_call_contact_icon_frame);
		}

		// 联系人信息容器，包括联系人姓名和联系人号码
		var contactInfoContainer = document.createElement("div");
		contactInfoContainer.className = "css_dialog_call_contact_info";

		// 联系人姓名
		var callContactName = document.createElement("div");
		callContactName.className = "css_dialog_call_contact_name";
		// callContactName.innerText = "张旭"
		if (contactOnlyNum) {
			callContactName.innerText = "未知号码";
		} else {
			callContactName.innerText = callInfo.contactName;
		}

		// 联系人号码
		var callContactNum = document.createElement("div");
		callContactNum.className = "css_dialog_call_contact_num";
		// callContactNum.innerText = "152 0336 5568";
		if (contactPhonePre !== "") {
			contactPhoneNum = contactPhonePre + " " + contactPhoneNum;
		}
		callContactNum.innerText = contactPhoneNum;

		contactInfoContainer.appendChild(callContactName);
		contactInfoContainer.appendChild(callContactNum);

		// 正在加载启动打电话面板的图标
		var dialog_call_loading_canvas = document.createElement("canvas");
		dialog_call_loading_canvas.className = "css_dialog_call_loading_icon";
		dialog_call_loading_canvas.setAttribute("width",
				dialog_call_loading_icon_width + "px");
		dialog_call_loading_canvas.setAttribute("height",
				dialog_call_loading_icon_height + "px");

		dialog_call_inner_div.appendChild(dialog_call_icon_container);
		dialog_call_inner_div.appendChild(contactInfoContainer);
		dialog_call_inner_div.appendChild(dialog_call_loading_canvas);

		// 取消面板
		var dialog_call_cancel_div = document.createElement("div");
		dialog_call_cancel_div.className = "css_dialog_appList_bottom_btn_div";
		dialog_call_cancel_div.style.height = dialog_title_canvas_height + "px";
		dialog_call_cancel_div.style.lineHeight = dialog_title_canvas_height + "px";

		var dialog_call_cancel_canvas = createBgCanvas(dialog_box_canvas_width);
		dialog_call_cancel_canvas.className = "css_dialog_absolute_bg";
		dialog_call_cancel_canvas.setAttribute("height", dialog_title_canvas_height + "px");

		var dialog_call_canceltext_div = document.createElement("div");
		dialog_call_canceltext_div.className = "css_dialog_bottom_btntext_div";
		dialog_call_canceltext_div.innerText = "取  消";

		dialog_call_cancel_div.appendChild(dialog_call_cancel_canvas);
		dialog_call_cancel_div.appendChild(dialog_call_canceltext_div);

		outDiv.appendChild(dialog_call_bg);
		outDiv.appendChild(dialog_call_inner_div);
		outDiv.appendChild(dialog_call_cancel_div);

		document.body.appendChild(outDiv);

		var rotatedId = startRotate(dialog_call_loading_canvas);

		var canvasHeight = dialog_call_inner_div.clientHeight;
		dialog_call_bg.setAttribute("height", canvasHeight + "px");

		// 设置大背景图片
		draw(dialog_call_bg, dialogmode_contact_bg, dialog_view_bg_coordinates);

		// 取消按钮背景图片设置
		draw(dialog_call_cancel_canvas, img_dialog_btnnomal_bg,
				dialog_btn_bg_coordinates);

		// 设置当前可删除view
		currentCanDeleteView = outDiv;

		var touchObj = {
			touchStart : function(event) {
				reDraw(dialog_call_cancel_canvas, img_dialog_btnpressed_bg,
						dialog_btn_bg_coordinates);
			},
			touchMove : function() {
				reDraw(dialog_call_cancel_canvas, img_dialog_btnnomal_bg,
						dialog_btn_bg_coordinates);
			},
			touchEnd : function() {
				reDraw(dialog_call_cancel_canvas, img_dialog_btnnomal_bg,
						dialog_btn_bg_coordinates);
			}
		};

		enableScrollTouch(dialog_call_canceltext_div, 15, touchObj);
		var taskHandler = callInfo.taskHandler;
		dialog_call_canceltext_div.addEventListener("scrolltouch", function() {
			removeChild(document.body, outDiv);
			currentCanDeleteView = null;
			exec(taskHandler, 'cancelCall', []);
			forceRefreshScreen();
			// 调用java函数释放相关资源
			exec('WidgetMMPContainerComponents', 'removeViewForJs',
					[ taskHandler ]);
		}, false);

		outDiv.refresh = function() {
			reDraw(dialog_call_bg, dialogmode_contact_bg,
					dialog_view_bg_coordinates);
			reDraw(dialog_call_cancel_canvas, img_dialog_btnnomal_bg,
					dialog_btn_bg_coordinates);
		};

		return outDiv;
	}
	
	return createCallView;
});