/*************************新建联系人View***************************/

define(function(){
	/**
	 * 创建新建联系人视图
	 */
	var isContactNameEmpty = false;
	var isPhoneNumberEmpty = false;
	function createContactCreateView(contactInfo) {
		var taskHandler = contactInfo.taskHandler;
	
		var contactName = contactInfo.contactName;
		var contactNumber = contactInfo.contactNumber;
	
		if (contactName == "") {
			isContactNameEmpty = true;
		} else {
			isContactNameEmpty = false;
		}
	
		if (contactNumber == "") {
			isPhoneNumberEmpty = true;
		} else {
			isPhoneNumberEmpty = false;
		}
	
		var container = createOutDiv();
	
		// 背景层
		var bg_canvas = createBgCanvas(dialog_box_canvas_width);
		bg_canvas.className = "css_dialog_absolute_bg";
	
		// 真正的盛放内容的容器
		var inner_div = document.createElement("div");
		inner_div.className = "css_dialog_contact_create_inner_container";
	
		// 联系人姓名容器
		var contactNameContainer = createContactCreateItem(taskHandler, taskHandler
				+ "contactName", "姓名：", contactName, "text", isContactNameEmpty);
	
		// 姓名和号码的分割线
		var seperator_line = createRestaurantDivier();
	
		// 联系人号码容器
		var contactNumberContainer = createContactCreateItem(taskHandler,
				taskHandler + "contactNumber", "号码：", contactNumber, "tel",
				isPhoneNumberEmpty);
	
		inner_div.appendChild(contactNameContainer);
		inner_div.appendChild(seperator_line);
		inner_div.appendChild(contactNumberContainer);
	
		// 按钮容器
		var buttonContainer = document.createElement("div");
		buttonContainer.className = "css_dialog_remind_bottom_btn_div";
	
		// 保存按钮背景层
		var saveButtonBgCanvas = createBgCanvas(dialog_remind_btn_canvas_width);
		saveButtonBgCanvas.className = "css_dialog_absolute_right_bg";
		saveButtonBgCanvas.setAttribute("height", dialog_remind_btn_canvas_height + "px");
		saveButtonBgCanvas.id = taskHandler + "contactCreateSaveButton";
	
		// 取消按钮背景层
		var cancelButtonBgCanvas = createBgCanvas(dialog_remind_btn_canvas_width);
		cancelButtonBgCanvas.setAttribute("height", dialog_remind_btn_canvas_height + "px");
		cancelButtonBgCanvas.className = "css_dialog_absolute_bg";
	
		var buttonTextContainer = document.createElement("div");
		buttonTextContainer.className = "css_dialog_bottom_btntext_div";
		buttonTextContainer.style.height = dialog_remind_btn_canvas_height + "px";
		buttonTextContainer.style.lineHeight = dialog_remind_btn_canvas_height + "px";
	
		// 保存按钮
		var saveButton = createButtonDiv(dialog_remind_btn_canvas_width,
				dialog_remind_btn_canvas_height, "保  存");
		saveButton.id = taskHandler + "SaveButton";
		// 取消按钮
		var cancelButton = createButtonDiv(dialog_remind_btn_canvas_width,
				dialog_remind_btn_canvas_height, "取  消");
		cancelButton.className = "css_dialog_remind_bottom_btncanvas_confirm";
	
		buttonTextContainer.appendChild(cancelButton);
		buttonTextContainer.appendChild(saveButton);
	
		buttonContainer.appendChild(cancelButtonBgCanvas);
		buttonContainer.appendChild(saveButtonBgCanvas);
		buttonContainer.appendChild(buttonTextContainer);
	
		container.appendChild(bg_canvas);
		container.appendChild(inner_div);
		container.appendChild(buttonContainer);
	
		document.body.appendChild(container);
		currentCanDeleteView = container;
	
		// 设置背景层的高度
		var canvasHeight = inner_div.clientHeight;
		bg_canvas.setAttribute("height", canvasHeight + "px");
		console.log("canvasHeight:" + canvasHeight);
	
		// 计算设置背景图片
		draw(bg_canvas, dialogmode_contact_bg, dialog_view_bg_coordinates);
	
		// 计算和设置取消按钮的背景图片
		draw(cancelButtonBgCanvas, img_dialog_btnnomal_bg,
				dialog_btn_bg_coordinates);
	
		// 姓名和号码同时为空时才不可点击
		if (isContactNameEmpty && isPhoneNumberEmpty) {
			saveButton.className = "css_dialog_btn_disabled";
			draw(saveButtonBgCanvas, img_dialog_btndisabled_bg,
					dialog_btn_bg_coordinates);
		} else {
			saveButton.className = "css_dialog_btn_normal";
			draw(saveButtonBgCanvas, img_dialog_btnnomal_bg,
					dialog_btn_bg_coordinates);
		}
	
		// 取消按钮事件监听
		cancelButton.addEventListener("touchstart", function() {
			reDraw(cancelButtonBgCanvas, img_dialog_btnpressed_bg,
					dialog_btn_bg_coordinates);
		}, false);
	
		cancelButton.addEventListener("touchend", function() {
			reDraw(cancelButtonBgCanvas, img_dialog_btnnomal_bg,
					dialog_btn_bg_coordinates);
			removeChild(document.body, container);
			// 调用java函数执行取消操作
			exec(taskHandler, 'contactCancel', []);
		}, false);
		// 保存按钮事件监听
		saveButton.addEventListener("touchstart", function() {
			// 只有不为空才有按下效果
			if (isContactNameEmpty != true || isPhoneNumberEmpty != true) {
				reDraw(saveButtonBgCanvas, img_dialog_btnpressed_bg,
						dialog_btn_bg_coordinates);
			}
		}, false);
	
		saveButton.addEventListener("touchend", function() {
			console.log("---------->>> isContactNameEmpty:" + isContactNameEmpty);
			console.log("---------->>> isPhoneNumberEmpty:" + isPhoneNumberEmpty);
			if (isContactNameEmpty != true || isPhoneNumberEmpty != true) {
				reDraw(saveButtonBgCanvas, img_dialog_btnnomal_bg,
						dialog_btn_bg_coordinates);
	
				var contactNameText = document.getElementById(taskHandler
						+ "contactName").value;
				var phoneNumberText = document.getElementById(taskHandler
						+ "contactNumber").value;
				// 操作完成后将自己销毁
				removeChild(document.body, container);
				// 调用java函数执行保存操作
				exec(taskHandler, 'contactSave',
						[ contactNameText, phoneNumberText ]);
			}
		}, false);
		// 换肤刷新
		container.refresh = function() {
			reDraw(bg_canvas, dialogmode_contact_bg, dialog_view_bg_coordinates);
			reDraw(cancelButtonBgCanvas, img_dialog_btnnomal_bg,
					dialog_btn_bg_coordinates);
	
			if (isContactNameEmpty != true || isPhoneNumberEmpty != true) {
				reDraw(saveButtonBgCanvas, img_dialog_btnnomal_bg,
						dialog_btn_bg_coordinates);
			} else {
				reDraw(saveButtonBgCanvas, img_dialog_btndisabled_bg,
						dialog_btn_bg_coordinates);
			}
			seperator_line.style.backgroundImage = "url('" + dialog_list_divider
					+ "')";
	
			contactNameContainer.refresh();
			contactNumberContainer.refresh();
		};
	
		return container;
	}
	
	/**
	 * 联系人创建前两个条目
	 */
	function createContactCreateItem(taskHandler, editTextId, labelText, editText,
			inputType) {
		var container = document.createElement("div");
		container.className = "css_dialog_contact_create_item";
	
		// 创建label
		var lableContainer = document.createElement("span");
		lableContainer.innerText = labelText;
		lableContainer.className = "css_dialog_contact_create_item_label";
	
		var editTextContainer = document.createElement("div");
		editTextContainer.className = "css_dialog_contact_create_item_editText_container";
	
		// 编辑框的背景层
		var editTextBgCanvas = createBgCanvas(dialog_contact_create_editTextBgCanvas_width);
		editTextBgCanvas.className = "css_dialog_absolute_bg";
		editTextBgCanvas.setAttribute("height",
				dialog_contact_create_editTextBgCanvas_height + "px");
	
		draw(editTextBgCanvas, dialogmode_contact_create_content_bg,
				dialogmode_contact_create_content_bg_coordinates);
	
		// 创建文本框
		var editTextWidget = document.createElement("input");
		editTextWidget.id = editTextId;
		editTextWidget.type = inputType;
		editTextWidget.maxLength = 32;
		editTextWidget.value = editText;
		editTextWidget.style.border = "none";
		editTextWidget.className = "css_dialog_contact_create_item_editText";
		// editTextWidget.addEventListener("input", function() {
		// console.log('input begin, text value length is '
		// + editTextWidget.value.length);
		// var saveButton = document.getElementById(taskHandler + "SaveButton");
		// if (editTextWidget.value.length > 0) {
		// if (inputType === "text") {
		// isContactNameEmpty = false;
		// } else if (inputType === "tel") {
		// isPhoneNumberEmpty = false;
		// }
		// if (isContactNameEmpty != true || isPhoneNumberEmpty != true) {
		// saveButton.className = "css_dialog_btn_normal";
		// var saveButtonContext = document.getElementById(
		// taskHandler + "contactCreateSaveButton").getContext(
		// "2d");
		// paintButtonBg(saveButtonContext, img_dialog_btnnomal_bg,
		// img_dialog_btnnomal_bg.width,
		// img_dialog_btnnomal_bg.height,
		// dialog_btn_bg_coordinates,
		// dialog_remind_btn_canvas_width,
		// dialog_remind_btn_canvas_height);
		// }
		// } else {
		// if (inputType === "text") {
		// isContactNameEmpty = true;
		// } else if (inputType === "tel") {
		// isPhoneNumberEmpty = true;
		// }
		// if (isContactNameEmpty == true && isPhoneNumberEmpty == true) {
		// saveButton.className = "css_dialog_btn_disabled";
		// var saveButtonContext = document.getElementById(
		// taskHandler + "contactCreateSaveButton").getContext(
		// "2d");
		// paintButtonBg(saveButtonContext, img_dialog_btndisabled_bg,
		// img_dialog_btndisabled_bg.width,
		// img_dialog_btndisabled_bg.height,
		// dialog_btn_bg_coordinates,
		// dialog_remind_btn_canvas_width,
		// dialog_remind_btn_canvas_height);
		// }
		// }
		// // 强制刷新
		// forceRefreshScreen();
		// }, false);
	
		var hintText = "姓名";
		if (inputType == "tel") {
			hintText = "电话";
		}
		editTextWidget.addEventListener("click", function() {
			console.log('onclick begin');
			// 停止语音交互流程
			// exec(taskHandler, 'stopVoiceInteraction', []);
			exec("WidgetMMPContainerComponents", 'inputEdit', [ "contacts",
					taskHandler, editTextWidget.value, inputType, hintText ]);
		}, false);
	
		editTextContainer.appendChild(editTextBgCanvas);
		editTextContainer.appendChild(editTextWidget);
	
		container.appendChild(lableContainer);
		container.appendChild(editTextContainer);
	
		// 编辑框的背景层
		var editTextBgCanvas = createBgCanvas(dialog_contact_create_editTextBgCanvas_width);
		// editTextBgCanvas.className =
		// "css_dialog_contact_create_item_editText_bgCanvas";
		editTextBgCanvas.setAttribute("height",
				dialog_contact_create_editTextBgCanvas_height + "px");
	
		container.refresh = function() {
			reDraw(editTextBgCanvas, dialogmode_contact_create_content_bg,
					dialogmode_contact_create_content_bg_coordinates);
		};
		return container;
	}
	
	function onContactCancel(taskHandler, editType) {
		if (editType === "text") {
			document.getElementById(taskHandler + "contactName").blur();
		} else {
			document.getElementById(taskHandler + "contactNumber").blur();
		}
		document.body.focus();
	}
	function onContactResult(taskHandler, content, editType) {
		var isConfirmOriginal = isContactNameEmpty && isPhoneNumberEmpty;
		if (editType === "text") {
			console.log("text content is " + content);
			if (content === "") {
				isContactNameEmpty = true;
			} else {
				isContactNameEmpty = false;
			}
			document.getElementById(taskHandler + "contactName").value = content;
			// 解决点击后input框获取焦点，而事件加在外部的container上，造成container无法获取焦点，事件没有响应
			setTimeout(function() {
				document.getElementById(taskHandler + "contactName").blur();
				document.body.focus();
			}, 250);
			// document.getElementById(taskHandler+"contactName").blur();
			// document.body.focus();
		} else if (editType === "tel") {
			console.log("tel content is " + content);
			if (content === "") {
				isPhoneNumberEmpty = true;
			} else {
				isPhoneNumberEmpty = false;
			}
			document.getElementById(taskHandler + "contactNumber").value = content;
			setTimeout(function() {
				document.getElementById(taskHandler + "contactNumber").blur();
				document.body.focus();
			}, 250);
			// document.getElementById(taskHandler+"contactNumber").blur();
			// document.body.focus();
		}
		var isConfirmNew = isContactNameEmpty && isPhoneNumberEmpty;
		if (isConfirmOriginal !== isConfirmNew) {
			var saveButton = document.getElementById(taskHandler + "SaveButton");
			var saveButtonCanvas = document.getElementById(taskHandler
					+ "contactCreateSaveButton");
			if (isContactNameEmpty && isPhoneNumberEmpty) {
				saveButton.className = "css_dialog_btn_disabled";
				reDraw(saveButtonCanvas, img_dialog_btndisabled_bg,
						dialog_btn_bg_coordinates);
			} else {
				saveButton.className = "css_dialog_btn_normal";
				reDraw(saveButtonCanvas, img_dialog_btnnomal_bg,
						dialog_btn_bg_coordinates);
			}
			forceRefreshScreen();
		}
	}
	
	window.contactCreateView = window.contactCreateView || {};
	contactCreateView.onContactResult = onContactResult;
	contactCreateView.onContactCancel = onContactCancel;
	
	return createContactCreateView;
});