/**
 * 搜索联系人视图
 * 
 * @author leleliu008
 * @author modified by mdhuang 2013-3-22
 */
define(function() {
	function createContactSearchListView(contactSetInfo) {
		var taskHandler = contactSetInfo.taskHandler;

		var container = createOutDiv();

		// 背景层
		var bg_canvas = createBgCanvas(dialog_box_canvas_width);
		bg_canvas.className = "css_dialog_absolute_bg";

		// 真正的盛放内容的容器
		var inner_div = document.createElement("div");
		inner_div.className = "css_dialog_contact_search_inner_div";

		var dialog_phone_title_div = createContactItem("",
				contactSetInfo.contactName, contactSetInfo.contactIconUri,
				"css_dialog_contact_search_title_container");
		inner_div.appendChild(dialog_phone_title_div);

		var contactTagAndNumberArray = contactSetInfo.contactTagAndNumberArray;
		var size = contactTagAndNumberArray.length;
		if (size == 1) {
			var item = createContactNumberItem("contactSearch0",
					contactTagAndNumberArray[0].isMobileNumber,
					contactTagAndNumberArray[0].contactTag,
					contactTagAndNumberArray[0].contactNumber,
					"contactSearch_left_0", "contactSearch_right_0", null);
			inner_div.appendChild(createRestaurantDivier());
			inner_div.appendChild(item);
		} else {
			for ( var i = 0; i < size; i++) {
				// var item = createContactNumberItem(taskHandler,
				// "contactSearch" +
				// i, "contactSearch_left_" + i, "contactSearch_right_" + i,
				// contactSetInfo.contactName,
				// contactTagAndNumberArray[i].contactNumber,
				// contactTagAndNumberArray[i].isMobileNumber,
				// contactTagAndNumberArray[i].contactTag);
				var item = createContactNumberItem("contactSearch" + i,
						contactTagAndNumberArray[i].isMobileNumber,
						contactTagAndNumberArray[i].contactTag,
						contactTagAndNumberArray[i].contactNumber,
						"contactSearch_left_" + i, "contactSearch_right_" + i,
						null);
				console.log("add create contact item");
				inner_div.appendChild(createRestaurantDivier());
				inner_div.appendChild(item);
			}
		}

		container.appendChild(bg_canvas);
		container.appendChild(inner_div);

		document.body.appendChild(container);
		currentCanDeleteView = container;

		// 设置背景层的高度
		var canvasHeight = inner_div.clientHeight;
		bg_canvas.setAttribute("height", canvasHeight + "px");
		console.log("canvasHeight:" + canvasHeight);

		// 计算
		draw(bg_canvas, dialogmode_contact_bg, dialog_view_bg_coordinates);

		// 设置当前可删除view
		currentCanDeleteView = container;

		var touchObj = {
			returnArgument : null,
			touchElement : null,
			touchStart : function(event) {
				this.touchElement = getParentOfClass(
						"css_dialog_contact_search_item_lr_container",
						event.target);
				if (this.touchElement != null) {
					this.touchElement.style.background = "url('"
							+ list_item_background_pressed + "')";
				}
			},
			touchMove : function() {
				if (this.touchElement != null) {
					this.touchElement.style.background = "";
				}
			},
			touchEnd : function() {
				if (this.touchElement != null) {
					this.touchElement.style.background = "";
					this.returnArgument = this.touchElement.id;
					console.log("get touch element id " + this.returnArgument);
				}
				this.touchElement = null;
			}
		};
		enableScrollTouch(inner_div, 15, touchObj);
		inner_div.addEventListener("scrolltouch", function() {
			removeChild(document.body, container);
			forceRefreshScreen();
			currentCanDeleteView = null;
			exec(taskHandler, 'contactSearchItemClick',
					[ touchObj.returnArgument ]);
			touchObj.returnArgument = null;
		}, false);
		// 换肤刷新
		container.refresh = function() {
			draw(bg_canvas, dialogmode_contact_bg, dialog_view_bg_coordinates);

			// 刷新分割线
			var lineElements = document
					.getElementsByClassName('css_dialog_restaurant_divider_line');
			if (lineElements != null && lineElements.length > 0) {
				for ( var i = 0; i < lineElements.length; i++) {
					lineElements[i].style.backgroundImage = "url('"
							+ dialog_list_divider + "')";
				}
			}
		};

		return container;
	}
	
	return createContactSearchListView;
});