/**
 * 联系人列表视图
 * 
 * @author leleliu008
 * @author modified by mdhuang 2013-3-22
 */
define(function() {
	function createContactOrder(contactOrder) {
		var orderContainer = document.createElement("div");
		orderContainer.className = "css_contact_order_container";
		var orderBg = document.createElement("img");
		orderBg.className = "css_contact_order_bg";
		orderBg.src = contact_order_bg;
		var orderText = document.createElement("label");
		orderText.innerText = contactOrder;
		orderText.className = "css_contact_order_text";
		orderContainer.appendChild(orderBg);
		orderContainer.appendChild(orderText);
		return orderContainer;
	}
	function createContactItemWhithOrder(itemOrder, contactNameId,
			contactNameStr, contactIconSrc, containerStyle) {
		var orderItem = createContactItem(contactNameId, contactNameStr,
				contactIconSrc, containerStyle);
		var order = createContactOrder(itemOrder);
		orderItem.appendChild(order);
		return orderItem;
	}
	function createContactView(contactInfo) {
		var contactNameList = contactInfo.contactNameList;
		var contactIconList = contactInfo.contactIconList;
		var taskHandler = contactInfo.taskHandler;

		var outDiv = createOutDiv();
		var dialog_contact_canvas = createBgCanvas(dialog_box_canvas_width);
		dialog_contact_canvas.className = "css_dialog_absolute_bg";

		var dialog_contact_inner_div = document.createElement("div");
		dialog_contact_inner_div.className = "css_dialog_contact_inner_div";

		for ( var i = 0; i < contactNameList.length; i++) {
			var contactItem = createContactItemWhithOrder(i + 1, "contactItem"
					+ i, contactNameList[i], contactIconList[i]);
			dialog_contact_inner_div.appendChild(contactItem);
			if (i < contactNameList.length - 1) {
				dialog_contact_inner_div.appendChild(createRestaurantDivier());
			}
		}

		outDiv.appendChild(dialog_contact_canvas);
		outDiv.appendChild(dialog_contact_inner_div);

		document.body.appendChild(outDiv);

		var canvasHeight = dialog_contact_inner_div.clientHeight;
		dialog_contact_canvas.setAttribute("height", canvasHeight + "px");
		console.log("canvasHeight:" + canvasHeight);

		// 设置大背景图片
		draw(dialog_contact_canvas, dialogmode_contact_bg,
				dialog_view_bg_coordinates);

		// 设置当前可删除view
		currentCanDeleteView = outDiv;
		var touchObj = {
			returnArgument : null,
			touchElement : null,
			touchStart : function(event) {
				this.touchElement = getParentOfClass("css_dialog_contact_item",
						event.target);
				if (this.touchElement != null) {
					this.touchElement.style.background = "url('"
							+ list_item_background_pressed + "')";
				}
				// if(event.target.className == "css_dialog_contact_item") {
				// this.touchElement = event.target;
				// this.touchElement.style.background = "green";
				// }
			},
			touchMove : function() {
				if (this.touchElement != null) {
					this.touchElement.style.background = "";
				}
			},
			touchEnd : function() {
				if (this.touchElement != null) {
					this.touchElement.style.background = "";
					this.returnArgument = this.touchElement.id;
					console.log("get touch element id " + this.returnArgument);
				}
				this.touchElement = null;
			}
		};
		enableScrollTouch(dialog_contact_inner_div, 15, touchObj);

		dialog_contact_inner_div.addEventListener("scrolltouch", function() {
			removeChild(document.body, outDiv);
			forceRefreshScreen();
			currentCanDeleteView = null;
			exec(taskHandler, 'contactItemClick', [ touchObj.returnArgument ]);
		}, false);

		outDiv.refresh = function() {
			// 背景
			reDraw(dialog_contact_canvas, dialogmode_contact_bg,
					dialog_view_bg_coordinates);

			// 分割线
			var lineElements = document
					.getElementsByClassName('css_dialog_restaurant_divider_line');
			if (lineElements != null && lineElements.length > 0) {
				for ( var i = 0; i < lineElements.length; i++) {
					lineElements[i].style.backgroundImage = "url('"
							+ dialog_list_divider + "')";
				}
			}
		};

		return outDiv;
	}
	
	return createContactView;
});