define(function() {
	function createDriveCreditQueryView(driverInfo) {
		var remember = true;
		var outDiv = createOutDiv();
		var credit_bg = createBgCanvas(dialog_box_canvas_width);
		credit_bg.className = "css_driver_credit_bg";

		var credit_inner = document.createElement("div");
		credit_inner.className = "css_driver_credit_inner";

		var credit_title = document.createElement("div");
		credit_title.className = "css_driver_credit_query_title";
		credit_title.innerText = "驾驶员积分查询";

		var input_block = document.createElement("div");
		input_block.className = "css_driver_credit_input_block";
		var input_inner = document.createElement("div");
		input_inner.className = "css_driver_credit_input_inner";
		var input_bg = document.createElement("canvas");
		input_bg.className = "css_driver_credit_input_bg";

		var inputItemUp = document.createElement("div");
		inputItemUp.className = "css_driver_credit_input_item";
		var inputItemDown = document.createElement("div");
		inputItemDown.className = "css_driver_credit_input_item";

		var inLabelUp = document.createElement("label");
		inLabelUp.className = "css_driver_credit_query_label";
		inLabelUp.innerText = "姓名：";
		var inBoxUp = document.createElement("input");
		inBoxUp.className = "css_driver_credit_query_input";
		inBoxUp.setAttribute("placeholder", "请输入姓名");
		inputItemUp.appendChild(inLabelUp);
		inputItemUp.appendChild(inBoxUp);

		var inLabelDown = document.createElement("label");
		inLabelDown.innerText = "驾驶证号：";
		inLabelDown.className = "css_driver_credit_query_label";
		var inBoxDown = document.createElement("input");
		inBoxDown.className = "css_driver_credit_query_input";
		inBoxDown.setAttribute("placeholder", "请输入驾驶证号码");
		inputItemDown.appendChild(inLabelDown);
		inputItemDown.appendChild(inBoxDown);

		if(false==driverInfo.isSimple){
			inBoxUp.value = driverInfo.driverName;
			inBoxDown.value = driverInfo.licenseNo;
		}

		var inputDivider = document.createElement("div");
		inputDivider.className = "css_driver_credit_input_divider";

		input_inner.appendChild(inputItemUp);
		input_inner.appendChild(inputDivider);
		input_inner.appendChild(inputItemDown);

		input_block.appendChild(input_inner);
		input_block.appendChild(input_bg);

		var rememberBlock = document.createElement("div");
		rememberBlock.className = "css_driver_remember";

		var checkBox = document.createElement("img");
		checkBox.className = "css_driver_remember_check_box";
		checkBox.src = vehicle_query_checkbox_checked;

		var checkFlag = document.createElement("label");
		checkFlag.className = "css_driver_remember_check_flag";
		checkFlag.innerText = "记住证件信息";

		rememberBlock.appendChild(checkBox);
		rememberBlock.appendChild(checkFlag);

		var errorBlock = document.createElement("div");
		errorBlock.className = "css_driver_error";
		var errorIcon = document.createElement("img");
		errorIcon.className = "css_driver_error_icon";
		errorIcon.src = vehicle_error_prompt;
		var errorFlag = document.createElement("label");
		errorFlag.className = "css_driver_error_flag";
		errorFlag.innerText = "信息格式正确";

		errorBlock.appendChild(errorIcon);
		errorBlock.appendChild(errorFlag);

		var buttonBlock = document.createElement("div");
		buttonBlock.className = "css_driver_credit_button_block";
		var buttonCanvas = document.createElement("canvas");
		buttonCanvas.className = "css_driver_credit_input_bg"
		var buttonText = document.createElement("div");
		buttonText.className = "css_driver_credit_button_text";
		buttonText.innerText = "查询";

		buttonBlock.appendChild(buttonCanvas);
		buttonBlock.appendChild(buttonText);

		credit_inner.appendChild(credit_title);
		credit_inner.appendChild(input_block);
		credit_inner.appendChild(rememberBlock);
		credit_inner.appendChild(errorBlock);
		credit_inner.appendChild(buttonBlock);
		
		//蒙层，防止查询过程中点击进行编辑和再次查询
		var coverLayer = document.createElement("div");
    	coverLayer.className = "css_driver_credit_cover";

		outDiv.appendChild(credit_bg);
		outDiv.appendChild(credit_inner);
		outDiv.appendChild(coverLayer);

		document.body.appendChild(outDiv);

		credit_bg.setAttribute("height", credit_inner.clientHeight + "px");

		input_bg.setAttribute("width", input_inner.clientWidth + "px");
		input_bg.setAttribute("height", input_inner.clientHeight + "px");

		buttonCanvas.setAttribute("width", buttonText.clientWidth + "px");
		buttonCanvas.setAttribute("height", buttonText.clientHeight + "px");

		draw(credit_bg, dialogmode_contact_bg, dialog_view_bg_coordinates);
		draw(input_bg, dialogmode_vehicle_content_input_bg, dialogmode_vehicle_content_input_bg_coordinates);
		draw(buttonCanvas, vehicle_query_button_backgroud_normal, vehicle_query_button_backgroud_normal_coordinates);
		
		// 设置当前可删除view
		currentCanDeleteView = outDiv;
		driverQueryView = outDiv;
		
		var isMove = false;
		var queryClickable = true;
		inBoxUp.addEventListener("click",function(){
			if (queryClickable){
				inBoxUp.blur();
				exec("WidgetMMPContainerComponents", 'inputEdit', [ "driver_point",
						driverInfo.taskHandler, inBoxUp.value, 'inBoxUp', "姓名" ]);
			}
		},false);
		inBoxDown.addEventListener("click",function(){
			if (queryClickable){
				inBoxDown.blur();
				exec("WidgetMMPContainerComponents", 'inputEdit', [ "driver_point",
						driverInfo.taskHandler, inBoxDown.value, "inBoxDown", "驾驶证号" ]);
			}
		},false);
		
		checkBox.addEventListener("touchstart",function(){
			event.stopPropagation();
			if (queryClickable)
				isMove = false;
		},false);
		checkBox.addEventListener("touchmove",function(){
			event.stopPropagation();
			if (queryClickable)
				isMove = true;
		},false);
		checkBox.addEventListener("touchend",function(){
			event.stopPropagation();
			if (queryClickable){
				if(isMove == true){
					isMove = false;
					return;
				}
				if(remember){
					checkBox.src = vehicle_query_checkbox_unchecked;
					remember = false;
				}else{
					checkBox.src = vehicle_query_checkbox_checked;
					remember = true;
				}
			}
		},false);
		
		coverLayer.addEventListener("touchstart",function(){ event.stopPropagation(); },false);
		buttonText.addEventListener("touchstart",function(){
			event.stopPropagation();
			if (queryClickable){
				isMove = false;
				draw(buttonCanvas, vehicle_query_button_backgroud_pressed, vehicle_query_button_backgroud_normal_coordinates);
			}
		});
		buttonText.addEventListener("touchmove",function(){
			event.stopPropagation();
			if (queryClickable){
				isMove = true;
				draw(buttonCanvas, vehicle_query_button_backgroud_normal, vehicle_query_button_backgroud_normal_coordinates);
			}
		});
		buttonText.addEventListener("touchend",function(){
			event.stopPropagation();
			if (queryClickable) {
				if(isMove) {
					isMove = false;
					return;
				}
				draw(buttonCanvas, vehicle_query_button_backgroud_normal, vehicle_query_button_backgroud_normal_coordinates);
				var info_name = (inBoxUp.value).replace(/\s/g, "");
				var info_license = (inBoxDown.value).replace(/\s/g, "");
				console.log("input name is : " + info_name + " ,input license is : " + info_license);
				if (checkInputValid(info_name, info_license, errorFlag, errorBlock)) {
					coverLayer.style.display = "block";
					queryClickable = false;
					buttonText.innerText = "正在查询...";
					exec(driverInfo.taskHandler, "query", [info_name, info_license,remember==true?"true":"false"]);
				}
			}
		});
		outDiv.updateErrorState = function(errorDes){
			errorBlock.style.opacity = "1.0";
			errorFlag.innerHTML = errorDes;
			buttonText.innerText = "查询";
			queryClickable = true;
			coverLayer.style.display = "none";
		}
		outDiv.onEditResult = function(content,editType){
			if(editType == "inBoxUp"){
				inBoxUp.value = content;
				inBoxUp.blur();
			}else{
				inBoxDown.value = content;
				inBoxDown.blur();
			}
			setTimeout(function() {
				document.body.focus();
			}, 250);
			forceRefreshScreen();
		}
		outDiv.onEditCancel = function(editType){
			if(editType == "inBoxUp")
				inBoxUp.blur();
			else
				inBoxDown.blur();
			document.body.focus();
		}
		outDiv.deleteView = function(){
			//取消请求
			exec(driverInfo.taskHandler, 'stopRequest',[ ]);
			// 调用java函数释放相关资源
			exec('WidgetMMPContainerComponents', 'removeViewForJs',[ driverInfo.taskHandler ]);
		}
		return outDiv;
	}
	function checkInputValid(input1,input2,errorTip,errorContainer){
		if(input1=="" || input1==null){
			errorContainer.style.opacity = "1.0";
			errorTip.innerText = "驾驶员姓名不能为空";
			return false;
		}
		if(input2=="" || input1==null){
			errorContainer.style.opacity = "1.0";
			errorTip.innerText = "驾驶证号不能为空";
			return false;
		}

		if (input2.length == 15 || input2.length == 18) {
			errorContainer.style.opacity = "0.0";
			errorTip.innerText = "信息格式正确";
			return true;
		}
		errorContainer.style.opacity = "1.0";
		errorTip.innerText = "对不起，您输入的信息有误，请检查后重试";
		return false;

	}

	function updateErrorState(errorDes){
		if(driverQueryView)
			driverQueryView.updateErrorState(errorDes);
	}
	function onEditResult(taskHandler, content, editType){
		driverQueryView.onEditResult(content, editType);
	}
	function onEditCancel(taskHandler, editType){
		driverQueryView.onEditCancel(editType);
	}
	window.driverPointQueryView = window.driverPointQueryView || {};
	driverPointQueryView.updateErrorState = updateErrorState;
	driverPointQueryView.onEditResult = onEditResult;
	driverPointQueryView.onEditCancel = onEditCancel;

	return createDriveCreditQueryView;
})