define(function() {
	function createDriverCreditResView(resultInfo){
	    var outDiv = createOutDiv();
	    var credit_bg = createBgCanvas(dialog_box_canvas_width);
	    credit_bg.className = "css_driver_credit_bg";
	
	    var credit_inner = document.createElement("div");
	    credit_inner.className = "css_driver_credit_inner";
	
	    var credit_title = document.createElement("div");
	    credit_title.className = "css_driver_credit_result_title";
	
	    var nameBlock = document.createElement("div");
	    nameBlock.className = "css_driver_credit_name_block";
	    var infoTag = document.createElement("label");
	    infoTag.className = "css_driver_credit_driver_name"
	    infoTag.innerText = "驾驶员积分信息";
	    var infoName = document.createElement("label");
	    infoName.className = "css_driver_credit_name_flag";
	    infoName.innerText = resultInfo.name;
	    nameBlock.appendChild(infoTag);
	    nameBlock.appendChild(infoName);
	
	    var moreBlock = document.createElement("div");
	    moreBlock.className = "css_driver_credit_more_block";
	    var moreImg = document.createElement("img");
	    moreImg.className = "css_driver_credit_more_menu";
	    moreImg.src = vehicle_query_menu_fold_state_normal_img;

	    moreBlock.appendChild(moreImg);
	
	    credit_title.appendChild(nameBlock);
	    credit_title.appendChild(moreBlock);
	
	    var baseTitle = document.createElement("div");
	    baseTitle.className = "css_driver_credit_info_flag";
	    baseTitle.innerText = "基本信息";
	    var baseContent = document.createElement("div");
	    baseContent.className = "css_driver_credit_info_content";
		
		baseContent.innerHTML = "证件号码：" + resultInfo.license + "<br>" + "证件状态：" + resultInfo.status  
				+ "<br>" + "准驾车型：" + resultInfo.motortype + "<br>" + "有效期限：" + resultInfo.period;
	
	    var creditTitle = document.createElement("div");
	    creditTitle.className = "css_driver_credit_info_flag";
	    creditTitle.innerText = "积分信息";
	    var creditContent = document.createElement("div");
	    creditContent.className = "css_driver_credit_info_content";
	    var creditStr = "已扣分：" + resultInfo.total + "<br>";
	    if(resultInfo.total>11){
	    	creditStr += "满12分时间：" + resultInfo.reach12Time+ "<br>";
	    }
	    if(resultInfo.clearTime){
	    	creditStr += "上次清零时间：" + resultInfo.clearTime;
	    }
	    creditContent.innerHTML = creditStr ;
	
	    var otherTitle = document.createElement("div");
	    otherTitle.className = "css_driver_credit_info_flag";
	    otherTitle.innerText = "其他信息";
	    var otherContent = document.createElement("div");
	    otherContent.className = "css_driver_credit_info_content";
	    otherContent.innerHTML = "初次领证时间：" + resultInfo.obtainTime 
	    					+ "<br>" + "提交体检证明时间：" + resultInfo.examTime ;
	
	    var content_info = document.createElement("div");
	    content_info.className = "css_driver_credit_content";
	    content_info.appendChild(baseTitle);
	    content_info.appendChild(baseContent);
	    content_info.appendChild(creditTitle);
	    content_info.appendChild(creditContent);
	    content_info.appendChild(otherTitle);
	    content_info.appendChild(otherContent);
	
	    var menuBlock = document.createElement("div");
	    menuBlock.className = "css_driver_credit_menu_block";
	    var otherDriver = document.createElement("div");
	    otherDriver.className = "";
	    otherDriver.innerText = "查询其他驾驶员";
	    var menuDivider = document.createElement("div");
	    menuDivider.className = "css_driver_credit_menu_divider";
	    var vehicleViolationQuery = document.createElement("div");
	    vehicleViolationQuery.className = "";
	    vehicleViolationQuery.innerText = "车辆违章查询";
	
	    var menuContent = document.createElement("div");
	    menuContent.className = "css_driver_credit_menu_content";
	
	    menuContent.appendChild(otherDriver);
	    menuContent.appendChild(menuDivider);
	    menuContent.appendChild(vehicleViolationQuery);
	
	    menuBlock.appendChild(menuContent);
	
	    content_info.appendChild(menuBlock);
		
		credit_inner.appendChild(credit_title);
    	credit_inner.appendChild(content_info);
	
	    outDiv.appendChild(credit_bg);
	    outDiv.appendChild(credit_inner);
	
	    document.body.appendChild(outDiv);
	
	    credit_bg.setAttribute("height",credit_inner.clientHeight + "px");
	
	    draw(credit_bg,dialogmode_contact_bg,dialog_view_bg_coordinates);
	    
	    var isMove = false;
	    var isMenuBlockShowing = false;
	    moreImg.addEventListener("touchstart",function(){
	    	isMove = false;
	    	event.stopPropagation();
	    	moreImg.src = vehicle_query_menu_fold_state_pressed_img;
	    },false);
	    moreImg.addEventListener("touchmove",function(){
	    	event.stopPropagation();
	    	isMove = true;
	    	moreImg.src = vehicle_query_menu_fold_state_normal_img;
	    },false);
	    moreImg.addEventListener("touchend",function(){
	    	event.stopPropagation();
	    	moreImg.src = vehicle_query_menu_fold_state_normal_img;
	    	if(!isMove){
	    		console.log("DriverPoint result menu is touched");
	    		if(isMenuBlockShowing){
		    		menuBlock.style.display = "none";
		    		isMenuBlockShowing = false;
	    		}else{
	    			menuBlock.style.display = "block";
	    			isMenuBlockShowing = true;
	    		}
	    	}
	    	forceRefreshScreen();
	    	isMove = false;
	    },false);

	    
	    menuBlock.addEventListener("touchstart",function(){
	    	isMove = false;
	    	if(event.target==menuBlock){
	    		menuBlock.style.display = "none";
	    		isMenuBlockShowing = false;
	    		forceRefreshScreen();
	    	}else if(event.target==otherDriver || event.target==vehicleViolationQuery){
	    		event.stopPropagation();
	    		event.target.style.color = "#47b1f9";
	    	}
	    });
	    menuBlock.addEventListener("touchmove",function(){
	    	event.stopPropagation();
	    	isMove = true;
	    	if(event.target==otherDriver || event.target==vehicleViolationQuery){
		    	event.target.style.color = "white";
	    	}
	    });
	    menuBlock.addEventListener("touchend",function(){
	    	event.stopPropagation();
	    	if(!isMove){
	    		if(event.target==otherDriver){
			    	event.target.style.color = "white";
			    	 menuBlock.style.display = "none";
                	 isMenuBlockShowing = false;
                	 moreImg.style.display = "none";
                	 exec(resultInfo.taskHandler, "queryOther", []);
		    	}else if(event.target==vehicleViolationQuery){
		    		event.target.style.color = "white";
		    		 menuBlock.style.display = "none";
                	 isMenuBlockShowing = false;
                	 moreImg.style.display = "none";
                	 exec(resultInfo.taskHandler, "queryVehicle", []);
		    	}
	    	}
	    	forceRefreshScreen();
	    	isMove = false;
	    });
	    return outDiv;
	}
	return createDriverCreditResView;
});