/****************************错误提示View****************************/
define(function() {
	function createErrorView(errorInfo) {
		if (errorView) {
			removeErrorView();
		}
		var errorType = errorInfo.errorType;
		var realTaskHandler = errorInfo.realTaskHandler;
		var isErrorOperate = 0;

		var outDiv = createOutDiv();
		outDiv.id = errorInfo.taskHandler;

		var dialog_answer_canvas = createBgCanvas(dialog_box_canvas_width);
		dialog_answer_canvas.className = "css_dialog_absolute_bg";

		var dialog_error_inner = document.createElement("div");
		dialog_error_inner.className = "css_dialog_answer_text";

		var error_func = document.createElement("div");
		error_func.className = "css_answer_text_whith_share";

		if (errorType != "dialog_error_tip") {
			var errorTextContainer = document.createElement("span");

			errorTextContainer.innerText = errorInfo.errorText;
			var errorIcon = document.createElement("img");

			if (errorType == "no_network_access" || errorType == "goto_language_activity") {
				errorTextContainer.className = "css_dialog_error_whith_icon_text";
				errorIcon.className = "css_dialog_error_set_icon";
				errorIcon.src = error_goto_set;
			} else if (errorType == "network_access_overtime") {
				errorTextContainer.className = "css_dialog_error_whith_icon_text2";
				errorIcon.className = "css_dialog_error_retry_icon";
				errorIcon.src = error_goto_retry;
			}
			error_func.appendChild(errorTextContainer);
			error_func.appendChild(errorIcon);

			dialog_error_inner.appendChild(error_func);
			if (errorInfo.isTipShow) {
				var err_func_text = document.createElement("div");
				err_func_text.className = "css_error_tip_text";
				err_func_text.innerText = "无网络时，您可以使用打电话、发短信功能";
				dialog_error_inner.appendChild(err_func_text);
			}

			isErrorOperate = 1;
			if (errorType != "goto_language_activity") {
				console.log("errorType is delete : " + errorType);
				errorView = outDiv;
			} else {
				console.log("errorType is normal : " + errorType);
				isErrorOperate = 2;
			}
		} else {
			error_func.innerText = errorInfo.errorText;
			dialog_error_inner.appendChild(error_func);
			errorView = outDiv;
		}
		outDiv.appendChild(dialog_answer_canvas);
		outDiv.appendChild(dialog_error_inner);

		document.body.appendChild(outDiv);

		// 重新设置padding_bottom，添加向下箭头的高度
		var paddingBottom = getCurrentStyle(dialog_error_inner, 'padding-bottom');
		var newPaddingBottom = (parseFloat(paddingBottom) + bubble_arrow_height) + 'px';
		dialog_error_inner.style.paddingBottom = newPaddingBottom;

		var canvasHeight = dialog_error_inner.clientHeight;
		if (canvasHeight < dialog_box_canvs_minHeight) {
			canvasHeight = dialog_box_canvs_minHeight;
			dialog_error_inner.style.top = (dialog_box_canvs_minHeight - dialog_error_inner.clientHeight) / 2 + "px";
		}
		dialog_answer_canvas.setAttribute("height", canvasHeight + "px");
		draw(dialog_answer_canvas, img_dialog_ansew_bg, dialog_answer_bg_coordinates);

		// 使用自定义scrolltouch事件，控制在滑动时点击是否生效；
		enableScrollTouch(outDiv, 15, null);
		outDiv.addEventListener("scrolltouch", function() {
			if (isErrorOperate == 1) {
				removeErrorView();
			}
			exec(realTaskHandler, errorType, []);
		}, false);
		showOpacityAnimation(outDiv, 150);

		outDiv.refresh = function() {
			reDraw(dialog_answer_canvas, img_dialog_ansew_bg, dialog_answer_bg_coordinates);

			if (errorType == "no_network_access") {
				errorIcon.src = dialog_goto_right_icon;
			} else if (errorType == "network_access_overtime") {
				errorIcon.src = dialog_stock_refresh;
			}
		};
		return outDiv;
	}

	return createErrorView;
})