/**
 * 新闻视图
 * 
 * @author mdhuang
 * @author modified by ppfeng 2013-3-25
 * 
 */
define(function(){
	/**
	 * 创建新闻界面控制播放按钮
	 * 
	 * @param btnImgSrc
	 *            按钮图片地址，字符串类型
	 * @param btnId
	 *            按钮ID
	 */
	function createNewsControlBtn(btnImgSrc, btnId) {
		var btnImg = document.createElement("img");
		btnImg.src = btnImgSrc;
		btnImg.id = btnId;
		btnImg.className = "css_dialog_news_control_btn_img";
		return btnImg;
	}
	
	var news_view_state = "";
	var newsContentScroller = null;
	var news_view_loading_update_id = null;
	function createNewsView(newsInfo) {
		news_view_state = "play";
	
		var newsTaskHandler = newsInfo.taskHandler;
	
		var outDiv = createOutDiv(newsTaskHandler);
		if (enableAnimation && isChangingSkin == false) {
			outDiv.className += " css_dialog_opacity_animation";
		}
	
		// loading 状态下的显示元素
		var dialog_news_loading_div = document.createElement("div");
		dialog_news_loading_div.id = "id_news_loading_div";
		dialog_news_loading_div.style.opacity = "0.0";
		dialog_news_loading_div.className = "css_dialog_news_loading";
	
		// loading使用canvas模拟
		var dialog_news_loading_canvas = document.createElement("canvas");
		dialog_news_loading_canvas.id = "id_news_loading_canvas";
		// FIXME 暂时借用dialog_title_canvas_height的值作为canvas的宽、高，后续使用独立的变量
		dialog_news_loading_canvas.setAttribute("width", dialog_title_canvas_height
				+ "px");
		dialog_news_loading_canvas.setAttribute("height",
				dialog_title_canvas_height + "px");
		dialog_news_loading_canvas.className = "css_dialog_news_loading_canvas";
	
		var dialog_news_loading_failertext = document.createElement("div");
		dialog_news_loading_failertext.setAttribute("id", "id_news_loading_failer");
		dialog_news_loading_failertext.className = "css_dialog_news_loading_failertext";
		dialog_news_loading_failertext.innerText = "信息提示";
	
		// 新闻主体div
		var dialog_news_inner_div = document.createElement("div");
		dialog_news_inner_div.className = "css_dialog_news_inner";
	
		// title区域
		var dialog_news_title = document.createElement("div");
		dialog_news_title.className = "css_dialog_news_title";
		dialog_news_title.innerText = "听新闻";
	
		// 新闻内容区域主容器
		var dialog_news_content_main_div = document.createElement("div");
		dialog_news_content_main_div.className = "css_dialog_news_content_main_div";
	
		// 新闻内容包装器，用于iscroll
		var dialog_news_content_wraper_div = document.createElement("div");
		dialog_news_content_wraper_div.id = "id_news_content_wraper";
		dialog_news_content_wraper_div.className = "css_dialog_news_content_wraper";
	
		// 新闻内容正文区
		var dialog_news_content_div = document.createElement("div");
		dialog_news_content_div.setAttribute("id", "id_news_content");
		dialog_news_content_div.className = "css_dialog_news_content_text";
		dialog_news_content_div.innerText = " ";
	
		dialog_news_content_wraper_div.appendChild(dialog_news_content_div);
	
		// 新闻内容底部栏
		var dialog_news_content_bottom = document.createElement("div");
		dialog_news_content_bottom.className = "css_dialog_news_content_bottom";
	
		var dialog_news_content_source = document.createElement("div");
		dialog_news_content_source.className = "css_dialog_news_content_source";
		dialog_news_content_source.setAttribute("id", "id_news_source");
		dialog_news_content_source.innerHTML = "新闻来源";
	
		var dialog_news_content_stretch = document.createElement("div");
		dialog_news_content_stretch.className = "css_dialog_news_content_stretch";
		dialog_news_content_stretch.setAttribute("id", "id_news_stretch");
		dialog_news_content_stretch.innerHTML = "展开全文";
	
		dialog_news_content_bottom.appendChild(dialog_news_content_source);
		dialog_news_content_bottom.appendChild(dialog_news_content_stretch);
	
		dialog_news_content_main_div.appendChild(dialog_news_content_wraper_div);
		dialog_news_content_main_div.appendChild(dialog_news_content_bottom);
	
		// 播放控制栏
		var dialog_news_control_div = document.createElement("div");
		dialog_news_control_div.className = "css_dialog_news_control_div";
	
		var dialog_news_control_btn_div = document.createElement("div");
		dialog_news_control_btn_div.className = "css_dialog_news_control_btn_div";
	
		var btn_last = createNewsControlBtn(news_btn_last_normal, "id_news_last");
		btn_last.className = btn_last.className + " css_dialog_news_btn_last";
	
		var btn_play = createNewsControlBtn(news_speaker_status1,
				"id_news_play_pause");
		btn_play.className = btn_play.className + " css_dialog_news_btn_play";
	
		var btn_next = createNewsControlBtn(news_btn_next_normal, "id_news_next");
		btn_next.className = btn_next.className + " css_dialog_news_btn_next";
	
		dialog_news_control_btn_div.appendChild(btn_last);
		dialog_news_control_btn_div.appendChild(btn_play);
		dialog_news_control_btn_div.appendChild(btn_next);
	
		dialog_news_control_div.appendChild(dialog_news_control_btn_div);
	
		dialog_news_inner_div.appendChild(dialog_news_title);
		dialog_news_inner_div.appendChild(dialog_news_content_main_div);
		dialog_news_inner_div.appendChild(dialog_news_control_div);
	
		dialog_news_loading_div.appendChild(dialog_news_loading_canvas);
		dialog_news_loading_div.appendChild(dialog_news_loading_failertext);
	
		outDiv.appendChild(dialog_news_loading_div);
		outDiv.appendChild(dialog_news_inner_div);
	
		document.body.appendChild(outDiv);
	
		/*
		 * setTimeout(function() { var newsContentScroller = new
		 * iScroll(dialog_news_content_wraper_div, { scrollbarClass : 'myScrollbar'
		 * }); }, 200);
		 */
	
		showOpacityAnimation(outDiv, 150);
		// 判断新闻内容高度是否大于包含它的容器高度
		if (dialog_news_content_div.clientHeight > dialog_news_content_wraper_div.clientHeight) {
			dialog_news_content_div.style.display = "inline-block";
		}
		/**
		 * 添加热区点击响应函数
		 */
		var isNewsTouchmove = false;
		dialog_news_content_main_div
				.addEventListener(
						"touchstart",
						function() {
							moveOverCheck.start(event);
							console.log("展开状态是"
									+ dialog_news_content_stretch.style.display);
							if (dialog_news_content_stretch.style.display != "none") {
								dialog_news_content_main_div.className = "css_dialog_news_content_main_div2";
							}
						});
		dialog_news_content_main_div
				.addEventListener(
						"touchmove",
						function() {
							if (moveOverCheck.check(event)) {
								isNewsTouchmove = true;
								dialog_news_content_main_div.className = "css_dialog_news_content_main_div";
							}
						});
		dialog_news_content_main_div
				.addEventListener(
						"touchend",
						function() {
							dialog_news_content_main_div.className = "css_dialog_news_content_main_div";
							if (isNewsTouchmove) {
								isNewsTouchmove = false;
							} else {
								if (document.getElementById("id_news_stretch").innerHTML == "展开全文") {
									document
											.getElementById("id_news_content_wraper").className = "css_dialog_news_content_wraper2";
									document.getElementById("id_news_content").className = "css_dialog_news_content_text2";
									document.getElementById("id_news_stretch").innerHTML = "收起全文";
									scrollDown();
								} else if (document
										.getElementById("id_news_stretch").innerHTML == "收起全文") {
									document
											.getElementById("id_news_content_wraper").className = "css_dialog_news_content_wraper";
									document.getElementById("id_news_content").className = "css_dialog_news_content_text";
									document.getElementById("id_news_stretch").innerHTML = "展开全文";
								}
							}
						});
		/**
		 * 添加控制按钮触摸响应函数
		 */
		dialog_news_control_btn_div.addEventListener("touchstart", function() {
			var targetElement = event.target;
			if (targetElement.id === "id_news_last") {
				if (news_view_state !== "last_over") {
					targetElement.src = news_btn_last_pressed;
				}
			} else if (targetElement.id === "id_news_play_pause") {
				if(news_view_state == "next_over"){
					targetElement.src = news_speaker_status1;
				}else{
					if (news_view_state === "pause") {
						targetElement.src = news_speaker_pressed;
					} else {
						targetElement.src = news_speaker_pressed;
					}
				}
			} else if (targetElement.id === "id_news_next") {
				if (news_view_state == "next_over"){
					targetElement.src = news_btn_next_normal;
				}
				if (news_view_state !== "next_over"
						&& news_view_state !== "loading"
						&& news_view_state !== "loading_faile") {
					targetElement.src = news_btn_next_pressed;
				}
			}
		}, false);
			dialog_news_control_btn_div.addEventListener("touchend", function() {
			var targetElement = event.target;
			if (targetElement.id === "id_news_last") {
				if (news_view_state !== "last_over") {
					targetElement.src = news_btn_last_normal;
					exec(newsTaskHandler, 'playLastItem', []);
				}
			} else if (targetElement.id === "id_news_play_pause") {
				if (news_view_state === "pause") {
					targetElement.src = news_speaker_status1;
					exec(newsTaskHandler, 'play', []);
					
				} else {
					targetElement.src = news_speaker_status1;
					exec(newsTaskHandler, 'pause', []);
				}
			} else if (targetElement.id === "id_news_next") {
				//console.log("new  state  is : " + news_view_state);
				if (news_view_state == "next_over"){
					targetElement.src = news_btn_next_normal;
				}
				if (news_view_state !== "next_over"
						&& news_view_state !== "loading"
						&& news_view_state !== "loading_faile") {
					targetElement.src = news_btn_next_normal;
					exec(newsTaskHandler, 'playNextItem', []);
				}
			}
		}, false);
	
		// 设置当前可删除view
		currentCanDeleteView = outDiv;
	
		outDiv.refresh = function() {
			update(outDiv.news_state, outDiv.news_content, outDiv.news_source,
					outDiv.news_description, newsTaskHandler);
		};
	
		return outDiv;
	}
	
	function showNewsDecription(news_decription) {
		console.log("current des:" + news_decription);
		document.getElementById("id_news_content").style.opacity = "0.0";
		document.getElementById("id_news_source").style.opacity = "0.0";
		document.getElementById("id_news_loading_div").style.opacity = "1.0";
		if (news_decription == "loading") {
			document.getElementById("id_news_loading_canvas").style.display = "inline-block";
			document.getElementById("id_news_loading_failer").style.display = "none";
		} else {
			document.getElementById("id_news_loading_canvas").style.display = "none";
			document.getElementById("id_news_loading_failer").style.display = "block";
		}
	}
	var isNewsRunning = false;
	function update(news_state, news_content, news_source, news_description,
			taskHandler) {
		console.log("new  state  is : " + news_state);
		if (news_state == "pause") {
			document.getElementById("id_news_play_pause").src = news_speaker_status1;
			document.getElementById("id_news_last").src = news_btn_last_normal;
			document.getElementById("id_news_next").src = news_btn_next_normal;
	
			// 配合暂停状态下的皮肤切换
			document.getElementById("id_news_content").innerText = news_content;
			document.getElementById("id_news_source").innerText = news_source;
		} else if (news_state == "play") {
			if (news_view_state == "last_over") {
				// document.getElementById("id_news_last").src =
				// news_btn_last_normal;
			} else if (news_view_state == "next_over") {
				// document.getElementById("id_news_next").src =
				// news_btn_next_normal;
			} else if (news_view_state == "loading") {
				stopRotate(news_view_loading_update_id);
				// document.getElementById("id_news_next").src =
				// news_btn_next_normal;
			} else if (news_view_state == "loading_faile") {
				// document.getElementById("id_news_next").src =
				// news_btn_next_normal;
			}
	
			document.getElementById("id_news_last").src = news_btn_last_normal;
			document.getElementById("id_news_next").src = news_btn_next_normal;
			document.getElementById("id_news_play_pause").src = news_speaker_status1;
			document.getElementById("id_news_loading_div").style.opacity = "0.0";
			document.getElementById("id_news_content").style.opacity = "1.0";
			document.getElementById("id_news_source").style.opacity = "1.0";
			document.getElementById("id_news_content").innerText = news_content;
			document.getElementById("id_news_source").innerText = news_source;
			//播放状态下当文档内容大于其容器时显示展开全文
			document.getElementById("id_news_content_wraper").className = "css_dialog_news_content_wraper";
			document.getElementById("id_news_content").className = "css_dialog_news_content_text";
			
			//计算元素的属性值
			var newsele = document.getElementById("id_news_content");
	        var newsstyle = document.defaultView.getComputedStyle(newsele, null);
	        var paddingBottomValue = parseInt(newsstyle.paddingBottom.substring(0,newsstyle.paddingBottom.length - 2));
			console.log("内容padding-bottom值" + paddingBottomValue);
			if(document.getElementById("id_news_content").clientHeight - 2 * paddingBottomValue > 
				document.getElementById("id_news_content_wraper").clientHeight){
					console.log("内容padding-bottom值" + newsstyle.paddingBottom);
					document.getElementById("id_news_stretch").style.display = "inline-block";
					document.getElementById("id_news_stretch").innerHTML = "展开全文";
			}else{
				document.getElementById("id_news_stretch").style.display = "none";
				document.getElementById("id_news_stretch").innerHTML = "";
			}
			
			if(isNewsRunning == false){
				setTimeout(function() {newsbuffer();}, 300);
			}
	
			if (newsContentScroller != null && newsContentScroller.y != 0) {
				newsContentScroller.scrollTo(0, 0);
			}
		} else if (news_state == "last_over") {
		
			console.log("There is no news ahead");
			document.getElementById("id_news_last").src = news_btn_last_disable;
			document.getElementById("id_news_play_pause").src = news_speaker_status1;
			document.getElementById("id_news_next").src = news_btn_next_normal;
			document.getElementById("id_news_stretch").style.display = "none";
			document.getElementById("id_news_stretch").innerHTML = "";
			document.getElementById("id_news_content_wraper").className = "css_dialog_news_content_wraper";
			document.getElementById("id_news_content").className = "css_dialog_news_content_text";
	
			// 更新提示
			showNewsDecription("last_over");
			document.getElementById("id_news_loading_failer").innerText = "没有更多新闻了";
		} else if (news_state == "play_faile") {
			document.getElementById("id_news_content_wraper").className = "css_dialog_news_content_wraper";
			document.getElementById("id_news_content").className = "css_dialog_news_content_text";
			showNewsDecription("play_faile");
			document.getElementById("id_news_play_pause").src = news_speaker_status1;
			document.getElementById("id_news_next").src = news_btn_next_normal;
			document.getElementById("id_news_last").src = news_btn_last_normal;
			document.getElementById("id_news_loading_failer").innerText = news_description;
			document.getElementById("id_news_stretch").style.display = "none";
			document.getElementById("id_news_stretch").innerHTML = "";
		} else if (news_state == "next_over") {
			
			document.getElementById("id_news_next").src = news_btn_next_disable;
			document.getElementById("id_news_play_pause").src = news_speaker_status1;
			document.getElementById("id_news_last").src = news_btn_last_normal;
			document.getElementById("id_news_stretch").style.display = "none";
			document.getElementById("id_news_stretch").innerHTML = "";
			document.getElementById("id_news_content_wraper").className = "css_dialog_news_content_wraper";
			document.getElementById("id_news_content").className = "css_dialog_news_content_text";
	
			// 更新提示
			showNewsDecription("next_over");
			document.getElementById("id_news_loading_failer").innerText = "没有更多新闻了";
		} else if (news_state == "loading") {
			
			document.getElementById("id_news_next").src = news_btn_next_disable;
			document.getElementById("id_news_last").src = news_btn_last_normal;
			document.getElementById("id_news_play_pause").src = news_speaker_status1;
			document.getElementById("id_news_stretch").style.display = "none";
			document.getElementById("id_news_stretch").innerHTML = "";
			document.getElementById("id_news_content_wraper").className = "css_dialog_news_content_wraper";
			document.getElementById("id_news_content").className = "css_dialog_news_content_text";
			showNewsDecription("loading");
	
			var canvas_target = document.getElementById("id_news_loading_canvas");
			news_view_loading_update_id = startRotate(canvas_target);
		} else if (news_state == "loading_faile") {
			console.log("current state is loading_fail");
			document.getElementById("id_news_next").src = news_btn_next_disable;
			document.getElementById("id_news_play_pause").src = news_speaker_status1;
			document.getElementById("id_news_last").src = news_btn_last_normal;
			document.getElementById("id_news_content_wraper").className = "css_dialog_news_content_wraper";
			document.getElementById("id_news_content").className = "css_dialog_news_content_text";
			stopRotate(news_view_loading_update_id);
	
			console.log("loading_faile:" + news_description);
			document.getElementById("id_news_loading_canvas").style.display = "none";
			document.getElementById("id_news_loading_failer").style.display = "block";
			document.getElementById("id_news_loading_failer").innerText = news_description;
		}
		news_view_state = news_state;
	
		// 保存数据到dom节点
		var outDiv = document.getElementById(taskHandler);
		outDiv.news_state = news_state;
		if (news_content != null && news_content != "") {
			outDiv.news_content = news_content;
		}
		if (news_source != null && news_source != "") {
			outDiv.news_source = news_source;
		}
		if (news_description != null && news_description != "") {
			outDiv.news_description = news_description;
		}
	}
	var news_counter = 0;
	function newsbuffer() {
	var bufferImgArray = [ news_speaker_status1, news_speaker_status2,
			news_speaker_status3 ];
	news_counter = news_counter % 3;
	document.getElementById("id_news_play_pause").src = bufferImgArray[news_counter];
	news_counter++;
	if (news_view_state == "play") {
		isNewsRunning = true;
		setTimeout(function() {
			newsbuffer();
		}, 300);
	} else {
		isNewsRunning = false;
		document.getElementById("id_news_play_pause").src = news_speaker_status1;
	}
}
	
	// 将需要java回调的函数暴露到全局对象newsView中，方便外部java文件调用
	window.newsView = window.newsView || {};
	console.log(newsView);
	newsView.update = update;
	
	return createNewsView;
});