/*****************转写结果View**********************/
define(function() {
	var editQuestionView = null;
	function showQuestion(questionInfo) {
		if (focusListView !== null && needFold == true) {
			focusListView.foldDetail();
		}
		return createQuestionDialog(questionInfo);
	}

	function deleteDomAfterEdit() {
		if (editQuestionView !== null) {
			for (var child = document.body.lastChild; child != editQuestionView; child = document.body.lastChild) {
				document.body.removeChild(child);

				// 删除原生控件
				if (child.id.indexOf('WidgetWebviewContainer') >= 0) {
					exec('WidgetMMPContainerComponents', 'removeWeb', [child.id]);
				}
			}
			forceRefreshScreen();
		}
	}

	/**
	 *该函数暂时保留，某些情况下手动调用的时候可以去除气泡的编辑属性
	 */
	function removeEditAttr() {
		if (editQuestionView != null) {
			editQuestionView.removeEdit();
			editQuestionView = null;
		}
	}

	function editResult(domId, editRes) {
		console.log("editId is " + domId);
		console.log("editResult is " + editRes);
		if (editQuestionView != null) {
			// document.getElementById(domId).innerText = editRes;
			editQuestionView.removeEdit(editRes);
			editQuestionView = null;
		}
	}

	function createQuestionDialog(questionInfo) {
		if (editQuestionView != null) {
			editQuestionView.removeEdit();
		}
		var outDiv = createOutDiv(questionInfo.taskHandler + "outDiv");
		if (enableAnimation && isChangingSkin == false) {
			outDiv.className += " css_dialog_opacity_animation";
		}
		var dialog_question_canvas = createBgCanvas(dialog_box_canvas_width);
		dialog_question_canvas.className = "css_dialog_absolute_bg";
		var dialog_question_text = document.createElement("div");
		dialog_question_text.className = "css_dialog_question_text";

		if (questionInfo.editEnable) {
			var text_content = document.createElement("a");
			text_content.id = questionInfo.taskHandler + "qContent";
			// text_content.className = "css_dialog_question_edit";
			text_content.innerText = questionInfo.questionText;

			dialog_question_text.appendChild(text_content);
		} else {
			dialog_question_text.innerText = questionInfo.questionText;
		}

		outDiv.appendChild(dialog_question_canvas);
		outDiv.appendChild(dialog_question_text);
		document.body.appendChild(outDiv);

		// 重新设置padding_bottom，添加向下箭头的高度
		var paddingBottom = getCurrentStyle(dialog_question_text, 'padding-bottom');
		var newPaddingBottom = (parseFloat(paddingBottom) + bubble_arrow_height) + 'px';
		dialog_question_text.style.paddingBottom = newPaddingBottom;

		// clientHeight = 显示区域高度+padding
		var canvasHeight = dialog_question_text.clientHeight;

		if (canvasHeight < dialog_box_canvs_minHeight) {
			canvasHeight = dialog_box_canvs_minHeight;
			dialog_question_text.style.top = (dialog_box_canvs_minHeight - dialog_question_text.clientHeight) / 2 + "px";
		}

		// console.log(dialog_answer_text.clientHeight);
		dialog_question_canvas.setAttribute("height", canvasHeight + "px");

		var context = dialog_question_canvas.getContext("2d");
		draw(dialog_question_canvas, img_dialog_question_bg, dialog_question_bg_coordinates);

		showOpacityAnimation(outDiv, 150);

		outDiv.refresh = function() {
			reDraw(dialog_question_canvas, img_dialog_question_bg, dialog_question_bg_coordinates);
		};
		var move = false;
		outDiv.editStart = function(event) {
			move = false;
		};
		outDiv.editMove = function(event) {
			if (!move)
				move = true;
		};
		outDiv.editEnd = function(event) {
			console.log("Edit move id " + move);
			if (!move) {
				exec("WidgetMMPContainerComponents", 'editQuestion', [text_content.id, text_content.innerText, questionInfo.intentType]);
			}
			move = false;
		};
		if (questionInfo.editEnable) {
			dialog_question_text.addEventListener("touchstart", outDiv.editStart, false);
			dialog_question_text.addEventListener("touchmove", outDiv.editMove, false);
			dialog_question_text.addEventListener("touchend", outDiv.editEnd, false);
			editQuestionView = outDiv;
		}

		outDiv.removeEdit = function(editText) {
			dialog_question_text.removeEventListener("touchstart", outDiv.editStart, false);
			dialog_question_text.removeEventListener("touchmove", outDiv.editMove, false);
			dialog_question_text.removeEventListener("touchend", outDiv.editEnd, false);
			text_content.className = "";
			if (editText !== undefined) {
				text_content.innerText = editText;
			}
			canvasHeight = dialog_question_text.clientHeight;

			if (canvasHeight < dialog_box_canvs_minHeight) {
				canvasHeight = dialog_box_canvs_minHeight;
				dialog_question_text.style.top = (dialog_box_canvs_minHeight - dialog_question_text.clientHeight) / 2 + "px";
			}
			dialog_question_canvas.setAttribute("height", canvasHeight + "px");
			reDraw(dialog_question_canvas, img_dialog_question_bg, dialog_question_bg_coordinates);
			editQuestionView = null;
			forceRefreshScreen();
		};

		return outDiv;
	}


	console.error('questionView.js load finished');

	window.questionEdit = window.questionEdit || {};
	questionEdit.deleteDomAfterEdit = deleteDomAfterEdit;
	questionEdit.removeEditAttr = removeEditAttr;
	questionEdit.editResult = editResult;

	return showQuestion;
})