/**********新建提醒view********/
define(function() {
	function showRemind(remindInfo) {
		return createRemindView(remindInfo);
	}
	/**
	 * 创建提醒界面
	 * @param remindInfo  java处理过的结果，json格式
	 */
	function createRemindView(remindInfo) {
		var remindTaskHandler = remindInfo.taskHandler;
		// 大背景
		var dialog_remind_canvas = createBgCanvas(dialog_box_canvas_width);
		dialog_remind_canvas.className = "css_dialog_absolute_bg";
		// 真正盛放内容的容器
		var dialog_remind_inner_div = document.createElement("div");
		dialog_remind_inner_div.className = "css_dialog_remind_inner";
		//上边的容器
		var dialog_remind_top_container = document.createElement("div");
		dialog_remind_top_container.className = "css_dialog_remind_top_container";
		//左边的容器
		var dialog_remind_top_left_container = document.createElement("div");
		dialog_remind_top_left_container.className = "css_dialog_remind_top_left_container";
		//上边的容器
		var dialog_remind_date_week = document.createElement("div");
		dialog_remind_date_week.className = "css_dialog_remind_date_week";
		// 日期
		var dialog_remind_date = document.createElement("label");
		dialog_remind_date.id = "remind_date";
		dialog_remind_date.className = "css_dialog_remind_date";
		dialog_remind_date.innerText = remindInfo.tempDate;

		// 周
		var dialog_remind_week = document.createElement("label");
		dialog_remind_week.id = "remind_week";
		dialog_remind_week.className = "css_dialog_remind_week";
		dialog_remind_week.innerText = remindInfo.tempWeek;

		dialog_remind_date_week.appendChild(dialog_remind_date);
		dialog_remind_date_week.appendChild(dialog_remind_week);

		// 时间
		var dialog_remind_time = document.createElement("div");
		dialog_remind_time.id = "remind_time";
		dialog_remind_time.className = "css_dialog_remind_time";
		dialog_remind_time.innerText = remindInfo.tempTime;

		dialog_remind_top_left_container.appendChild(dialog_remind_date_week);
		dialog_remind_top_left_container.appendChild(dialog_remind_time);

		//右边的容器
		var dialog_remind_top_right_container = document.createElement("div");
		dialog_remind_top_right_container.className = "css_dialog_remind_top_right_container";

		var dialog_remind_delete_Icon = document.createElement("img");
		dialog_remind_delete_Icon.className = "css_dialog_remind_delete_icon";
		dialog_remind_delete_Icon.src = dialogmode_remind_delete_normal;

		//右边的容器的点击事件
		dialog_remind_top_right_container.addEventListener("touchstart", function() {
			dialog_remind_delete_Icon.src = dialogmode_remind_delete_pressed;
		}, false);
		dialog_remind_top_right_container.addEventListener("touchmove", function() {
			dialog_remind_delete_Icon.src = dialogmode_remind_delete_normal;
		}, false);
		dialog_remind_top_right_container.addEventListener("touchend", function() {
			dialog_remind_delete_Icon.src = dialogmode_remind_delete_normal;
			removeChild(document.body, outDiv);
			// 取消提醒
			exec(remindTaskHandler, 'deleteRemind', []);
			// 通知java函数释放相关资源
			exec('WidgetMMPContainerComponents', 'removeViewForJs', [remindTaskHandler]);
		}, false);

		dialog_remind_top_right_container.appendChild(dialog_remind_delete_Icon);

		dialog_remind_top_container.appendChild(dialog_remind_top_left_container);
		dialog_remind_top_container.appendChild(dialog_remind_top_right_container);

		// 分割线
		var dialog_remind_line = document.createElement("div");
		dialog_remind_line.className = "css_dialog_remind_divider_line";
		dialog_remind_line.style.backgroundImage = "url('" + dialog_list_divider + "')";

		// 提醒内容
		var dialog_remind_content = document.createElement("div");
		dialog_remind_content.className = "css_dialog_remind_content";

		var dialog_remind_content_label = document.createElement("div");
		dialog_remind_content_label.id = "remind_content";
		dialog_remind_content_label.innerText = remindInfo.tempContent;

		dialog_remind_content.appendChild(dialog_remind_content_label);

		dialog_remind_inner_div.appendChild(dialog_remind_top_container);
		dialog_remind_inner_div.appendChild(dialog_remind_line);
		dialog_remind_inner_div.appendChild(dialog_remind_content);

		//整个容器的点击事件
		dialog_remind_inner_div.addEventListener("touchstart", function(event) {
			moveOverCheck.start(event);
		}, false);
		dialog_remind_inner_div.addEventListener("touchmove", function() {
			moveOverCheck.check(event);
		}, false);
		dialog_remind_inner_div.addEventListener("touchend", function() {
			if (!moveOverCheck.isMoveOver()) {
				exec(remindTaskHandler, 'jumpToRemindEdit', []);
			}
		}, false);

		var outDiv = createOutDiv();
		outDiv.id = "remind_out_div";
		if (enableAnimation && isChangingSkin == false) {
			outDiv.className += "css_dialog_opacity_animation";
		}

		outDiv.appendChild(dialog_remind_canvas);
		outDiv.appendChild(dialog_remind_inner_div);

		document.body.appendChild(outDiv);

		if (dialog_remind_content_label.clientHeight < dialog_remind_content_minHeight) {
			dialog_remind_content_label.style.marginTop = (dialog_remind_content_minHeight - dialog_remind_content_label.clientHeight) / 2 + "px";
		}

		outDiv.onDraw = function() {
			var canvasHeight = dialog_remind_inner_div.clientHeight + dialog_remind_inner_div.style.paddingTop + dialog_remind_inner_div.style.paddingBottom;
			dialog_remind_canvas.setAttribute("height", canvasHeight + "px");

			// 设置大背景图片
			draw(dialog_remind_canvas, dialogmode_remind_bg, dialogmode_remind_bg_coordinates);
		};

		outDiv.onDraw();
		showOpacityAnimation(outDiv, 150);
		// 设置当前可删除view
		currentCanDeleteView = outDiv;

		outDiv.refresh = function() {
			reDraw(dialog_remind_canvas, dialogmode_remind_bg, dialogmode_remind_bg_coordinates);
			dialog_remind_line.style.backgroundImage = "url('" + dialog_list_divider + "')";
		};

		return outDiv;
	}

	function updateRemindView(remind) {
		console.log("uadate remind info is " + remind);
		if (remind != null) {
			var remindInfo = eval("(" + remind + ")");
			// 日期
			var dialog_remind_date = document.getElementById("remind_date");
			dialog_remind_date.innerText = remindInfo.tempDate;
			// 周
			var dialog_remind_week = document.getElementById("remind_week");
			dialog_remind_week.innerText = remindInfo.tempWeek;
			// 时间
			var dialog_remind_time = document.getElementById("remind_time");
			dialog_remind_time.innerText = remindInfo.tempTime;
			// 提醒内容
			var dialog_remind_content = document.getElementById("remind_content");
			dialog_remind_content.innerText = remindInfo.tempContent;

			var outDiv = document.getElementById("remind_out_div");
			outDiv.onDraw();
		}
	}
	window.remindView = window.remindView || {};
	remindView.updateRemindView = updateRemindView;
	return showRemind;
})