/******************餐饮View******************/
define(function() {

	function createRestaurantItem(id, name, level, address, avgPrice) {
		var itemDiv = document.createElement("div");

		itemDiv.id = id;
		itemDiv.className = "css_dialog_restaurant_item_div";
		var nameAndlevelDiv = document.createElement("div");

		var nameDiv = document.createElement("div");
		nameDiv.className = "css_dialog_restaurant_name_div";
		nameDiv.innerText = name;

		var priceDiv = document.createElement("div");
		priceDiv.className = "css_dialog_restaurant_price_div";
		priceDiv.innerText = avgPrice;

		var levelDiv = document.createElement("div");
		levelDiv.className = "css_dialog_restaurant_level_div";

		var addressDiv = document.createElement("div");
		addressDiv.className = "css_dialog_restaurant_address_div";
		addressDiv.innerText = address;

		var full, half, empty;
		if (level % 1 == 0.5) {
			full = (level - 0.5);
			half = 1;
		} else {
			full = level;
			half = 0;
		}
		empty = 5 - full - half;
		for (var i = 0; i < 5; i++) {
			var img = document.createElement("img");
			img.className = "css_dialog_restaurant_level_star";
			if (i < empty) {
				img.src = restaurant_star_empty;
			}
			if (i == empty) {
				if (half == 1)
					img.src = restaurant_star_half;
				else
					img.src = restaurant_star_full;
			}
			if (i > empty) {
				img.src = restaurant_star_full;
			}
			levelDiv.appendChild(img);
		}

		var gotoIcon = document.createElement("img");
		gotoIcon.className = "css_dialog_restaurant_goto_icon";
		gotoIcon.src = dialog_goto_right_icon;

		itemDiv.appendChild(nameDiv);
		itemDiv.appendChild(priceDiv);
		itemDiv.appendChild(levelDiv);
		itemDiv.appendChild(gotoIcon);
		itemDiv.appendChild(addressDiv);
		return itemDiv;
	}

	function createCMBottomRestau() {
		var bottomDiv = document.createElement("div");
		bottomDiv.className = "cm_restau_bottom";
		var restauLogo = document.createElement("img");
		restauLogo.className = "cm_restau_logo";
		restauLogo.src = cm_restau_icon;
		var restauFrom = document.createElement("label");
		restauFrom.className = "cm_bottom_text";
		restauFrom.innerText = "大众点评 dianping.com";
		bottomDiv.appendChild(restauLogo);
		bottomDiv.appendChild(restauFrom);

		return bottomDiv;
	}

	function createCMRestauLink() {
		var cmRestauLink = document.createElement("div");
		cmRestauLink.className = "cm_restau_link_div";
		var bgCanvas = document.createElement("canvas");
		bgCanvas.setAttribute("width", dialog_box_canvas_width + "px");
		bgCanvas.setAttribute("height", dialog_remind_btn_canvas_height + "px");
		var linKImg = document.createElement("img");
		linKImg.className = "cm_restau_link_icon";
		linKImg.src = cm_12580_icon;

		var linKGoto = document.createElement("img");
		linKGoto.className = "cm_restau_link_goto";
		linKGoto.src = dialog_goto_right_icon;

		cmRestauLink.appendChild(bgCanvas);
		cmRestauLink.appendChild(linKImg);
		cmRestauLink.appendChild(linKGoto);

		draw(bgCanvas, img_dialog_btnnomal_bg, dialog_btn_bg_coordinates);

		return cmRestauLink;
	}

	function createRestaurantView(restaurantInfo) {
		console.log("restaurantview is started");
		var items = restaurantInfo.reataurantListLength;
		var outDiv = createOutDiv();
		if (enableAnimation && isChangingSkin == false) {
			outDiv.className += " css_dialog_opacity_animation";
		}

		var dialog_restaurant_canvas = createBgCanvas(dialog_box_canvas_width);
		dialog_restaurant_canvas.className = "css_dialog_absolute_bg";

		var dialog_restaurant_title = document.createElement("div");
		dialog_restaurant_title.className = "css_dialog_restaurant_title_container";

		var titleText = document.createElement("label");
		titleText.className = "css_dialog_restaurant_title_text";
		titleText.innerText = restaurantInfo.reataurantKind;

		shareDiv = createSharePlayView(restaurantInfo.taskHandler, true, 2);
		shareDiv.className = "css_dialog_restaurant_sharePlayDiv";

		dialog_restaurant_title.appendChild(titleText);
		dialog_restaurant_title.appendChild(shareDiv);

		var dialog_restaurant_inner_div = document.createElement("div");
		dialog_restaurant_inner_div.className = "css_dialog_restaurant_inner_div";

		dialog_restaurant_inner_div.appendChild(dialog_restaurant_title);

		var currentShowItems = 5;
		if (items < currentShowItems) {
			currentShowItems = items;
		}

		var lastItem = null;
		for (var i = 0; i < currentShowItems; i++) {
			var item = createRestaurantItem(restaurantInfo.taskHandler + "restaurant_" + i, restaurantInfo.reataurantItems[i].reataurantName, restaurantInfo.reataurantItems[i].restaurantStarLevel, restaurantInfo.reataurantItems[i].restaurantAddress, restaurantInfo.reataurantItems[i].reataurantAvgPrice);
			dialog_restaurant_inner_div.appendChild(item);

			if ((i + 1) != currentShowItems) {
				dialog_restaurant_inner_div.appendChild(createRestaurantDivier());
			}

			if (i == currentShowItems - 1) {
				lastItem = item;
			}
		}

		var btn_more = null;
		if (items > 5) {
			dialog_restaurant_inner_div.appendChild(createRestaurantDivier());
			btn_more = document.createElement("div");
			btn_more.id = restaurantInfo.taskHandler + "restaurant_" + currentShowItems;
			btn_more.className = "css_dialog_restaurant_item_div css_dialog_restaurant_more_div";
			var btn_more_text = document.createElement("label");
			btn_more_text.innerText = "查看更多";
			var btn_more_goto = document.createElement("img");
			btn_more_goto.className = "css_dialog_restaurant_more_goto_icon";
			btn_more_goto.src = dialog_goto_right_icon;
			btn_more.appendChild(btn_more_text);
			btn_more.appendChild(btn_more_goto);
			dialog_restaurant_inner_div.appendChild(btn_more);
		}

		var restauBottom = createCMBottomRestau();
		dialog_restaurant_inner_div.appendChild(restauBottom);

		outDiv.appendChild(dialog_restaurant_canvas);
		outDiv.appendChild(dialog_restaurant_inner_div);

		if (items < 6 && restaurantInfo.cmFlag) {
			var restauLink = createCMRestauLink();
			outDiv.appendChild(restauLink);
			restauLink.addEventListener("click", function() {
				exec(restaurantInfo.taskHandler, 'gotoBrowser', []);
			}, false);
		}

		document.body.appendChild(outDiv);

		var canvasHeight = dialog_restaurant_inner_div.clientHeight;
		dialog_restaurant_canvas.setAttribute("height", canvasHeight + "px");
		console.log("canvasHeight:" + canvasHeight);
		draw(dialog_restaurant_canvas, img_dialog_view_bg, dialog_view_bg_coordinates);

		showOpacityAnimation(outDiv, 150);

		// 设置当前可删除view
		// currentCanDeleteView = outDiv;
		var touchObj = {
			returnArgument : null,
			touchElement : null,
			btn : btn_more,
			touchStart : function(event) {
				this.touchElement = event.target;
				if (this.touchElement != this.btn) {
					this.touchElement = getParentOfClass("css_dialog_restaurant_item_div", this.touchElement);
				}
				this.touchElement.style.background = "url('" + list_item_background_pressed + "')";
			},
			touchMove : function() {
				if (this.touchElement !== null) {
					this.touchElement.style.background = "";
				}

			},
			touchEnd : function() {
				if (this.touchElement != null) {
					this.touchElement.style.background = "";
					this.returnArgument = this.touchElement.id;
				}
				this.touchElement = null;
			}
		};

		enableScrollTouch(dialog_restaurant_inner_div, 15, touchObj);
		var taskHandler = restaurantInfo.taskHandler;
		dialog_restaurant_inner_div.addEventListener("scrolltouch", function() {
			var myDate = new Date();
			console.log("ShopListActivity js Request start time is " + myDate.getTime());
			exec(taskHandler, 'launcherResult', [touchObj.returnArgument]);
		}, false);

		outDiv.refresh = function() {
			// 背景
			reDraw(dialog_restaurant_canvas, img_dialog_view_bg, dialog_view_bg_coordinates);

			// 分割线
			var lineElements = document.getElementsByClassName('css_dialog_restaurant_divider_line');
			if (lineElements != null && lineElements.length > 0) {
				for (var i = 0; i < lineElements.length; i++) {
					lineElements[i].style.backgroundImage = "url('" + dialog_list_divider + "')";
				}
			}

			// 星星图标
			var starImgElements = document.getElementsByClassName('css_dialog_restaurant_level_star');
			if (starImgElements != null && starImgElements.length > 0) {
				for (var i = 0; i < starImgElements.length; i++) {
					if (starImgElements[i].src.indexOf('star_full')) {
						starImgElements[i].src = restaurant_star_full;
					} else if (starImgElements[i].src.indexOf('star_half')) {
						starImgElements[i].src = restaurant_star_half;
					} else {
						starImgElements[i].src = restaurant_star_empty;
					}
				}
			}
		};

		return outDiv;
	}
	return createRestaurantView;
}); 