/**
 * 短信视图
 * 
 * @author leleliu008
 * @author modified by mdhuang 2013-3-22
 */
define(function() {
	// java回调，更新短信界面
	function updateSmsData(smsJson) {
		console.log("sms update is called");
		console.log("sms update data is :" + smsJson);
		if (smsSendView) {
			smsSendView.updateSmsData(smsJson);
		}
	}
	
	function createCarmodeSmsFlag(smsState,smsHandler){
	    var carMode = document.createElement("div");
	    carMode.className = "css_car_sms_container";
	    var recordBlock = document.createElement("div");
	    recordBlock.style.opacity = "0";
	    var recordIcon = document.createElement("img");
	    recordIcon.src = dialogmode_car_sms_record;
	    recordIcon.className = "css_car_sms_record";
	    var recordDes = document.createElement("label");
	    recordDes.className = "css_car_sms_des";
	    recordDes.innerHTML = "录音中...";
	    recordBlock.appendChild(recordIcon);
	    recordBlock.appendChild(recordDes);
	
	    var playBlock = document.createElement("div");
	    var playIcon = document.createElement("img");
	    playIcon.src = dialogmode_car_sms_play;
	    playIcon.className = "css_car_sms_record";
	    var playDes = document.createElement("label");
	    playDes.className = "css_car_sms_des";
	    playDes.innerHTML = "点击播放";
	    playBlock.appendChild(playIcon);
	    playBlock.appendChild(playDes);
	    
	    if(smsState==0){
	    	playBlock.style.display = "none";
	    }else{
	    	recordBlock.style.display = "none";
	    }
	
	    carMode.appendChild(recordBlock);
	    carMode.appendChild(playBlock);
	
		carMode.stopRecording = function(){
	        recordBlock.style.display = "none";
	        playBlock.style.display = "block";
	    }
	    carMode.startRecording = function(){
	        recordBlock.style.display = "block";
	       	recordBlock.style.opacity = "1";
	        playBlock.style.display = "none";
	    }
	    playBlock.addEventListener("touchstart",function(){
	        event.stopPropagation();
	        carMode.style.background = "url('" + dialogmode_car_sms_press + "') repeat-x";
	    },true);
	    playBlock.addEventListener("touchmove",function(){
	        event.stopPropagation();
	        carMode.style.background = "";
	        forceRefreshScreen();
	    },true);
	    playBlock.addEventListener("touchend",function(){
	        event.stopPropagation();
	        carMode.style.background = "";
	        forceRefreshScreen();
	        exec(smsHandler, "replaySmsAudio", []);
	    },true);
		
	    return carMode;
	}
	
	// 创建短信视图界面
	function createSms(smsJson) {
		if (smsJson.smsContent === "") {
			isConfirmBtnClickable = false;
		} else {
			isConfirmBtnClickable = true;
		}
		var taskHandler = smsJson.taskHandler;
		var sms_view = document.createElement("div");
		sms_view.className = "css_sms_view";
		var sms_inner = document.createElement("div");
		sms_inner.className = "css_sms_inner";

		var sms_bg = document.createElement("canvas");
		sms_bg.className = "css_dialog_absolute_bg";
		sms_bg.setAttribute("width", dialog_box_canvas_width + "px");

		var smsTitle = document.createElement("div");
		smsTitle.className = "css_sms_title_out";

		var smsTitleInner = document.createElement("div");
		smsTitleInner.className = "css_sms_title_inner";

		var smsTitleCanvas = document.createElement("canvas");
		smsTitleCanvas.className = "css_dialog_absolute_bg";

		var sms_contact_left = document.createElement("div");
		sms_contact_left.className = "css_sms_title_left";

		var sms_phone = document.createElement("div");
		sms_phone.className = "css_sms_phone";

		if (!smsJson.hasDefault) {
			sms_phone.style.display = "none";
		}

		var sms_name = document.createElement("div");
		sms_name.className = "css_sms_name";

		// 有默认号码
		if (smsJson.hasDefault) {
			sms_name.innerText = smsJson.contactName;
		} else {
			// 没有默认号码，与原来的相同
			var contactList = smsJson.contactNameList;
			if (contactList != null && contactList.length > 0) {
				for ( var i = 0; i < contactList.length; i++) {
					sms_name.innerHTML = sms_name.innerHTML + contactList[i];
					if (i + 1 < contactList.length) {
						sms_name.innerHTML += "，";
					}
				}
			}
		}

		var sms_num_select = document.createElement("div");
		sms_num_select.className = "css_sms_loca_div";

		var sms_phone_location = document.createElement("div");
		sms_phone_location.id = "dialog_sms_location";
		sms_phone_location.className = "css_sms_location";
		sms_phone_location.innerText = smsJson.location;

		var sms_phone_select = document.createElement("img");
		sms_phone_select.className = "css_sms_select";
		sms_phone_select.src = dialogmode_sms_select_normal;

		sms_num_select.appendChild(sms_phone_location);
		sms_num_select.appendChild(sms_phone_select);

		var sms_phone_num = document.createElement("div");
		sms_phone_num.id = "dialog_sms_num";
		sms_phone_num.innerText = smsJson.phoneNumber;

		sms_phone.appendChild(sms_num_select);
		sms_phone.appendChild(sms_phone_num);

		sms_contact_left.appendChild(sms_name);
		sms_contact_left.appendChild(sms_phone);

		smsTitleInner.appendChild(sms_contact_left);

		var sms_title_divider = document.createElement("img");
		sms_title_divider.className = "css_sms_tittle_divider";
		sms_title_divider.src = dialogmode_sms_title_divdier;

		var sms_edit = document.createElement("img");
		sms_edit.className = "css_sms_contact_edit";
		sms_edit.src = dialogmode_sms_edit_normal;

		smsTitleInner.appendChild(sms_title_divider);
		smsTitleInner.appendChild(sms_edit);

		smsTitle.appendChild(smsTitleInner);
		smsTitle.appendChild(smsTitleCanvas);

		var sms_inputBox = document.createElement("textarea");
		sms_inputBox.className = "css_sms_content_inner";
		sms_inputBox.id = 'smsInput' + smsJson.taskHandler;
		sms_inputBox.value = smsJson.smsContent;

		var carModeBlock,carModeDivider,audioUrl;
		
		sms_inner.appendChild(smsTitle);
		
		if(smsJson.isMMS && smsJson.smsState<1){
			carModeBlock = createCarmodeSmsFlag(smsJson.smsState,taskHandler);
		    carModeDivider = document.createElement("div");
		    carModeDivider.className = "css_car_sms_divider";
		    sms_inner.appendChild(carModeBlock);
			sms_inner.appendChild(carModeDivider);
		}
		sms_inner.appendChild(sms_inputBox);

		if(smsJson.ime){
			var isImeMove = false;
			var imeIcon = document.createElement("img");
		    imeIcon.src = ime_normal;
		    imeIcon.className = "css_imeIcon"
		    imeIcon.addEventListener("touchstart",function(){
		        event.stopPropagation();
		        isImeMove = false;
		        imeIcon.src = ime_press;
		    });
		    imeIcon.addEventListener("touchmove",function(){
		        event.stopPropagation();
		        isImeMove = true;
		        imeIcon.src = ime_normal;
		    });
		    imeIcon.addEventListener("touchend",function(){
		        event.stopPropagation();
		        imeIcon.src = ime_normal;
		        exec(taskHandler, 'selectIme', []);
		    });
		    sms_inner.appendChild(imeIcon);
		    sms_view.removeImeIcon = function(){
		    	sms_inner.removeChild(imeIcon);
		    	imeIcon = null;
		    }
		}

		
		sms_view.appendChild(sms_bg);
		sms_view.appendChild(sms_inner);

		// 创建底部确定取消按钮
		var dialog_btn_div = document.createElement("div");
		dialog_btn_div.id = "sms_bottom_btn" + taskHandler;
		dialog_btn_div.className = "css_dialog_sms_bottom_btn_div";

		var dialog_btntext_div = document.createElement("div");
		dialog_btntext_div.className = "css_dialog_bottom_btntext_div";
		dialog_btntext_div.style.height = dialog_remind_btn_canvas_height + "px";
		dialog_btntext_div.style.lineHeight = dialog_remind_btn_canvas_height + "px";

		// 取消按钮
		var cancelButton = createButtonDiv(dialog_remind_btn_canvas_width,
				dialog_remind_btn_canvas_height, "取  消");
		cancelButton.className = "css_dialog_remind_bottom_btncanvas_confirm";

		// 发送按钮
		var sendButton = createButtonDiv(dialog_remind_btn_canvas_width,
				dialog_remind_btn_canvas_height, "发  送");
		sendButton.id = taskHandler + "sendButton";

		dialog_btntext_div.appendChild(cancelButton);
		dialog_btntext_div.appendChild(sendButton);

		var dialog_confirmbtn_canvas = createBgCanvas(dialog_remind_btn_canvas_width);
		dialog_confirmbtn_canvas.className = "css_dialog_absolute_right_bg";
		dialog_confirmbtn_canvas.setAttribute("height", dialog_remind_btn_canvas_height + "px");
		dialog_confirmbtn_canvas.id = "smsConfirm" + taskHandler;

		var dialog_cancelbtn_canvas = createBgCanvas(dialog_remind_btn_canvas_width);
		dialog_cancelbtn_canvas.className = "css_dialog_absolute_bg";
		dialog_cancelbtn_canvas.setAttribute("height", dialog_remind_btn_canvas_height + "px");

		dialog_btn_div.appendChild(dialog_cancelbtn_canvas);
		dialog_btn_div.appendChild(dialog_confirmbtn_canvas);
		dialog_btn_div.appendChild(dialog_btntext_div);

		sendButton.addEventListener("touchstart", function() {
			if (isConfirmBtnClickable) {
				reDraw(dialog_confirmbtn_canvas, img_dialog_btnpressed_bg,
						dialog_btn_bg_coordinates);
			}
		}, false);
		sendButton.addEventListener("touchend", function() {
			console.log("isConfirmBtnClickable:" + isConfirmBtnClickable);
			if (isConfirmBtnClickable) {
				reDraw(dialog_confirmbtn_canvas, img_dialog_btnnomal_bg,
						dialog_btn_bg_coordinates);

				var sms_inputBox = document.getElementById('smsInput' + taskHandler);
				// 调用java函数执行发送短信的请求
				exec(taskHandler, 'smsSend', [ sms_inputBox.value ]);

				// 通知java函数释放相关资源
				exec('WidgetMMPContainerComponents', 'removeViewForJs', [ taskHandler ]);

				// 刷新界面
				onSmsFinish(true, taskHandler);
			}
		}, false);

		cancelButton.addEventListener("touchstart", function() {
			reDraw(dialog_cancelbtn_canvas, img_dialog_btnpressed_bg,
					dialog_btn_bg_coordinates);
		}, false);
		cancelButton.addEventListener("touchend", function() {
			reDraw(dialog_cancelbtn_canvas, img_dialog_btnnomal_bg,
					dialog_btn_bg_coordinates);

			// 调用java函数执行取消操作
			exec(taskHandler, 'smsCancel', []);
			// 通知java函数释放相关资源
			exec('WidgetMMPContainerComponents', 'removeViewForJs', [ taskHandler ]);

			// 刷新界面
			onSmsFinish(false, taskHandler);
		}, false);
		// //////////////////////////////////////

		// //////////////////////////////////////
		var innerTouchTarget = null;
		var innerTouchMove = false;
		sms_inner.addEventListener("touchstart", function(event) {
			innerTouchMove = false;
			moveOverCheck.start(event);
			innerTouchTarget = event.target;
			if (innerTouchTarget == sms_phone_select) {
				sms_phone_select.src = dialogmode_sms_select_pressed;
			} else if (innerTouchTarget == sms_edit) {
				sms_edit.src = dialogmode_sms_edit_pressed;
			}
		}, false);
		sms_inner.addEventListener("touchmove", function(event) {
			if (moveOverCheck.check(event)) {
				innerTouchMove = true;
				if (innerTouchTarget == sms_phone_select) {
					sms_phone_select.src = dialogmode_sms_select_normal;
				} else if (innerTouchTarget == sms_edit) {
					sms_edit.src = dialogmode_sms_edit_normal;
				}
			}
		}, false);
		sms_inner.addEventListener("touchend", function() {
			if (innerTouchMove == false) {
				if (innerTouchTarget == sms_phone_select) {
					sms_phone_select.src = dialogmode_sms_select_normal;
					exec(taskHandler, "selectContact", []);
				} else if (innerTouchTarget == sms_edit) {
					sms_edit.src = dialogmode_sms_edit_normal;
					exec(taskHandler, "editContacts", [ sms_inputBox.value ]);
				} else if (innerTouchTarget == sms_inputBox) {
					sms_inputBox.blur();
					document.body.focus();
					exec(taskHandler, "inputEdit", [ sms_inputBox.value ]);
				}
			}
		}, false);
		sms_inputBox.addEventListener("focus", function() {
			sms_inputBox.blur();
		});
		// //////////////////////////////////////
		sms_view.appendChild(dialog_btn_div);

		document.body.appendChild(sms_view);
		currentCanDeleteView = sms_view;
		smsSendView = sms_view;

		console.log(sms_contact_left.clientHeight);

		sms_title_divider.style.height = sms_contact_left.clientHeight - 4 + "px";
		smsTitleCanvas.setAttribute("height", sms_contact_left.clientHeight + "px");
		smsTitleCanvas.setAttribute("width", dialog_box_canvas_width - 10 + "px");
		sms_bg.setAttribute("height", sms_inner.clientHeight + "px");

		draw(smsTitleCanvas, dialogmode_sms_title_bg,
				dialog_sms_title_bg_coordinates);
		draw(sms_bg, dialogmode_sms_nbg, dialog_sms_nbg_coordinates);

		// 设置取消按钮的背景图片
		draw(dialog_cancelbtn_canvas, img_dialog_btnnomal_bg,
				dialog_btn_bg_coordinates);

		// 设置确定按钮的背景图片
		if (isConfirmBtnClickable) {
			sendButton.className = "css_dialog_btn_normal";
			draw(dialog_confirmbtn_canvas, img_dialog_btnnomal_bg,
					dialog_btn_bg_coordinates);
		} else {
			sendButton.className = "css_dialog_btn_disabled";
			reDraw(dialog_confirmbtn_canvas, img_dialog_btndisabled_bg,
					dialog_btn_bg_coordinates);
		}

		sms_view.updateSmsData = function(newSmsJson) {
			var newSmsInfo = eval("(" + newSmsJson + ")");
			var newTaskHandler = newSmsInfo.taskHandler;

			if (newSmsInfo.smsContent === "") {
				if(audioUrl){
					isConfirmBtnClickable = true;
				}else{
					isConfirmBtnClickable = false;
				}
			} else {
				isConfirmBtnClickable = true;
			}

			sms_inputBox.value = newSmsInfo.smsContent;
			setTimeout(function() {
				sms_inputBox.blur();
				document.body.focus();
			}, 150);

			if (newSmsInfo.hasDefault) {
				sms_name.innerText = newSmsInfo.contactName;
				sms_phone_location.innerText = newSmsInfo.location;
				sms_phone_num.innerText = newSmsInfo.phoneNumber;
				sms_phone.style.display = "block";
			} else {
				// 没有默认号码，与原来的相同
				var contactList = newSmsInfo.contactNameList;
				console.log("sms update naes is: " + contactList);
				console.log("name list.length is :" + contactList.length);
				sms_name.innerHTML = "";
				if (contactList != null && contactList.length > 0) {
					for ( var i = 0; i < contactList.length; i++) {
						sms_name.innerHTML = sms_name.innerHTML
								+ contactList[i];
						if (i + 1 < contactList.length) {
							sms_name.innerHTML += "，";
						}
					}
				} else {
					sms_name.innerHTML = "无收件人";
					isConfirmBtnClickable = false;
				}
				sms_phone.style.display = "none";
			}

			if (isConfirmBtnClickable) {
				sendButton.className = "css_dialog_btn_normal";
				reDraw(dialog_confirmbtn_canvas, img_dialog_btnnomal_bg,
						dialog_btn_bg_coordinates);
			} else {
				sendButton.className = "css_dialog_btn_disabled";
				reDraw(dialog_confirmbtn_canvas, img_dialog_btndisabled_bg,
						dialog_btn_bg_coordinates);
			}

			sms_title_divider.style.height = sms_contact_left.clientHeight - 4 + "px";
			smsTitleCanvas.setAttribute("height", sms_contact_left.clientHeight + "px");
			smsTitleCanvas.setAttribute("width", dialog_box_canvas_width - 10 + "px");
			sms_bg.setAttribute("height", sms_inner.clientHeight + "px");

			reDraw(smsTitleCanvas, dialogmode_sms_title_bg,
					dialog_sms_title_bg_coordinates);
			reDraw(sms_bg, dialogmode_sms_nbg, dialog_sms_nbg_coordinates);
		};
		sms_view.stopRecording = function(recordUrl){
			if(carModeBlock){
				carModeBlock.stopRecording();
				if(recordUrl){
					audioUrl = recordUrl;
					isConfirmBtnClickable = true;
					sendButton.className = "css_dialog_btn_normal";
					reDraw(confrmbtnCanvas, img_dialog_btnnomal_bg,
							dialog_btn_bg_coordinates);
					return true;
				}
			}
			return false;
		}
		sms_view.startRecording = function(){
			if(carModeBlock)
				carModeBlock.startRecording();
		}
		
		return sms_view;
	}

	// function updateSmsView(result) {
	// var smsInfo = eval('(' + result + ')');
	// var taskHandler = smsInfo.taskHandler;
	//
	// if (smsInfo.smsContent === "") {
	// isConfirmBtnClickable = false;
	// } else {
	// isConfirmBtnClickable = true;
	// }
	//
	// var sendButton = document.getElementById(taskHandler + "sendButton");
	// var confrmbtnCanvas = document.getElementById("smsConfirm"
	// + taskHandler);
	//
	// if (isConfirmBtnClickable) {
	// sendButton.className = "css_dialog_btn_normal";
	// reDraw(confrmbtnCanvas, img_dialog_btnnomal_bg,
	// dialog_btn_bg_coordinates);
	// } else {
	// sendButton.className = "css_dialog_btn_disabled";
	// reDraw(confrmbtnCanvas, img_dialog_btndisabled_bg,
	// dialog_btn_bg_coordinates);
	// }
	//
	// var sms_inputBox = document.getElementById("smsInput" + taskHandler);
	// sms_inputBox.value = smsInfo.smsContent;
	//
	// if (smsInfo.hasDefault) {
	// var contactNamelabel = document.getElementById("sms_contactName");
	// contactNamelabel.innerHTML = smsInfo.contactName;
	//
	// afterSelectNumber(smsInfo.location, smsInfo.phoneNumber);
	//
	// if (smsInfo.needShowMore) {
	//
	// }
	// } else {
	// var contactNameDiv = document.getElementById("sms_contactNameDiv"
	// + taskHandler);
	// var names = smsInfo.contactNameList;
	// if (names.length == 0) {
	// contactNameDiv.innerHTML = "无收件人";
	// } else if (names.length > 1) {
	// var str = "";
	// for ( var i = 0; i < names.length; i++) {
	// str += "，" + names[i];
	// if (i == 5) {
	// str += "..." + names.length + "人";
	// break;
	// }
	// }
	//
	// contactNameDiv.innerHTML = str;
	// }
	// }
	// }
	
	// java回调函数
	function removeImeIcon(){
		if(smsSendView){
			smsSendView.removeImeIcon();
		}
	}
	function afterSelectNumber(location, phoneNumber) {
		console.log('location:' + location + ' phoneNumber:' + phoneNumber);
		document.getElementById("dialog_sms_location").innerHTML = location;
		document.getElementById("dialog_sms_num").innerHTML = phoneNumber;
	}

	// 取消编辑后把 文本框的焦点清除
	function onSmsCancel(taskHandler) {
		var element = document.getElementById('smsInput' + taskHandler);
		element.blur();
		document.body.focus();
	}
	/**
	 * 短信识别结果，由java层调用
	 */
	function onSmsResult(result, taskHandler, textAddType) {
		console.log('onSmsResult, result is ' + result + ' ,taskHandler is '
				+ taskHandler);

		var element = document.getElementById('smsInput' + taskHandler);
		element.value = result;
		/*
		 * if(textAddType!==undefined){ //直接修改文本内容为 result element.value =
		 * result; }else{ //在文本末尾追加文字 result insertText(element, result); }
		 */
		// 解决部分手机界面不刷新的问题(如三星9100G)，因为焦点一直被输入框所占用。
		setTimeout(function() {
			element.blur();
			document.body.focus();
		}, 250);
		// element.blur();
		// document.body.focus();

		removeErrorView();
		if(!stopRecording("true")){
		
		var sendButton = document.getElementById(taskHandler + "sendButton");
		var confrmbtnCanvas = document.getElementById("smsConfirm" + taskHandler);
		
		if (isConfirmBtnClickable === false && result !== "") {
			isConfirmBtnClickable = true;
			sendButton.className = "css_dialog_btn_normal";
			reDraw(confrmbtnCanvas, img_dialog_btnnomal_bg,
					dialog_btn_bg_coordinates);
		} else if (isConfirmBtnClickable === true && result === "") {
			isConfirmBtnClickable = false;
			sendButton.className = "css_dialog_btn_disabled";
			reDraw(confrmbtnCanvas, img_dialog_btndisabled_bg,
					dialog_btn_bg_coordinates);
		}
		}
		// forceRefreshScreen();

		// if(result != null && result != "") {
		// 这里没有触发sms_inputBox的input事件，因此需要刷新底部按钮栏界面
		// var dialog_btn_div = document.getElementById("sms_bottom_btn" +
		// taskHandler);
		// var outDiv = dialog_btn_div.parentNode;
		// removeChild(outDiv,dialog_btn_div);
		// dialog_btn_div = createSmsBottomDiv(taskHandler, false);
		// outDiv.appendChild(dialog_btn_div);
		// }
	}

	/**
	 * 短信操作完成，删除底部按钮栏
	 */
	function onSmsFinish(isConfirm, taskHandler) {
		removeErrorView();
		isConfirmBtnClickable = false;
		removeCurrentCanDeleteView(taskHandler);
	}
	
	function stopRecording(recordUrl){
		smsSendView.stopRecording(recordUrl);
	}
	function startRecording(){
		smsSendView.startRecording();
	}
	// 将需要java回调的函数暴露到全局对象smsView中，方便外部java文件调用
	window.smsView = window.smsView || {};
	smsView.updateSmsData = updateSmsData;
	smsView.afterSelectNumber = afterSelectNumber;
	smsView.onSmsCancel = onSmsCancel;
	smsView.onSmsResult = onSmsResult;
	smsView.onSmsFinish = onSmsFinish;
	smsView.removeImeIcon = removeImeIcon;
	smsView.stopRecording = stopRecording;
	smsView.startRecording = startRecording;

	// 返回视图创建函数，便于main.js中的addE调用
	return createSms;
});
