/*************************车辆违章查询View***************************/

define(function(){
	var isVehicleNumberEmpty = false;
	var isEngineNumberEmpty = false;
	var vehicleNumber = "";
	var engineNumber = "";
	var vehicleNumberLength = 0;
	var firstWordOfVehicleNum;
	var queryClickable = true;
	var oldViolationView = null; // 保存车辆违章view对象
	var violationTaskHandler; // 保存车辆违章view对应的java层处理组件的标识
	/**
	 * 创建车辆违章查询视图
	 */
	function createVehicleQueryView(vehicleInfo) {
		// 删除oldViolationView
		if (oldViolationView != null && oldViolationView.parentNode == document.body) {
			removeChild(document.body, oldViolationView);
			// 调用java函数释放底层资源
			exec('WidgetMMPContainerComponents', 'removeViewForJs',
					[ violationTaskHandler ]);
		}
		var taskHandler = vehicleInfo.taskHandler;
		violationTaskHandler = taskHandler;
		
		var vehicleNumberText = vehicleInfo.vehicleNumber.toUpperCase();
		var engineNumberText = vehicleInfo.engineNumber.toUpperCase();
		var isMotorCheckBoxChecked = true;
	
		if (vehicleNumberText == "") {
			isVehicleNumberEmpty = true;
		} else {
			isVehicleNumberEmpty = false;
		}
	
		if (engineNumberText == "") {
			isEngineNumberEmpty = true;
		} else {
			isEngineNumberEmpty = false;
		}
		
		var container = createOutDiv();
	
		// 背景层
		var bg_canvas = createBgCanvas(dialog_box_canvas_width);
		bg_canvas.className = "css_dialog_absolute_bg";
	
		// 真正的盛放内容的容器
		var inner_div = document.createElement("div");
		inner_div.className = "css_dialog_vehicle_query_inner_container";
	
		//标题
		var vehicle_query_title_div = document.createElement("div");
		vehicle_query_title_div.className = "css_vehicle_query_title_div";
		
		var vehicle_query_title_text_div = document.createElement("div");
		vehicle_query_title_text_div.className = "css_vehicle_query_title_text_div";
		vehicle_query_title_text_div.innerText = "车辆违章查询";
		
		vehicle_query_title_div.appendChild(vehicle_query_title_text_div);
		
		//车辆信息div
		var vehicle_information_input_div = document.createElement("div");
		vehicle_information_input_div.className = "css_vehicle_information_input_div";
		
		//车辆信息输入容器背景层
		var vehicleInformationContainerBgCanvas = createBgCanvas(dialog_vehicle_infromation_container_BgCanvas_width);
		vehicleInformationContainerBgCanvas.className = "css_dialog_absolute_bg";
		vehicleInformationContainerBgCanvas.setAttribute("height",
				dialog_vehicle_infromation_container__height + "px");
	
		draw(vehicleInformationContainerBgCanvas, dialogmode_vehicle_content_input_bg,
				dialogmode_vehicle_content_input_bg_coordinates);
		
		//车辆信息输入外层容器，盛放真正的内容
		var vehicleInformationContainer = document.createElement("div");
		vehicleInformationContainer.className = "css_vehicle_Information_Container";
				
		//创建车牌号码容器
		var vehicleNumberContainer = document.createElement("div");
		vehicleNumberContainer.className = "css_vehicleNumberContainer";
		//标签
		var vehicleNumberLable = document.createElement("div");
		vehicleNumberLable.innerText = "车牌号码：";
		vehicleNumberLable.className = "css_vehicleNumberLable";
		//输入文本框
		var vehicleNumber_editText_input = document.createElement("input");
		vehicleNumber_editText_input.id = taskHandler + "vehicleNumber";
		vehicleNumber_editText_input.name = "vehicleNum_text_input";
		vehicleNumber_editText_input.value = vehicleNumberText;
		vehicleNumber_editText_input.maxLength = 18;
		vehicleNumber_editText_input.style.border = "none";
		vehicleNumber_editText_input.className = "css_dialog_vehicle_item_editText";
		vehicleNumber_editText_input.setAttribute("placeholder", "如：京A12345");
		
		//车牌号码容器
		vehicleNumberContainer.appendChild(vehicleNumberLable);
		vehicleNumberContainer.appendChild(vehicleNumber_editText_input);
		
		// 车辆号码和发动机号的分割线
		var seperator_line = document.createElement("img");
		seperator_line.className = "css_vehicle_horizontal_divider_in_input_frame";
		seperator_line.src = vehicle_horizontal_divider_in_input_frame;
	
		//创建发动机号容器
		var engineNumberContainer = document.createElement("div");
		engineNumberContainer.className = "css_vehicleNumberContainer";
		//标签
		var engineNumberLable = document.createElement("div");
		engineNumberLable.innerText = "发动机号：";
		engineNumberLable.className = "css_vehicleNumberLable";
		//输入文本框
		var engineNumber_editText_input = document.createElement("input");
		engineNumber_editText_input.id = taskHandler + "engineNumber";
		engineNumber_editText_input.name = "engineNum_text_input";
		engineNumber_editText_input.value = engineNumberText;
		engineNumber_editText_input.maxLength = 18;
		engineNumber_editText_input.style.border = "none";
		engineNumber_editText_input.className = "css_dialog_engine_item_editText";
		engineNumber_editText_input.setAttribute("placeholder", "输入行驶证上的发动机号");
		//发动机号容器
		engineNumberContainer.appendChild(engineNumberLable);
		engineNumberContainer.appendChild(engineNumber_editText_input);
		
		
		vehicleInformationContainer.appendChild(vehicleNumberContainer);
		vehicleInformationContainer.appendChild(seperator_line);
		vehicleInformationContainer.appendChild(engineNumberContainer);
		
		vehicle_information_input_div.appendChild(vehicleInformationContainerBgCanvas);
		vehicle_information_input_div.appendChild(vehicleInformationContainer);
		
		//保存车辆信息checkbox
		var saveVehicleInformationdiv = document.createElement("div");
		saveVehicleInformationdiv.className = "css_saveVehicleInformationdiv";
		
		var checkboxButton = document.createElement("img");
		checkboxButton.className = "css_checkboxButton";
		checkboxButton.id = "MotorcheckboxButton";
		checkboxButton.src = vehicle_query_checkbox_checked;
		
		var checkboxExplainLable = document.createElement("label");
		checkboxExplainLable.className = "css_checkboxExplainLable";
		checkboxExplainLable.innerText = "记住车辆信息";
		
		//保存车辆信息checkbox的外层div
		saveVehicleInformationdiv.appendChild(checkboxButton);
		saveVehicleInformationdiv.appendChild(checkboxExplainLable);
		
		
		//输入信息出错提示div
		var errorPromptdiv = document.createElement("div");
		errorPromptdiv.className = "css_errorPrompt_vehicleQuerydiv_noError";
		errorPromptdiv.id = "errorPromptdiv";
		
		var errorPromptImg = document.createElement("img");
		errorPromptImg.className = "css_errorPromptImg";
		errorPromptImg.id = "errorPromptImg";
		//errorPromptImg.src = vehicle_error_prompt;
		errorPromptImg.style.display = "none";
		
		var errorPromptLable = document.createElement("label");
		errorPromptLable.className = "css_errorPromptLable";
		errorPromptLable.innerHTML = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
		errorPromptLable.id = "errorPromptLable";
		
		
		//输入信息出错提示的外层div
		errorPromptdiv.appendChild(errorPromptImg);
		errorPromptdiv.appendChild(errorPromptLable);
		
		
		//查询按钮
		// 按钮容器
		var buttonContainer = document.createElement("div");
		buttonContainer.className = "css_dialog_vehicle_bottom_btn_div";
	
		// 保存按钮背景层
		var QueryButtonBgCanvas = createBgCanvas(dialog_vehicle_btn_canvas_width);
		QueryButtonBgCanvas.className = "css_dialog_absolute_bg";
		QueryButtonBgCanvas.setAttribute("height", dialog_vehicle_btn_canvas_height+"px");
		
		// 查询按钮
		var qureyButton = createButtonDiv(dialog_vehicle_btn_canvas_width,
				dialog_vehicle_btn_canvas_height, "查&nbsp;询");
		qureyButton.className = "css_dialog_vehicle_bottom_btntext_div";
		qureyButton.id = "vehicle_query_button";
		
		buttonContainer.appendChild(QueryButtonBgCanvas);
		buttonContainer.appendChild(qureyButton);
		
		var vehicleQueryTipHorizontalDivider = document.createElement("img");
		vehicleQueryTipHorizontalDivider.className = "css_vehicleQueryTipHorizontalDivider";
		vehicleQueryTipHorizontalDivider.src = vehicle_horizontal_divider_under_query_button;
		//车辆查询tip
		var vehicleQueryTip = document.createElement("div");
		vehicleQueryTip.className = "css_vehicleQueryTip";
		vehicleQueryTip.innerText = "当前仅支持查询北京市车辆，更多省市敬请期待。";
	
		inner_div.appendChild(vehicle_query_title_div);
		inner_div.appendChild(vehicle_information_input_div);
		inner_div.appendChild(saveVehicleInformationdiv);
		inner_div.appendChild(errorPromptdiv);
		inner_div.appendChild(buttonContainer);
		inner_div.appendChild(vehicleQueryTipHorizontalDivider);
		inner_div.appendChild(vehicleQueryTip);
		
		container.appendChild(bg_canvas);
		container.appendChild(inner_div);
	
		document.body.appendChild(container);
		oldViolationView = container;
		currentCanDeleteView = container;
	
		// 设置背景层的高度
		var canvasHeight = inner_div.clientHeight;
		bg_canvas.setAttribute("height", canvasHeight + "px");
		console.log("canvasHeight:" + canvasHeight);
	
		// 计算设置背景图片
		draw(bg_canvas, dialogmode_contact_bg, dialog_view_bg_coordinates);
		
		// 设置查询按钮的背景图片
		draw(QueryButtonBgCanvas, vehicle_query_button_backgroud_normal,
				vehicle_query_button_backgroud_normal_coordinates);
		
		var hintText = "如：京A12345";
		var inputname = "vehicleNum_text_input";	
		//输入框点击事件--车牌号码输入框
		vehicleNumber_editText_input.addEventListener("click", function() {
			console.log('onclick begin');
			// 停止语音交互流程
			// exec(taskHandler, 'stopVoiceInteraction', []);
			exec("WidgetMMPContainerComponents", 'inputEdit', [ "motor_violation",
					taskHandler, vehicleNumber_editText_input.value, "vehicleNum_text_input", "如：京A12345" ]);
		}, false);
		//输入框点击事件--发动机号输入框
		engineNumber_editText_input.addEventListener("click", function() {
			console.log('onclick begin');
			// 停止语音交互流程
			// exec(taskHandler, 'stopVoiceInteraction', []);
			exec("WidgetMMPContainerComponents", 'inputEdit', [ "motor_violation",
					taskHandler, engineNumber_editText_input.value, "engineNum_text_input", "请输入行驶证上的发动机号" ]);
		}, false);
		
		
		
		//保存的checkbox点击事件
		checkboxButton.addEventListener("touchstart",function() {
			
		}, false);
		checkboxButton.addEventListener("touchend",function() {
			if (isMotorCheckBoxChecked) {
				checkboxButton.src = vehicle_query_checkbox_unchecked;
				isMotorCheckBoxChecked = false;
			} else {
				checkboxButton.src = vehicle_query_checkbox_checked;
				isMotorCheckBoxChecked = true;
			}
		}, false);
		
		//查询按钮点击事件
		qureyButton.addEventListener("touchstart",function() {
			if(queryClickable){
				vehicleNumber = vehicleNumber_editText_input.value;
				engineNumber = engineNumber_editText_input.value;
				firstWordOfVehicleNum = vehicleNumber.substring(0,1);
				vehicleNumberLength = vehicleNumber.length;
				if(vehicleNumber == ""){
					isVehicleNumberEmpty = true;
				}else{
					isVehicleNumberEmpty = false;
				}
				
				if(engineNumber == ""){
					isEngineNumberEmpty = true;
				}else{
					isEngineNumberEmpty = false;
				}
				// 查询按钮的按下背景
				if(!isVehicleNumberEmpty && !isEngineNumberEmpty){
					if(vehicleNumberLength == 7){
						if(firstWordOfVehicleNum != "京"){
							errorPromptImg.style.display = "inline-block";
							errorPromptdiv.className = "css_errorPrompt_vehicleQuerydiv_forWrongPlace";
							errorPromptImg.src = vehicle_error_prompt;
							errorPromptLable.innerHTML = "很抱歉，暂不支持非北京车牌号的查询！";
						}else{
							errorPromptImg.style.display = "none";
							errorPromptdiv.className = "css_errorPrompt_vehicleQuerydiv_noError";
							errorPromptLable.innerHTML = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
							draw(QueryButtonBgCanvas, vehicle_query_button_backgroud_pressed,
								vehicle_query_button_backgroud_pressed_coordinates);
						}
					}else{
						errorPromptImg.style.display = "inline-block";
						errorPromptdiv.className = "css_errorPrompt_vehicleQuerydiv_forVehicleNum";
						errorPromptImg.src = vehicle_error_prompt;
						errorPromptLable.innerHTML = "请输入正确的车牌号码";
					}
					
				}else{
					if(isVehicleNumberEmpty){
						errorPromptImg.style.display = "inline-block";
						errorPromptdiv.className = "css_errorPrompt_vehicleQuerydiv_withoutContent";
						errorPromptImg.src = vehicle_error_prompt;
						errorPromptLable.innerHTML = "车牌号码不能为空";
					}else if(isEngineNumberEmpty){
						errorPromptImg.style.display = "inline-block";
						errorPromptdiv.className = "css_errorPrompt_vehicleQuerydiv_withoutContent";
						errorPromptImg.src = vehicle_error_prompt;
						errorPromptLable.innerHTML = "发动机号不能为空";
					}
				}
			}
			
		}, false);
		qureyButton.addEventListener("touchend",function() {
			if(queryClickable){
				if(!isVehicleNumberEmpty && !isEngineNumberEmpty && vehicleNumberLength == 7 && firstWordOfVehicleNum == "京"){
					draw(QueryButtonBgCanvas, vehicle_query_button_backgroud_normal,
						vehicle_query_button_backgroud_normal_coordinates);
					qureyButton.innerHTML = "正在查询&nbsp;...";
					queryClickable = false;
					vehicleNumber_editText_input.setAttribute('disabled','disabled');
					engineNumber_editText_input.setAttribute('disabled','disabled');
					exec(taskHandler, 'isQueryMotorSuccess', [vehicleNumber, engineNumber, isMotorCheckBoxChecked]);
				}
			}
		}, false);
		return container;
	}
	
	function onVehicleCancel(taskHandler, editType) {
		if (editType === "vehicleNum_text_input") {
			document.getElementById(taskHandler + "vehicleNumber").blur();
		} else {
			document.getElementById(taskHandler + "engineNumber").blur();
		}
		document.body.focus();
		var vehicleNum = document.getElementById(taskHandler + "vehicleNumber").value;
		if(vehicleNum.length == 7){
			document.getElementById("errorPromptImg").style.display = "none";
			document.getElementById("errorPromptdiv").className = "css_errorPrompt_vehicleQuerydiv_noError";
			document.getElementById("errorPromptLable").innerHTML = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
		}else{
			document.getElementById("errorPromptImg").style.display = "inline-block";
			document.getElementById("errorPromptdiv").className = "css_errorPrompt_vehicleQuerydiv_forVehicleNum";
			document.getElementById("errorPromptImg").src = vehicle_error_prompt;
			document.getElementById("errorPromptLable").innerHTML = "请输入正确的车牌号码";
		}
	}
	function onVehicleResult(taskHandler, content, editType) {
		var isConfirmOriginal = isVehicleNumberEmpty && isEngineNumberEmpty;
		if (editType === "vehicleNum_text_input") {
			console.log("text content is " + content);
			if (content === "") {
				isVehicleNumberEmpty = true;
			} else {
				isVehicleNumberEmpty = false;
			}
			document.getElementById(taskHandler + "vehicleNumber").value = content.toUpperCase();
			// 解决点击后input框获取焦点，而事件加在外部的container上，造成container无法获取焦点，事件没有响应
			setTimeout(function() {
				document.getElementById(taskHandler + "vehicleNumber").blur();
				document.body.focus();
			}, 250);
			// document.getElementById(taskHandler+"contactName").blur();
			// document.body.focus();
		} else if (editType === "engineNum_text_input") {
			console.log("tel content is " + content);
			if (content === "") {
				isEngineNumberEmpty = true;
			} else {
				isEngineNumberEmpty = false;
			}
			document.getElementById(taskHandler + "engineNumber").value = content.toUpperCase();
			setTimeout(function() {
				document.getElementById(taskHandler + "engineNumber").blur();
				document.body.focus();
			}, 250);
			// document.getElementById(taskHandler+"engineNumber").blur();
			// document.body.focus();
		}
		var vehicleNum = document.getElementById(taskHandler + "vehicleNumber").value;
		if(vehicleNum.length == 7){
			document.getElementById("errorPromptImg").style.display = "none";
			document.getElementById("errorPromptdiv").className = "css_errorPrompt_vehicleQuerydiv_noError";
			document.getElementById("errorPromptLable").innerHTML = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
		}else{
			document.getElementById("errorPromptImg").style.display = "inline-block";
			document.getElementById("errorPromptdiv").className = "css_errorPrompt_vehicleQuerydiv_forVehicleNum";
			document.getElementById("errorPromptImg").src = vehicle_error_prompt;
			document.getElementById("errorPromptLable").innerHTML = "请输入正确的车牌号码";
		}

	}
	
		
	/**
	 *回调函数 
	 */
	function refreshViolationSearchShow(queryResult){
		document.getElementById("vehicle_query_button").innerHTML = "查&nbsp;询";
		queryClickable = true;
		var vehicleNumInputId = violationTaskHandler + "vehicleNumber";
		var engineNumInputId = violationTaskHandler + "engineNumber";
		document.getElementById(vehicleNumInputId).removeAttribute('disabled');
		document.getElementById(engineNumInputId).removeAttribute('disabled');
		if(queryResult == 1){//查询成功
			document.getElementById("errorPromptImg").style.display = "none";
			document.getElementById("errorPromptdiv").className = "css_errorPrompt_vehicleQuerydiv_noError";
			document.getElementById("errorPromptLable").innerHTML = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
			if (oldViolationView != null && oldViolationView.parentNode == document.body) {
				removeChild(document.body, oldViolationView);
				// 调用java函数释放底层资源
				exec('WidgetMMPContainerComponents', 'removeViewForJs',
						[ violationTaskHandler ]);
			}
		}else if(queryResult == 2){
			document.getElementById("errorPromptImg").style.display = "inline-block";
			document.getElementById("errorPromptImg").src = vehicle_error_prompt;
			document.getElementById("errorPromptdiv").className = "css_errorPrompt_vehicleQuerydiv_forSearchResultNull";
			document.getElementById("errorPromptLable").innerHTML = "对不起，没有查询到您想要数据";
		}else if(queryResult == 3){
			document.getElementById("errorPromptImg").style.display = "inline-block";
			document.getElementById("errorPromptImg").src = vehicle_error_prompt;
			document.getElementById("errorPromptdiv").className = "css_errorPrompt_vehicleQuerydiv_forNoNet";
			document.getElementById("errorPromptLable").innerHTML = "网络未打开，请检查网络设置";
		}else if(queryResult == 4){
			document.getElementById("errorPromptImg").style.display = "inline-block";
			document.getElementById("errorPromptImg").src = vehicle_error_prompt;
			document.getElementById("errorPromptdiv").className = "css_errorPrompt_vehicleQuerydiv_forNoNet";
			document.getElementById("errorPromptLable").innerHTML = "网络连接超时，请重新提交一下";
		}
	}
	
	//回调函数，当查询fail时更新查询界面
	function onViolationSearchFail(failDescription){
			document.getElementById("vehicle_query_button").innerHTML = "查&nbsp;询";
			queryClickable = true;
			var vehicleNumInputId = violationTaskHandler + "vehicleNumber";
			var engineNumInputId = violationTaskHandler + "engineNumber";
			document.getElementById(vehicleNumInputId).removeAttribute('disabled');
			document.getElementById(engineNumInputId).removeAttribute('disabled');
			document.getElementById("errorPromptImg").style.display = "inline-block";
			document.getElementById("errorPromptdiv").className = "css_errorPrompt_vehicleQuerydiv_forSearchResultNull";
			document.getElementById("errorPromptImg").src = vehicle_error_prompt;
			document.getElementById("errorPromptLable").innerHTML = failDescription;
	}
	
	window.vehicleQueryView = window.vehicleQueryView || {};
	vehicleQueryView.onVehicleResult = onVehicleResult;
	vehicleQueryView.onVehicleCancel = onVehicleCancel;
	vehicleQueryView.refreshViolationSearchShow = refreshViolationSearchShow;
	vehicleQueryView.onViolationSearchFail = onViolationSearchFail;
	
	return createVehicleQueryView;
});