/**
 * 车辆违章查询结果
 * 
 * @author ppfeng 2013-4-15
 */
define(function() {
	var oldViolationView = null; // 保存车辆违章view对象
	var violationTaskHandler; // 保存车辆违章view对应的java层处理组件的标识
	var isViolationRemindNotice = true;//是否打开违章提醒
	function createVehicleInformationView(vehicleResultInfo) {
		
		// 删除oldViolationView
		if (oldViolationView != null && oldViolationView.parentNode == document.body) {
			removeChild(document.body, oldViolationView);
			violation_item_show = 2;
			// 调用java函数释放底层资源
			exec('WidgetMMPContainerComponents', 'removeViewForJs',
					[ violationTaskHandler ]);
		}
		
		var container = createOutDiv();
		var vehicleNumberText = vehicleResultInfo.vehicleNumber;
		var violationListLen = vehicleResultInfo.violationListLength;
		var violation_item_show = 2;
		violationTaskHandler = vehicleResultInfo.taskHandler;
		isViolationRemindNotice = vehicleResultInfo.isRemindOpen;
		
		// 背景层
		var bg_canvas = createBgCanvas(dialog_box_canvas_width);
		bg_canvas.className = "css_driver_credit_bg";

		//真正的盛放内容的容器
		var innerdiv = document.createElement("div");
		innerdiv.className = "css_vehicle_violation_information_div";
		
		//标题栏
		var titleBar = document.createElement("div");
		titleBar.style.display = "inline-block";
		titleBar.className = "css_vehicle_violation_information_titleBar_div";
		//标题栏文字
		var titleTextDiv = document.createElement("div");
		titleTextDiv.className = "css_vehicle_violation_information_titleText_div";
		//标题栏大标题--“违章信息”
		var titleViolationInforDiv = document.createElement("div");
		titleViolationInforDiv.className = "css_titleViolationInforDiv";
		titleViolationInforDiv.innerText = "违章信息";
		//标题栏车牌号
		var titleVehicleNumberDiv = document.createElement("div");
		titleVehicleNumberDiv.innerText = vehicleNumberText;
		titleVehicleNumberDiv.className = "css_titleVehicleNumberDiv";
		
		titleTextDiv.appendChild(titleViolationInforDiv);
		titleTextDiv.appendChild(titleVehicleNumberDiv);
		
		//标题栏图片容器
		var titleImageDiv = document.createElement("div");
		titleImageDiv.style.display = "inline-block";
		titleImageDiv.className = "css_vehicle_violation_information_titleImage_div";
		//标题栏提醒图片
		var titleRemindImage = document.createElement("img");
		titleRemindImage.id = "vehicle_violation_information_title_RemindImage";
		titleRemindImage.style.display = "inline-block";
		titleRemindImage.className = "css_vehicle_violation_information_titleRemind_image";
		if(isViolationRemindNotice){
			titleRemindImage.src = vehicle_remind_open;
		}else{
			titleRemindImage.src = vehicle_remind_closed;
		}
		titleRemindImage.setAttribute("ontouchstart", "touchstart('vehicle_violation_information_title_RemindImage')");
		titleRemindImage.setAttribute("ontouchmove", "touchmove('vehicle_violation_information_title_RemindImage')");
		titleRemindImage.setAttribute("ontouchend", "touchend('vehicle_violation_information_title_RemindImage')");
		//标题栏垂直分隔线
		var titleVerticalDividerImage = document.createElement("img");
		titleVerticalDividerImage.style.display = "inline-block";
		titleVerticalDividerImage.className = "css_vehicle_violation_information_titleVerticalDivider_image";
		titleVerticalDividerImage.src = vehicle_vertical_divider_between_remind_menu;
		//标题栏折叠图片
		var titleFoldImage = document.createElement("img");
		titleFoldImage.id = "vehicle_violation_information_title_FoldImage";
		titleFoldImage.style.display = "inline-block";
		titleFoldImage.src = vehicle_query_menu_fold_state_normal_img;
		titleFoldImage.className = "css_vehicle_violation_information_titleFold_image";
		
		titleImageDiv.appendChild(titleRemindImage);
		titleImageDiv.appendChild(titleVerticalDividerImage);
		titleImageDiv.appendChild(titleFoldImage);
		
		titleBar.appendChild(titleTextDiv);
		titleBar.appendChild(titleImageDiv);
		
		//中间部分
		var middleContentDiv = document.createElement("div");
		middleContentDiv.className = "css_middleContentDiv";
		middleContentDiv.id = "middleContentDiv";
		//没有违章信息
		var noResultSmileImg = document.createElement("img");
		noResultSmileImg.className = "css_noResultSmileImg";
		noResultSmileImg.src = vehicle_violation_smile_face;
		
		var noResultStatementDiv = document.createElement("div");
		noResultStatementDiv.className = "css_noResultStatementDiv";
		noResultStatementDiv.innerText = "您的车辆没有违章信息";
		
		//违章状态--未处理违章
		var vehicle_violation_status = document.createElement("div");
		vehicle_violation_status.className = "css_vehicle_violation_status";
		vehicle_violation_status.innerText = "未处理违章";
		//违章条目集合
		var vehicle_violation_lists_div = document.createElement("div");
		vehicle_violation_lists_div.className = "css_vehicle_violation_lists_div";
		//违章条目
		if(violationListLen < violation_item_show){
			violation_item_show = violationListLen;
		}
		for ( var i = 0; i < violation_item_show; i++) {
			var item = createViolationItem(i,
					vehicleResultInfo.violationItems[i].violationTime,
					vehicleResultInfo.violationItems[i].violationPlace,
					vehicleResultInfo.violationItems[i].violationCause);
			vehicle_violation_lists_div.appendChild(item);
		}


		
		if(violationListLen == 0){
			middleContentDiv.appendChild(noResultSmileImg);
			middleContentDiv.appendChild(noResultStatementDiv);
		}else{
			middleContentDiv.appendChild(vehicle_violation_status);
			middleContentDiv.appendChild(vehicle_violation_lists_div);
		}
		
		if(violationListLen > 2){
			var moreDividerImg = document.createElement("img");
			moreDividerImg.src = vehicle_horizontal_divider_under_query_button;
			moreDividerImg.className = "css_moreDividerImg";
			
			//查看更多
			var showMoreDiv = document.createElement("div");
			showMoreDiv.style.display = "inline-block";
			showMoreDiv.className = "css_vehicle_violation_information_showMore_div";
			showMoreDiv.id = "vehicle_violation_information_showMore";
			//查看更多文字
			var showMoreTextDiv = document.createElement("div");
			showMoreTextDiv.style.display = "inline-block";
			showMoreTextDiv.className = "css_vehicle_violation_information_showMoreText_div";
			showMoreTextDiv.innerText = "查看更多";
			//查看更多箭头
			var showMoreImage = document.createElement("img");
			showMoreImage.style.display = "inline-block";
			showMoreImage.className = "css_vehicle_violation_information_showMoreImage_image";
			showMoreImage.src = dialog_goto_right_icon;
			
			showMoreDiv.appendChild(showMoreTextDiv);
			showMoreDiv.appendChild(showMoreImage);
			showMoreDiv.setAttribute("ontouchstart", "touchstart('vehicle_violation_information_showMore')");
			showMoreDiv.setAttribute("ontouchmove", "touchmove('vehicle_violation_information_showMore')");
			showMoreDiv.setAttribute("ontouchend", "touchend('vehicle_violation_information_showMore')");
			middleContentDiv.appendChild(moreDividerImg);
			middleContentDiv.appendChild(showMoreDiv);
		}
		
		var menuBlock = document.createElement("div");
	    menuBlock.className = "css_driver_credit_menu_block";
	    var otherDriver = document.createElement("div");
	    otherDriver.className = "";
	    otherDriver.innerText = "查询其他车辆";
	    var menuDivider = document.createElement("div");
	    menuDivider.className = "css_driver_credit_menu_divider";
	    var vehicleViolationQuery = document.createElement("div");
	    vehicleViolationQuery.className = "";
	    vehicleViolationQuery.innerText = "驾驶员积分查询";
	
	    var menuContent = document.createElement("div");
	    menuContent.className = "css_driver_credit_menu_content";
	
	    menuContent.appendChild(otherDriver);
	    menuContent.appendChild(menuDivider);
	    menuContent.appendChild(vehicleViolationQuery);
	
	    menuBlock.appendChild(menuContent);
	    middleContentDiv.appendChild(menuBlock);
		
		innerdiv.appendChild(titleBar);
		innerdiv.appendChild(middleContentDiv);
		
		container.appendChild(bg_canvas);
		container.appendChild(innerdiv);

		document.body.appendChild(container);
		
		
		
		oldViolationView = container;
		currentCanDeleteView = container;
		
		// 背景层的高度
		var canvasHeight = innerdiv.clientHeight;
		bg_canvas.setAttribute("height", canvasHeight + "px");
		console.log("canvasHeight:" + canvasHeight);
	
		// 设背景图片
		draw(bg_canvas, dialogmode_contact_bg, dialog_view_bg_coordinates);
		if(violation_item_show == 1){
			var ItemConDiv = document.getElementById("violationItemContentDiv0");
			var canvasHeight2 = ItemConDiv.clientHeight;
			var ItemBg = document.getElementById("violationItemBgCanvas0");
			ItemBg.setAttribute("height", canvasHeight2 + "px");
			
			// 违章条目的背景图片
			draw(ItemBg, vehicle_violation_item_show_bg,
					vehicle_violation_item_show_bg_coordinates);
		}else if(violation_item_show == 2){
			var ItemConDiv = document.getElementById("violationItemContentDiv0");
			var canvasHeight2 = ItemConDiv.clientHeight;
			var ItemBg = document.getElementById("violationItemBgCanvas0");
			ItemBg.setAttribute("height", canvasHeight2 + "px");
			
			// 违章条目的背景图片
			draw(ItemBg, vehicle_violation_item_show_bg,
					vehicle_violation_item_show_bg_coordinates);
					
			var ItemConDiv2 = document.getElementById("violationItemContentDiv1");
			var canvasHeight3 = ItemConDiv2.clientHeight;
			var ItemBg2 = document.getElementById("violationItemBgCanvas1");
			ItemBg2.setAttribute("height", canvasHeight3 + "px");
			
			// 违章条目的背景图片
			draw(ItemBg2, vehicle_violation_item_show_bg,
					vehicle_violation_item_show_bg_coordinates);
		}
		
		
		var isMove = false;
		var isMenuBlockShowing = false;
	    titleFoldImage.addEventListener("touchstart",function(){
	    	isMove = false;
	    	event.stopPropagation();
	    	titleFoldImage.src = vehicle_query_menu_fold_state_pressed_img;
	    },false);
	    titleFoldImage.addEventListener("touchmove",function(){
	    	event.stopPropagation();
	    	isMove = true;
	    	titleFoldImage.src = vehicle_query_menu_fold_state_normal_img;
	    },false);
	    titleFoldImage.addEventListener("touchend",function(){
	    	event.stopPropagation();
	    	titleFoldImage.src = vehicle_query_menu_fold_state_normal_img;
	    	if(!isMove){
	    		console.log("DriverPoint result menu is touched");
	    		if(isMenuBlockShowing){
		    		menuBlock.style.display = "none";
		    		isMenuBlockShowing = false;
	    		}else{
	    			menuBlock.style.display = "block";
	    			isMenuBlockShowing = true;
	    		}
	    	}
	    	forceRefreshScreen();
	    	isMove = false;
	    },false);
		
		menuBlock.addEventListener("touchstart",function(){
	    	isMove = false;
	    	if(event.target==menuBlock){
	    		menuBlock.style.display = "none";
	    		isMenuBlockShowing = false;
	    		forceRefreshScreen();
	    	}else if(event.target==otherDriver || event.target==vehicleViolationQuery){
	    		event.stopPropagation();
	    		event.target.style.color = "#47b1f9";
	    	}
	    });
	    menuBlock.addEventListener("touchmove",function(){
	    	event.stopPropagation();
	    	isMove = true;
	    	if(event.target==otherDriver || event.target==vehicleViolationQuery){
		    	event.target.style.color = "white";
	    	}
	    });
	    menuBlock.addEventListener("touchend",function(){
	    	event.stopPropagation();
	    	if(!isMove){
	    		if(event.target==otherDriver){
			    	event.target.style.color = "white";
			    	 menuBlock.style.display = "none";
                	 isMenuBlockShowing = false;
                	 //查询其他车辆
                	 exec(violationTaskHandler, 'searchOtherMotor', []);
		    	}else if(event.target==vehicleViolationQuery){
		    		event.target.style.color = "white";
		    		 menuBlock.style.display = "none";
                	 isMenuBlockShowing = false;
                	 //查询驾驶员积分
                	 exec(violationTaskHandler, 'searchDriverPoint', []);
		    	}
	    	}
	    	forceRefreshScreen();
	    	isMove = false;
	    });
		
		return container;
	}
	
	var istouchmove = false;// 点击是否触发touchmove
	touchstart = function(id) {
		var clickElement = document.getElementById(id);
		if(id == "vehicle_violation_information_title_RemindImage"){
			 
		}else if(id == "vehicle_violation_information_showMore"){
			clickElement.style.background = "url('" + list_item_background_pressed + "')";
		}
		
		moveOverCheck.start(event);
	};
	
	touchmove = function(id) {
		var clickElement = document.getElementById(id);
		if(id == "vehicle_violation_information_title_RemindImage"){
			 
		}else if(id == "vehicle_violation_information_showMore"){
			clickElement.style.background = "";
		}
	
		if (moveOverCheck.check(event)) {
			istouchmove = true;
		}
	};
	
	touchend = function(id) {
		var clickElement = document.getElementById(id);
		
		if (istouchmove == true) {
			if(id == "vehicle_violation_information_title_RemindImage"){
				 
			}else if(id == "vehicle_violation_information_showMore"){
				clickElement.style.background = "";
			}
			istouchmove = false;
		} else {
			if(id == "vehicle_violation_information_title_RemindImage"){
				if(isViolationRemindNotice){
					clickElement.src = vehicle_remind_closed;
					isViolationRemindNotice = false;
					exec(violationTaskHandler, 'openVehicleNotice', [ isViolationRemindNotice ]);
					
				}else{
					clickElement.src = vehicle_remind_open;
					isViolationRemindNotice = true;
					exec(violationTaskHandler, 'openVehicleNotice', [ isViolationRemindNotice ]);
				}
				
			}else if(id == "vehicle_violation_information_showMore"){
				clickElement.style.background = "";
				exec(violationTaskHandler, 'showMore', []);
			}
		}
	};
	
	function createViolationItem(id,time,place,cause){
		var violationItemContainer = document.createElement("div");
		violationItemContainer.className = "css_violation_item_container_div";
	
		// 违章条目背景层
		var violationItemBgCanvas = createBgCanvas(dialog_violation_item_canvas_width);
		violationItemBgCanvas.className = "css_dialog_absolute_bg";
		violationItemBgCanvas.id = "violationItemBgCanvas" + id;
		
		var violationItemContentDiv = document.createElement("div");
		violationItemContentDiv.className = "css_violation_item_content_div";
		violationItemContentDiv.id = "violationItemContentDiv" + id;
		
		var violationTimeDiv = createViolationConcreteInforItem("违章时间：", time);
		var violationPlaceDiv = createViolationConcreteInforItem("违章地点：", place);
		var violationCauseDiv = createViolationConcreteInforItem("违章原因：", cause);
		
		violationItemContentDiv.appendChild(violationTimeDiv);
		violationItemContentDiv.appendChild(violationPlaceDiv);
		violationItemContentDiv.appendChild(violationCauseDiv);
		
		violationItemContainer.appendChild(violationItemBgCanvas);
		violationItemContainer.appendChild(violationItemContentDiv);
				
		return violationItemContainer;
	}
	
	function createViolationConcreteInforItem (keyword,content) {
		var violationConcreteInforContainerDiv = document.createElement("div");
		if (keyword == "违章原因：") {
			violationConcreteInforContainerDiv.className = "css_violation_concrete_info_container_cause_div";
		}else{
			violationConcreteInforContainerDiv.className = "css_violation_concrete_info_containerDiv";
		}
		
		var violationKeywordDiv = document.createElement("div");
		violationKeywordDiv.className = "css_violation_keyword_div";
		violationKeywordDiv.innerText = keyword;
		
		var violationContentDiv = document.createElement("div");
		violationContentDiv.className = "css_violation_content_div";
		violationContentDiv.innerText = content;
		
		violationConcreteInforContainerDiv.appendChild(violationKeywordDiv);
		violationConcreteInforContainerDiv.appendChild(violationContentDiv);
		
		return violationConcreteInforContainerDiv;
	}
	
	
	
	window.vehicleViolationResultView = window.vehicleViolationResultView || {};
	
	
	return createVehicleInformationView;
});
