/**
 * 音乐视图
 * 
 * @author mdhuang
 * @author modified by ppfeng 2013-3-25
 * 
 */
define(function(){
function showWeather(weatherInfo) {
	return createWeatherView(weatherInfo);
}
/**
 * 创建未来天气
 * 
 * @param futureWeather
 *            未来天气信息，经过java处理的json数据
 */
function createFutureWeatherItem(futureWeather) {
	var weatherItem = document.createElement("div");
	weatherItem.className = "css_dialog_weather_future_item";
	if (futureWeather.isTarget === true) {
		weatherItem.className = weatherItem.className
				+ " css_dialog_weather_target_future_item";
	}
	var weekday = document.createElement("div");
	weekday.className = "css_dialog_weather_future_item_week_text";
	weekday.innerText = futureWeather.weekTv;

	var futureImg = document.createElement("img");
	futureImg.className = "css_dialog_weather_futureImg";
	futureImg.src = futureWeather.image;

	var tempArea = document.createElement("div");
	tempArea.className = "css_weather_future_tempArea";

	var lowTemp = document.createElement("div");
	lowTemp.innerText = futureWeather.lowTemp + "°";

	var weather_tilt_divider_img = document.createElement("img");
	weather_tilt_divider_img.className = "css_weather_tilt_divider";
	if (futureWeather.isTarget === true) {
		weather_tilt_divider_img.src = weather_tilt_divider_target;
	} else {
		weather_tilt_divider_img.src = weather_tilt_divider;
	}

	var highTemp = document.createElement("div");
	highTemp.className = "css_weather_future_highTemp";
	highTemp.innerText = futureWeather.highTemp + "°";

	tempArea.appendChild(lowTemp);
	tempArea.appendChild(weather_tilt_divider_img);
	tempArea.appendChild(highTemp);

	var status = document.createElement("div");
	status.className = "css_dialog_weather_future_item_condition_text";
	status.innerText = futureWeather.description;

	weatherItem.appendChild(weekday);
	weatherItem.appendChild(futureImg);
	weatherItem.appendChild(tempArea);
	weatherItem.appendChild(status);

	return weatherItem;
}

function createWeatherView(weatherInfo) {
	var outDiv = createOutDiv();
	if (enableAnimation && isChangingSkin == false) {
		outDiv.className += " css_dialog_opacity_animation";
	}

	var dialog_weather_inner_div = document.createElement("div");
	dialog_weather_inner_div.className = "css_dialog_weather_inner_div";

	// 天气上半区主容器
	var top_div = document.createElement("div");
	top_div.className = "css_dialog_weather_top_div";

	// 天气上半区主体内容div
	var top_main_div = document.createElement("div");
	top_main_div.className = "css_dialog_weather_top_main_div";

	// top主体内容区域上部分
	var top_main_top_div = document.createElement("div");
	top_main_top_div.className = "css_dialog_weather_top_main_top_div";

	// top主体内容区域上部分左边区域
	var top_main_top_left_div = document.createElement("div");
	top_main_top_left_div.className = "css_dialog_weather_top_main_top_left_div";

	var target_day = document.createElement("div");
	target_day.className = "css_weather_target_day";
	target_day.innerText = weatherInfo.target_day;

	// 温度显示区域
	var target_tempArea = document.createElement("div");
	target_tempArea.className = "css_weather_target_tempArea";
	if (weatherInfo.target_temperature == undefined
			|| weatherInfo.target_temperature == ""
			|| weatherInfo.target_temperature == null) {
		// 无实时温度
		var target_lowTemp_highTemp = document.createElement("div");
		target_lowTemp_highTemp.className = "css_weather_target_lowTemp_highTemp2";

		var target_lowTemp = document.createElement("label");
		target_lowTemp.innerText = weatherInfo.target_lowTemp + "°";

		var target_temperature_biasLine = document.createElement("label");
		target_temperature_biasLine.className = "css_weather_target_temperature_biasLine";
		target_temperature_biasLine.innerText = "/";

		var target_highTemp = document.createElement("label");
		target_highTemp.innerText = weatherInfo.target_highTemp + "°";

		target_lowTemp_highTemp.appendChild(target_lowTemp);
		target_lowTemp_highTemp.appendChild(target_temperature_biasLine);
		target_lowTemp_highTemp.appendChild(target_highTemp);

		target_tempArea.appendChild(target_lowTemp_highTemp);
	} else {
		// 有实时温度
		var target_temperature = document.createElement("label");
		target_temperature.className = "css_weather_target_temperature";
		target_temperature.innerText = weatherInfo.target_temperature + "°";

		var target_temperature_symbol = document.createElement("label");
		target_temperature_symbol.className = "css_weather_target_temperature_symbol";
		target_temperature_symbol.innerText = "c";

		var target_lowTemp_highTemp = document.createElement("div");
		target_lowTemp_highTemp.className = "css_weather_target_lowTemp_highTemp";

		var target_lowTemp = document.createElement("div");
		target_lowTemp.innerText = weatherInfo.target_lowTemp + "°";

		var target_highTemp = document.createElement("div");
		target_highTemp.innerText = weatherInfo.target_highTemp + "°";

		target_lowTemp_highTemp.appendChild(target_lowTemp);
		target_lowTemp_highTemp.appendChild(target_highTemp);

		target_tempArea.appendChild(target_temperature);
		target_tempArea.appendChild(target_temperature_symbol);
		target_tempArea.appendChild(target_lowTemp_highTemp);
	}

	var target_description = document.createElement("div");
	target_description.className = "css_weather_target_description";
	target_description.innerText = weatherInfo.target_description;

	top_main_top_left_div.appendChild(target_day);
	top_main_top_left_div.appendChild(target_tempArea);
	top_main_top_left_div.appendChild(target_description);

	// top主体内容区域上部分右边区域
	var top_main_top_right_div = document.createElement("div");
	top_main_top_right_div.className = "css_dialog_weather_top_main_top_right_div";

	var target_image = document.createElement("img");
	target_image.className = "css_weather_target_image";
	target_image.src = weatherInfo.target_image;

	top_main_top_right_div.appendChild(target_image);

	top_main_top_div.appendChild(top_main_top_left_div);
	top_main_top_div.appendChild(top_main_top_right_div);

	// top主体内容区域下部分
	var top_main_bottom_div = document.createElement("div");
	top_main_bottom_div.className = "css_dialog_weather_top_main_bottom_div";

	var city = document.createElement("label");
	city.innerText = weatherInfo.city;

	var target_wind_humidity_area = document.createElement("div");
	target_wind_humidity_area.className = "css_weather_target_wind_humidity_area";

	var target_wind_image = document.createElement("img");
	target_wind_image.className = "css_weather_target_wind_image";
	target_wind_image.src = weather_wind;

	var target_wind = document.createElement("label");
	target_wind.innerText = weatherInfo.target_wind;

	target_wind_humidity_area.appendChild(target_wind_image);
	target_wind_humidity_area.appendChild(target_wind);

	if (weatherInfo.target_humidity != undefined
			&& weatherInfo.target_humidity != null
			&& weatherInfo.target_humidity != "") {
		// 湿度
		var target_humidity_image = document.createElement("img");
		target_humidity_image.className = "css_weather_target_humidity_image";
		target_humidity_image.src = weather_humidity;

		var target_humidity = document.createElement("label");
		target_humidity.innerText = weatherInfo.target_humidity;

		target_wind_humidity_area.appendChild(target_humidity_image);
		target_wind_humidity_area.appendChild(target_humidity);
	}

	top_main_bottom_div.appendChild(city);
	top_main_bottom_div.appendChild(target_wind_humidity_area);

	top_main_div.appendChild(top_main_top_div);
	top_main_div.appendChild(top_main_bottom_div);

	top_div.appendChild(top_main_div);

	// 天气下半区主容器
	var bottom_div = document.createElement("div");

	var dialog_future_weathers_panel = document.createElement("div");
	dialog_future_weathers_panel.className = "css_dialog_future_weathers_panel";

	var weathers = weatherInfo.weathers;
	var length = weathers.length;
	for ( var i = 0; i < length; i++) {
		var futureItem = createFutureWeatherItem(weathers[i]);
		var future_weather_divider = null;
		// 分割线
		if (i < length - 1) {
			future_weather_divider = document.createElement("img");
			future_weather_divider.className = "css_weather_future_item_divier";
			future_weather_divider.src = weather_divider_vertical;
		}

		// 根据个数平均分配宽度
		futureItem.style.width = (100 / length) + "%";
		dialog_future_weathers_panel.appendChild(futureItem);
		if (future_weather_divider != null) {
			dialog_future_weathers_panel.appendChild(future_weather_divider);
		}
	}

	var footer = document.createElement("div");
	footer.className = "css_dialog_weather_footer";

	var updateTimeDiv = document.createElement("div");
	updateTimeDiv.innerText = "发布时间：" + weatherInfo.updateTime;
	updateTimeDiv.className = "css_dialog_weather_updateTime";

	var sharePlayDiv = createSharePlayView(weatherInfo.taskHandler, false, 1);
	sharePlayDiv.className = "css_dialog_weather_sharePlayDiv";

	// 给分享、播报图片添加样式
	var childs = sharePlayDiv.children;
	childs[1].className = childs[1].className
			+ " css_dialog_weather_sharePlay_img";
	childs[2].className = childs[2].className
			+ " css_dialog_weather_sharePlay_img";

	footer.appendChild(updateTimeDiv);
	footer.appendChild(sharePlayDiv);

	dialog_future_weathers_panel.appendChild(footer);

	var dialog_weather_canvas = createBgCanvas(dialog_box_canvas_width);
	dialog_weather_canvas.className = "css_dialog_weather_canvas";

	bottom_div.appendChild(dialog_weather_canvas);
	bottom_div.appendChild(dialog_future_weathers_panel);

	dialog_weather_inner_div.appendChild(top_div);
	dialog_weather_inner_div.appendChild(bottom_div);

	outDiv.appendChild(dialog_weather_inner_div);

	document.body.appendChild(outDiv);

	if (weatherInfo.showProgressBar && isChangingSkin == false) {
		showProgressBar(weatherInfo.taskHandler);
	}

	// 内容高度+4像素的阴影
	var canvasHeight = bottom_div.clientHeight + 4;
	dialog_weather_canvas.setAttribute("height", canvasHeight + "px");
	draw(dialog_weather_canvas, weather_bottom_panel_bg_img,
			weather_bottom_panel_bg_coordinates);

	// 使用自定义scrolltouch事件，控制在滑动时点击是否生效；
	enableScrollTouch(outDiv, 15);
	outDiv.addEventListener("scrolltouch", function() {
		var taskHandler = weatherInfo.taskHandler;
		exec(taskHandler, 'launcherResult', []);
	}, false);
	showOpacityAnimation(outDiv, 150);

	outDiv.refresh = function() {
		sharePlayDiv.refresh();
	};

	return outDiv;
}
	
	return createWeatherView;
});